commit dea0b2a11bffe1877ec10d29279fbb0f635d70e7
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Wed Jan 30 16:58:55 2013 +0100

    Preparations for 3.4.1.
    
    NEWS & VERSION updated for 3.4.1.
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit 31d93f775d39bad00e5fba7a4ddc10c706a18753
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Tue Jan 29 13:22:30 2013 +0100

    logrewrite: Fix the template reference counting
    
    In case of the subst() and set() rewrite statements, when the
    implementation was changed to pass a template to the constructor
    instead of a string, the free() remained in the parser. While that was
    supposed to free a string allocated by the parser, after the change,
    that free'd the template that we had stored in the rewrite struct
    itself.
    
    To correct the issue, both the subst() and set() constructors will ref
    the template, and the parser-side will unref it, instead of free()ing
    it up.
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit 077c669c2dcca7b7323e7a42dcaba94755d3bc23
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sat Jan 26 13:53:22 2013 +0100

    logrewrite: fix rewrite set/subst related segfault
    
    If a set/rewrite operation is referenced from multiple locations, and
    it uses template functions, a segfault has occurred, as the clone
    operation didn't properly propagate the associated configuration object,
    which rendered template->cfg to be NULL, which in turn caused
    template-function lookup code to dereference a NULL pointer.
    
    This was fixed by two dependent changes:
      - always passing the already-compiled LogTemplate to the rewrite
        operations instead of a string constant.
      - reusing the compiled template object in clone()
    
    Since LogTemplate is reused, and the first one contains a proper reference
    to the appropriate configuration object, the NULL deref issue was
    solved too.
    
    Reported-By: Johnson, Chris <chris.johnson3@hp.com>
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit c5775b689720c811905ebf55ee07f16773126215
Author: Gergely Nagy <algernon@madhouse-project.org>
Date:   Tue Jan 22 13:36:53 2013 +0100

    affile: Restore fsync & flush-lines functionality
    
    Back in May, in 101cb379, which moved fsync() from logtransport to
    logproto, a new argument for log_proto_file_writer_new() was
    introduced, but when updating the call sites, the flush_lines and
    fsync arguments were mixed up.
    
    This corrects that, restoring both flush-lines() and fsync()
    functionality for the file destination.
    
    Reported-by: Evan Rempel <erempel@uvic.ca>
    Signed-off-by: Gergely Nagy <algernon@madhouse-project.org>

commit 84330674f51de8cb7e09672e9375f3e1eb342032
Author: Gergely Nagy <algernon@madhouse-project.org>
Date:   Fri Jan 18 17:17:59 2013 +0100

    patterndb: Allow a wider range of characters in a class value
    
    Allow a wider range of characters in a class value. To the already
    existing list, the following were added (both pdb3 and pdb4): "%",
    ":", "@", "+", "!", "^", "/" and "\". This should hopefully cover most
    - if not all - the usual suspects.
    
    Requested-by: Evan Rempel <erempel@uvic.ca>
    Signed-off-by: Gergely Nagy <algernon@madhouse-project.org>

commit 1f2ff45d2a9d084c33df7906fe5266fa38b8fd1d
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Thu Jan 17 14:33:56 2013 +0100

    dbparser: Wrap LogMessage into a PDBInput properly
    
    Instead of creating a local PDBInput structure from within the
    PDB_INPUT_MESSAGE macro, force using an existing variable instead, so
    the code is correctly compiled even with -O3.
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit 533cf59d01986a121a3a2eec02b6a091dabdfacc
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Thu Jan 17 12:40:08 2013 +0100

    Preparations for 3.4.0rc2
    
    NEWS & VERSION updated to 3.4.0rc2.
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit 60a639d5614897c12ea593bea02eb4627b92ea11
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Thu Jan 17 12:19:08 2013 +0100

    dbparser: Implement a template() option for the parser
    
    Similar to the csv-parser(), this patch makes dbparser() accept a
    template() option, that can be used to tell the parser what to parse
    instead of the MESSAGE part (which it does by default).
    
    This allows one to conveniently chain parsers together, assembling one
    parser's output into an input template for another, without the need
    for complicated rewrites:
    
    ,----
    | parser p_step1 {
    |  csv-parser(columns("timestamp", "host", "app", "instance", "session", "message"));
    | };
    |
    | parser p_step2 {
    |  db-parser(file("etc/patterndb.d/step2.xml")
    |            template("${session}: ${message}"));
    | };
    |
    | log {
    |   source(...);
    |   parser(p_step1);
    |   parser(p_step2);
    |   destination(...);
    | };
    `----
    
    This patch makes this config work, so that the db-parser() will
    operate on the given template, instead of $MESSAGE.
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit b6f37d4a8e08d3da5aaf6a9632a6c767183f88f2
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Thu Jan 17 11:24:29 2013 +0100

    dbparser: fix LLADDR parser
    
    The LLADDR parser required that the exact number of components were
    present and got the parts/count values backwards.
    
    Reported-By: Evan Rempel <erempel@uvic.ca>
    Signed-Off-By: Evan Rempel <erempel@uvic.ca>
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit 81850bf2978a07b7be29392bd7402dbb74ec8cfe
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Tue Jan 15 14:55:11 2013 +0100

    lib/ivykis: Update to latest stable-v0.36
    
    To make the syslog-ng make dist tarball usable, we need an embedded
    ivykis version that has a working make dist. To do this, update the
    embedded submodule to the latest commit in stable-v0.36, that fixes
    these issues.
    
    Reported-by: Peter Czanik <czanik@balabit.hu>
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit 0f502771095e999dc362af14a0cdf6c7839b9791
Author: Gergely Nagy <algernon@madhouse-project.org>
Date:   Sat Jan 12 17:54:56 2013 +0100

    dbparser: Make tests work with --with-embedded-crypto
    
    When adding support for --with-embedded-crypto, dbparser/tests were
    overlooked, and they still relied on libsyslog-ng-crypto being
    available. It should've been migrated to CRYPTO_LIBS too, which is
    done now.
    
    Reported-by: Jose Pedro Oliveira <jpo@di.uminho.pt>
    Signed-off-by: Gergely Nagy <algernon@madhouse-project.org>

commit 2b453e1e9164c5a9b290cefa1c8356b2740fa63e
Author: Gergely Nagy <algernon@madhouse-project.org>
Date:   Sat Jan 12 17:39:42 2013 +0100

    afamqp: Really do not build the module if amqp is disabled
    
    Move the module_LTLIBRARIES declaration inside the ENABLE_AMQP, so
    that we don't build an empty shared object when we wanted to disable
    amqp completely instead.
    
    Reported-by: Jose Pedro Oliveira <jpo@di.uminho.pt>
    Signed-off-by: Gergely Nagy <algernon@madhouse-project.org>

commit bd2d4a72d0e97146715c75d625d057e8c37fadc9
Author: Gergely Nagy <algernon@madhouse-project.org>
Date:   Sat Jan 12 12:20:59 2013 +0100

    Follow up on ivykis changes
    
    Between ivykis 0.30 and 0.36 a couple of reorganisations were made,
    which needed followups on the syslog-ng side. These are those
    folloups:
    
     * ivykis/lib and ivykis/modules were merged into ivykis/src
     * there is no top-level libivykis.la, it is under src now
     * ivykis/lib/iv_main.c was split, we'll check for
       ivykis/src/iv_main_posix.c now, as that is 0.36 specific, thus
       enforcing that the bundled ivykis is of appropriate version too.
    
    Signed-off-by: Gergely Nagy <algernon@madhouse-project.org>

commit c4676e47caada1880f24156015bce47f3ca6022f
Author: Gergely Nagy <algernon@madhouse-project.org>
Date:   Fri Jan 11 23:21:03 2013 +0100

    Bump ivykis requirement to 0.36.1
    
    To pull in new platform support, bugfixes, and for a whole lot of
    other reasons, bump the ivykis dependency to 0.36.1, and update the
    submodule to that version aswell.
    
    Signed-off-by: Gergely Nagy <algernon@madhouse-project.org>

commit def6462e90335dd9b8114cc434cdde68784bf703
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Fri Jan 11 12:15:19 2013 +0100

    configure: Properly support disabling AMQP
    
    Tie --disable-amqp and --without-librabbitmq-client together: if
    either is set, disable the other too, and in both cases, clear
    LIBRABBITMQ_SUBDIRS.
    
    This means that disabling AMQP will neither build the module, nor will
    it recurse into modules/afamqp/librabbitmq-client.
    
    Reported-by: Jose Pedro Oliveira <jpo@di.uminho.pt>
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit 4246bcc2f52d11323d574b2f484a03c830db58ce
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Wed Jan 9 11:30:16 2013 +0100

    NEWS: Added 3.4.0beta1 credits
    
    Credits were added to the announcement that went out, but NEWS was not
    updated. Copied the credits over from the mail.
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit b38cf92d209a0b8e002616364c9959ee4b6c8c5f
Author: Gergely Nagy <algernon@madhouse-project.org>
Date:   Fri Jan 4 17:01:58 2013 +0100

    Preparations for 3.4.0rc1
    
    Signed-off-by: Gergely Nagy <algernon@madhouse-project.org>

commit aa86722473ada45e05d7710ffa0737749da3322a
Author: Gergely Nagy <algernon@madhouse-project.org>
Date:   Sat Dec 22 10:51:01 2012 +0100

    Make it possible to link crypto stuff directly into libsyslog-ng
    
    There's been a long desire to be able to link libsyslog-ng-crypto
    directly into libsyslog-ng, if so desired. To accomplish that, we
    introduce a --with-embedded-crypto option to configure, which in turn
    produces a WITH_EMBEDDED_CRYPTO automake conditional.
    
    If that conditional is set, then the sources of libsyslog-ng-crypto
    get appended to the libsyslog-ng sources, and -crypto is not built. In
    the non-embedded case CRYPTO_LIBS will be set to
    ${top_builddir}/lib/libsyslog-ng-crypto.la, otherwise it will be
    empty. All users of the -crypto module (afsocket, dbparser &
    cryptofuns) have been updated to use $(CRYPTO_LIBS) instead of
    hard-coding libsyslog-ng-crypto.la.
    
    Signed-off-by: Gergely Nagy <algernon@madhouse-project.org>

commit 62e62fa4ec7acf3f5fe2f87362bae88fce28e7e2
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Thu Jan 3 18:51:53 2013 +0100

    travis: Simplify the config
    
    We only need one apt-get install line, and no template for the IRC
    notifications, the default is good enough.
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit 1e8f5ffa76c38189006a6e82e38b5cdfa472e90b
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Thu Jan 3 18:48:29 2013 +0100

    configure: Add support for GeoIP without pkg-config
    
    If libgeoip is installed without a pkg-config data file, then fall
    back to GEOIP_LIBS and GEOIP_CFLAGS, if set.
    
    On systems that do not have the pkg-config data file for libgeoip,
    running configure with GEOIP_LIBS and GEOIP_CFLAGS appropriately set,
    along with --with-geoip, will enable the module.
    
    Reported-by: Peter Czanik <czanik@balabit.hu>
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit 6c1f62cea66dc8a04bac60b6085726edfc46f031
Author: Gergely Nagy <algernon@madhouse-project.org>
Date:   Sat Dec 22 11:19:56 2012 +0100

    syslog-ng-ctl: Fix the linking with modern libtool
    
    The Makefile.am for syslog-ng-ctl relied on lib/gsocket.c and
    lib/gsockaddr.c getting compiled to gsocket.lo and gsockaddr.lo,
    respectively. This is not always the case, sometimes the library name
    gets prepended.
    
    To work around this, add the two source files to syslog_ng_ctl_SOURCES
    instead. This way, they'll get compiled again, but the result will
    always work, and not rely on fragile convention.
    
    Signed-off-by: Gergely Nagy <algernon@madhouse-project.org>

commit ce4098682d4794ce6a83a00904bf5978bf9bc121
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Thu Dec 20 15:31:39 2012 +0100

    cfg: Fix cfg_is_config_version_older()
    
    The function was given a configuration in the cfg argument, tested
    that for NULL, but then used the global 'configuration' variable to
    compute the config version.
    
    It is very easily possible that the global configuration is NULL, but
    cfg isn't, which in this case, led to a segmentation fault.
    
    Reported-by: Peter Czanik <czanik@balabit.hu>
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit 1661326fb255504e8e1d55dfa38e4e4c54fce155
Merge: 6181f78 45eaaae
Author: Gergely Nagy <algernon@madhouse-project.org>
Date:   Fri Jan 4 10:08:22 2013 +0100

    Merge branch 'upstream/mirror/3.3' into 'merge-queue/3.4'
    
    Conflicts:
    	lib/Makefile.am
    	lib/plugin.c

commit 45eaaae93a98aaad163b8f6cdb6d5df026d90baf
Author: Gergely Nagy <algernon@madhouse-project.org>
Date:   Sat Dec 22 10:51:01 2012 +0100

    Make it possible to link crypto stuff directly into libsyslog-ng
    
    There's been a long desire to be able to link libsyslog-ng-crypto
    directly into libsyslog-ng, if so desired. To accomplish that, we
    introduce a --with-embedded-crypto option to configure, which in turn
    produces a WITH_EMBEDDED_CRYPTO automake conditional.
    
    If that conditional is set, then the sources of libsyslog-ng-crypto
    get appended to the libsyslog-ng sources, and -crypto is not
    built. All users of the -crypto module (afsocket) have been updated to
    not try and link in libsyslog-ng-crypto if WITH_EMBEDDED_CRYPTO is
    set.
    
    Signed-off-by: Gergely Nagy <algernon@madhouse-project.org>

commit 91a221c29a8c88ded4bbbc7e0c68faa2484bc945
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Thu Jan 3 18:51:53 2013 +0100

    travis: Simplify the config
    
    We don't need a template for the IRC notifications, the default is
    good enough.
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit df6d07e6489e30b4eaa7ca53f444106962f8ac55
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Thu Jan 3 17:32:49 2013 +0100

    afsocket: Update sd-daemon.* to systemd 44's version
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit 519d2111bb957f787ecc0feb45666e0d46eefd22
Author: Juhasz Viktor <jviktor@balabit.hu>
Date:   Tue Nov 15 10:27:09 2011 +0100

    [plugin.c] on AIX 5.2 the G_MODULE_SUFFIX contains "so" and the available modules will be empty
    
    correction is that overwrite this define to "a"
    
    Signed-off-by: Juhasz Viktor <jviktor@balabit.hu>

commit 4244bbf1e95e3c6fecc83d868e9bcece04223ddd
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Thu Dec 20 14:19:55 2012 +0100

    afsocket: Force syslog() destination to use IPv4
    
    The syslog() source already enforces IPv4, the destination should be
    doing the same.
    
    Reported-by: Jan Schaumann <jschauma@netmeister.org>
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit 8d02242c132cccb587ed03e8e3908ca67e244346
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Thu Dec 20 14:06:41 2012 +0100

    cfg-lexer: Support systems without GLOB_NOMAGIC
    
    GLOB_NOMAGIC is a GNU-ism, and not present on all systems syslog-ng
    supports, so for those system, we need a workaround. We can't use
    GLOB_NOCHECK, as that would make us have widly different behaviour in
    some cases (when there really is a pattern in the @include'd filename).
    
    So, on platforms that do not have GLOB_NOMAGIC, we implement the same
    behaviour on our own: if glob() failed with GLOB_NOMATCH, we check if
    the filename is a pattern, and if not, add the pattern to the include
    list as-is, otherwise silently ignore it.
    
    This means that @include "/etc/syslog-ng/conf.d/*.conf" will work on
    these platforms the same way as it does on GNU-enabled ones.
    
    Reported-by: Ben Lentz <blentz@cswg.com>
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit 92c3dd3b35badf1d866961cafb57dee3b5cc8abb
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Thu Dec 20 13:21:00 2012 +0100

    mainloop: #include <iv_event.h>, as we're using it
    
    Reported-by: Ben Lentz <blentz@cswg.com>
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit 6181f78386c01c9bdc94bb1afb9b0ea5ce07b221
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Wed Dec 19 10:49:36 2012 +0100

    tgz2build/rules: disable amqp and rabbitmq from the build
    
    Since my test build environment is Debian etch based, rabbitmq doesn't
    build as it needs a newer Python. Disable it for now.
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 23ae67aa81b1b37572334d31b0c4015314d38049
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Wed Dec 19 10:48:59 2012 +0100

    test_logproto: use the canonical names for utf8 and ucs4
    
    Since our build environments were pruned to the least amount of stuff,
    the aliases for utf-8 are not recognized. Change the character names
    to "utf-8" and "ucs-4", these work without the aliases being available.
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 06a46ba5d4ad9d30b0c30c3b6588212c95ba7448
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Wed Dec 19 10:47:37 2012 +0100

    dbparser: added basicfuncs as a dlpreload module to the unit tests
    
    Since $(context-length) is now being used by the dbparser unit tests,
    and otherwise the unit tests wouldn't be able to run in a non-installed
    environment.
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit e8a68b29131983bf3d0764720774f09d05107d64
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Wed Dec 19 10:46:55 2012 +0100

    configure.in: fixed --with-librabbitmq-client option to match shell variable name
    
    The name of the option was incorrectly given, causing the shell variable
    that contains the command line value to be unset even if the option
    was specified in the configure command line.
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 11b20b28f7586b2bf10c281328f28d93f39e279c
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Fri Dec 14 17:54:39 2012 +0100

    resolve_sockaddr: fixed unsafe use of non-reentrant APIs to resolve IP addresses to names
    
    As it seems the use of the DNS cache hid the fact that we're not thread
    safe when resolving IPs to DNS names. This patch attempts to use
    getnameinfo() API if available that is thread safe and protects
    all other paths with a mutex.
    
    Reported-By: Brian Kroth <bpkroth@gmail.com>
    Tested-By: Gergely Nagy <algernon@balabit.hu>
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 46c1c580f8c11dc842d1ca9bbae073f652dcec7d
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Mon Dec 10 18:25:50 2012 -0800

    ivykis: updated to 0.30.5

commit 33efb59899c5eeda26f97e971c0f9fe9118b720b
Author: Balint Kovacs <blint@blint.hu>
Date:   Mon Dec 10 09:58:12 2012 +0100

    pdbtool: fix a double increment within a loop
    
    When displaying debug-csv information, the loop variable was not
    only incremented in the for statement, but also within the loop, which
    caused an index mismatch when iterating over the dbg_info array
    
    Signed-off-by: Balint Kovacs <blint@blint.hu>

commit b349581c14ac6fa119f847f226d1f7eeb08d89a7
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sat Dec 15 19:04:16 2012 +0100

    csvparser, basicfuncs, cryptofuncs: compile the module first, and then recurse into tests
    
    Fixes build when make check is invoked in a pristine build directory.
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 3bcf7c60a5474e0a68c854ec82e6d3107ff3b60a
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sat Dec 15 12:39:33 2012 +0100

    modules/Makefile.am: move syslogformat to the beginning of the list of compiled modules
    
    Because other modules depending on it would not compile (such as csvparser unit test).
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit f03f2e5c35b5f2b842209bc0837828ce0fe66c72
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sat Dec 15 12:31:15 2012 +0100

    preparations for 3.4.0beta1

commit a1804be6988e911823205c0c5fff5b702852e1f5
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sat Dec 15 12:30:20 2012 +0100

    afsocket: fixed compilation error on FreeBSD with spoof-source enabled
    
    Don't define libnet_t as a typedef as that clashes the definition from
    libnet.h. Use a non-type reference and a forward struct declaration instead.
    
    Reported-by: Peter Czanik <czanik@balabit.hu>
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 2d05ec6625dd1bb76642dc12fc601d9fa2cb86dc
Merge: 770251b 200e554
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sat Dec 15 02:10:45 2012 +0100

    Merge remote-tracking branch '3.3/master'
    
    Conflicts:
    	.travis.yml
    	NEWS
    	VERSION
    	lib/logwriter.c
    	lib/messages.h
    	modules/dbparser/tests/test_patterndb.c
    	scl/system/generate-system-source.sh

commit 770251b2b5488f6dce26706cebba9831a73f6d36
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Fri Dec 14 17:54:39 2012 +0100

    resolve_sockaddr: fixed unsafe use of non-reentrant APIs to resolve IP addresses to names
    
    As it seems the use of the DNS cache hid the fact that we're not thread
    safe when resolving IPs to DNS names. This patch attempts to use
    getnameinfo() API if available that is thread safe and protects
    all other paths with a mutex.
    
    Reported-By: Brian Kroth <bpkroth@gmail.com>
    Tested-By: Gergely Nagy <algernon@balabit.hu>
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit a15b503a9f88d0f1885ef450282354418f12bae7
Author: Balint Kovacs <blint@blint.hu>
Date:   Mon Dec 10 09:58:12 2012 +0100

    pdbtool: fix a double increment within a loop
    
    When displaying debug-csv information, the loop variable was not
    only incremented in the for statement, but also within the loop, which
    caused an index mismatch when iterating over the dbg_info array
    
    Signed-off-by: Balint Kovacs <blint@blint.hu>

commit d4cafb3b3afe014064af6bdc425a0c4560f1440e
Author: Balint Kovacs <blint@blint.hu>
Date:   Mon Dec 10 09:58:11 2012 +0100

    pdbtool: match with supplied message did not perform processing
    
    Under some circumstances pdbtool match did not process the message
    if it was provided on the command line due to a regression introduced
    as part of a LogProto refactoring (2d0fb042)
    
    Signed-off-by: Balint Kovacs <blint@blint.hu>

commit 45599e0e5a31144cea1812b56601738aefae7f0c
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Tue Dec 11 07:54:08 2012 +0100

    syslog-ng.conf: bump version to 3.4

commit 06fe6ea00df758fef6060931eb3f560039a86bf5
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Mon Dec 10 18:25:50 2012 -0800

    ivykis: updated to 0.30.5

commit fded992aa2514cced657006bde189f19ed68b525
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Fri Dec 7 16:23:54 2012 +0100

    afamqp: Include rabbitmq-c/configure.gnu in the tarball
    
    In order to install cleanly with an internal rabbitmq-c, we need that
    library to be compiled in statically, which is what the configure.gnu
    script (installed via autogen.sh from git) enforces.
    
    However, since configure.gnu is not part of rabbitmq-c, its make dist
    will not include it, so its parent must do that. For this reason, and
    similarly to how the same file is handled elsewhere, include
    rabbitmq-c/configure.gnu in the EXTRA_DIST of afamqp/Makefile.am.
    
    Reported-by: Peter Czanik <czanik@balabit.hu>
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit 51d3f00121e4269874d9021e716e519b0f8fe11b
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Fri Dec 7 13:55:32 2012 +0100

    afsocket: Add an ip-protocol() option for the network driver
    
    To make it easy to set up IPv6 sources or destinations, the network()
    driver should have an option to select the IP protocol. This patch
    does just that, in the form of an ip-protocol() option, which allows
    one to select either IPv4 or IPv6.
    
    In the end, this allows us to have a source as follows:
    
    source s_v6_syslog {
      network(port(12345)
              transport(framed)
              ip-protocol(6));
    };
    
    The option is available for both the source and destination version of
    network().
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit d2df2e1eadffaff884ed95fb03372367a794bdff
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Fri Dec 7 12:48:21 2012 +0100

    syslogformat: Include all necessary files in the dist tarball
    
    A few files were missing from the make dist tarball, leaing to
    distcheck and building from source failing. This patch fixes the
    Makefile to include these previously missing files.
    
    Reported-by: Peter Czanik <czanik@balabit.hu>
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit 200e5546d0c3209b4eaf47ba6fc6b73d269a3cf4
Author: Balint Kovacs <blint@blint.hu>
Date:   Mon Dec 3 12:43:19 2012 +0100

    fix a missing XML semantic check in PDBLoader
    
    pattnerndb has failed to check if we are within a rule when trying to
    add tags and values, so a patterndb xml containing these elements
    outside of a rule element would cause syslog-ng (and pdbtool) to
    segfault
    
    Signed-off-by: Balint Kovacs <blint@blint.hu>
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit eec05cc33635df0380e748dedc70b95dddaba374
Author: Balint Kovacs <blint@blint.hu>
Date:   Mon Dec 3 12:43:19 2012 +0100

    fix a missing XML semantic check in PDBLoader
    
    pattnerndb has failed to check if we are within a rule when trying to
    add tags and values, so a patterndb xml containing these elements
    outside of a rule element would cause syslog-ng (and pdbtool) to
    segfault
    
    Signed-off-by: Balint Kovacs <blint@blint.hu>
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit 8a38902fe07d46c4fefbae029572f22bb840f10b
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Thu Nov 22 15:35:28 2012 +0100

    reader/writer start-watches code simplification
    
    Rearrange and simplify the pollable_state logic, so that it is easier
    to follow.
    
    Signed-off-by: Viktor Juhasz <jviktor@balabit.hu>
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit 3475182cc00d5944c957aa6c991df587ff26df40
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Thu Nov 22 15:30:16 2012 +0100

    logreader: Error out when follow-freq is 0, and fd is not pollable
    
    In case an FD is not pollable, but follow-freq is 0, error out,
    instead of silently not doing anything.
    
    This is accomplished by breaking out the if (self->pollable_state ==
    0) branch out of the big if/else chain, and making it a mandatory step
    in the end.
    
    Signed-off-by: Viktor Juhasz <jviktor@balabit.hu>
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit 3095faa2d585624fac3041bcbadd7872f1d4d789
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Wed Nov 21 11:33:38 2012 +0100

    dbparser: Make the context length available to action conditions
    
    It was quite unintuitive to determine if a previous message exists in
    the corellation context as the basis of the decision whether an action
    should be run or not. This patch implements a $(context-length)
    template function that returns the number of messages within a
    corellation context, and can be used in the condition of an action.
    
    This way it is easy to determine if a context contains sufficient
    amount of messages for the event to be complete and run a different
    action if it is not, e.g. if 2 messages are needed for an event, this
    should emit an event message if there are enough messages and an error
    message if not.
    
     <actions>
      <action condition='"$(context-length)" >= "2"'>
       <message>
        <values>
         <value name="PROGRAM">event</value>
         <value name="MESSAGE">Hello event!</value>
        </values>
       </message>
      </action>
      <action condition='"$(context-length)" < "2"'>
       <message>
        <values>
         <value name="PROGRAM">error</value>
         <value name="MESSAGE">Hello error!</value>
        </values>
       </message>
      </action>
     </actions>
    
    (Based on a patch from Balint Kovacs <blint@blint.hu>, and
    suggestsions from Balazs Scheidler <bazsi@balabit.hu>)
    
    Requested-by: Balint Kovacs <blint@blint.hu>
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit e97df0f0aaef3973b35e01820b15e499dd229b28
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Fri Nov 9 14:13:01 2012 +0100

    system-source: Use follow-freq(1) on FreeBSD prior to 9.1
    
    FreeBSD prior to 9.1 does not have a kqueue-pollable /dev/klog, so
    syslog-ng would fall back to using timers, except that follow-freq()
    is explicitly set to zero, also diabling timer-based polling. This has
    the effect of making syslog-ng not read from /dev/klog at all.
    
    To work around the issue, on FreeBSD prior to 9.1, use follow-freq(1)
    for /dev/klog when using the system() source.
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit 757d22109ffa7df4f3a23159e8fa467746c26f78
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sun Dec 2 10:03:45 2012 +0100

    afsocket: handle unknown transport errors during initialization
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 9fed2310546e17e6074c105e248c677a4f41fdb1
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sun Dec 2 09:53:50 2012 +0100

    func_test: added tests for network() source
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 5a80e09ca25efdbf3f3599a58d660412950ea4ef
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sun Dec 2 09:51:56 2012 +0100

    network(): added new network source and destination drivers
    
    This patch implements both source and destination drivers called
    "network()", which encapsulates the previous tcp() and udp() drivers. The
    advantage of using network() over tcp/udp is that it separates the message
    format from the transport being used.
    
    The transport can be specified using the transport() parameter (akin to
    syslog()), the newly introduced plugin support for pluggable transport
    mechanisms become available this way.
    
    The message format defaults to traditional BSD syslog, but can
    completely be customized using the template() option.
    
    Here's a sample network source:
    
    source s_network {
    	network(port(2000) transport(udp));
    };
    
    Destination:
    
    destination d_network {
    	network("hostname" port(2000) transport(framed));
    };
    
    As you can see it is possible to use the new-style RFC5425 framing with
    whatever (e.g. BSD or custom template formatted) message contents.
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 5275d8bf337d4ef741278b7c727a0a15a91135c2
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sat Dec 1 20:44:22 2012 +0100

    logproto-builtins: register the client side for "dgram"
    
    We don't do anything special on the LogProto level when dgram client is
    being used, however for the sake of symmetry and to make the logic
    that determines which plugin to use, also register that, for the time being
    it is equivalent to LogProtoTextClient.
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 8cc535f77b0511497dfdaa6ada80ef2278ab4ee9
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Tue Nov 20 20:59:27 2012 +0100

    network(): added grammar skeleton and plugin registration
    
    This patch lays the foundation for the upcoming network source/destination.
    It currently only introduces the rules in the grammar, registers the
    network keyword and the network plugins.
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 3fc709c9fa76d8184506481b930521e065978695
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sat Dec 1 20:28:23 2012 +0100

    afsocket: move the transport() option of the syslog driver into a separate rule in the grammar
    
    In order to make it usable from the upcoming network() source destination,
    dedicate a new rule to KW_TRANSPORT rules.
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit f26b7148f54212246e0d8e7d281b4e07af97b06f
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Thu Nov 29 19:47:15 2012 +0100

    afsocket: get rid of the "flags" member for AFSocket{Source,Dest}Driver
    
    This patch removes the ugly "flags" member and its complicated initialization
    in constructors, rather the code now uses booleans which is easier
    to follow.
    
    Also separate constructors were added for the syslog() driver case, in
    addition to tcp() and udp().
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 4163872d268e96273ba9d1f391e12a1932cc51a8
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Thu Nov 22 15:35:28 2012 +0100

    reader/writer start-watches code simplification
    
    Rearrange and simplify the pollable_state logic, so that it is easier
    to follow.
    
    Signed-off-by: Viktor Juhasz <jviktor@balabit.hu>
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit e894b94610e6e441bb5adb18663adc6816be7c7a
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Thu Nov 22 15:30:16 2012 +0100

    logreader: Error out when follow-freq is 0, and fd is not pollable
    
    In case an FD is not pollable, but follow-freq is 0, error out,
    instead of silently not doing anything.
    
    This is accomplished by breaking out the if (self->pollable_state ==
    0) branch out of the big if/else chain, and making it a mandatory step
    in the end.
    
    Signed-off-by: Viktor Juhasz <jviktor@balabit.hu>
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit 1edffccfe83850dc134219a9110078d13508e78a
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Tue Nov 20 20:55:10 2012 +0100

    afsocket-grammar: split {source,dest}_afsocket
    
    Instead of using an indirect rule for unix/inet sources destinations,
    propagate them to the top-level, just like syslog (and the future
    network source/destination)
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit cb07caffcd57170ecf77eae31c35aade6d4a05b2
Author: Balint Kovacs <blint@blint.hu>
Date:   Fri Nov 9 15:28:20 2012 +0100

    dbparser: support inheriting properties in a corellation action
    
    This patch implements an inherit-properties attribute for message type
    actions is patterndb correlation. In case this is set to TRUE, the
    triggering log message is cloned and all name-value pairs (including
    tags) are automagically copied to the emitted message. The values set
    in the values XML subtree overwrite the original values. In case it is
    set to FALSE or unspecified, a new message is generated and only the
    values set manually are added to it.
    
       <actions>
         <action>
           <message inherit-properties='TRUE'>
             <values>
               <value name="PROGRAM">my-program-name</value>
               <value name="MSG">Hello new message!</value>
               <value name="contextid">${session-id}@2</value>
             </values>
           </message>
         </action>
       </actions>
    
    Signed-off-by: Balint Kovacs <blint@blint.hu>
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit 1050a5b0371f7d6a1d287b6b742b4811b11e60ac
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Thu Nov 15 12:53:23 2012 +0100

    Use value-pairs transformations in mongodb and format-json
    
    For both mongodb and json, leading dots are not allowed on key
    names. The mongodb destination had a guard against this, and replaced
    leading dots with an underscore, format-json did not.
    
    With this patch, both will forcibly add a value-pair key
    transformation that replaces the first leading dot. This covers the
    most common cases, but makes the mongodb destination vulnerable to
    keys like ".foo..bar". However, it is not the purpose of the driver to
    guard against corner cases.
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit cacf855fe38cbd3a549f7b94ab99c0e396ec2247
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Thu Nov 15 12:30:26 2012 +0100

    value-pairs: Support rekey outside of key()
    
    There are situations where one would like to apply transformations to
    keys selected by the scope, without having to re-list the selected
    keys in the config (such as default transformations for mongodb and
    format-json). For this to work, we need to be able to use rekey
    outside of key(), so that the pattern given to rekey will not be
    explicitly added to the set.
    
    In other words, this allows us to write transformations that work on
    the already assembled set, without adding new elements to it.
    
    For the command-line variant, this is done with the new --rekey
    option, which is exactly like --key, except it does not add the
    pattern to the set.
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit 77e1eaf9e00acd10d949a397f7ccaf20430c9cb8
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Sat Nov 10 13:09:37 2012 +0100

    Improved silent-rules support
    
    This adds a few harmless things to the lex/yacc and doc building
    rules, so their output will be shortened when using V=0. The variables
    have no effect when using an automake that does not support
    silent-rules, so it's completely backwards compatible.
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit 9eb524ced170d4cf5b7189bf06cf99d6e43a1717
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Sat Nov 10 11:41:15 2012 +0100

    ivykis: Update to the latest 0.30 stable
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit 403f91b28808346db72ec3d30939d1eec9222935
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Fri Nov 9 10:35:58 2012 +0100

    plugin: Fix a minor memory leak in plugin_list_modules()
    
    When listing modules, the configuration was not used anywhere: it was
    just allocated and never free'd.
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit bf57502535110061cbb2a2a4d24b5968dc00252f
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Fri Nov 9 10:24:42 2012 +0100

    Silence a few warnings
    
    A couple of files were using strlen(), memcmp() and similar things
    from <string.h> without explicitly including it, and the gcc on
    FreeBSD9 complained about that - lets silence that by explicitly
    including said header. While there, also add other missing include
    statements.
    
    Furthermore, a few mismatched prototype warnings, unused variables and
    other minor things were cleaned up aswell.
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit ae94298f37d824f28394a11259310dd5354c9303
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Fri Nov 9 10:11:57 2012 +0100

    configure: Support silent rules, if available
    
    Building with silent rules enabled has the advantage of producing
    shorter output, and making warnings and other anomalies stand out
    better. Building verbosely is still the default, but silent rules can
    now be turned on by passing V=0 to make.
    
    Silent rules support is only available if using a recent enough
    automake to build the makefiles.
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit 82b09cc75d8d844668eb7ca8e8215c4276bcb54a
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Fri Oct 19 17:47:40 2012 +0200

    tfgeoip: $(geoip) template function
    
    This implements a $(geoip) template function using libgeoip, based on
    a patch from Csaba Major. The function can be used to look up the
    2-letter country code of any IPv4 address or host passed to the function.
    
    Currently only the 2-letter codes are supported, and only from the
    default database, and only for IPv4 addresses (or hosts). Adding
    further functionality can be done on demand, however.
    
    Signed-off-by: Csaba Major <csaba.major@balabit.com>
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit 670be638bf89e816f03aa889b5198ccd38b83260
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Thu Nov 8 14:49:44 2012 +0100

    Major copyright & license fixups
    
    Update all the copyright years in pretty much any file touched in the
    past 2-2.5 years, and clarify the licensing situation:
    
    lib/ is LGPL2.1+, modules/ is GPL2+, both with an OpenSSL
    exception. Updated the top-level COPYING file to reflect the changed
    paths too, and LGPL.txt was replaced with the text of LGPL 2.1
    (instead of LGPL 3, when the sources were under 2.1+).
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit f4ae7681cdf39c2e663efdd547b8ade232033f84
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Thu Nov 8 12:58:44 2012 +0100

    system-source: Use so_rcvbuf(8192) on Linux
    
    Some Linux kernel messages are particularly long (iscsi, for example),
    so in order to not get garbage out, we need to increase the socket
    buffer size, and 8k is big enough for now.
    
    Reported-by: shih dane <daneshih1125@gmail.com>
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit 915661388afb577f5d0b0172f47258914fc38d3f
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Fri Nov 9 14:20:17 2012 +0100

    system(): Use follow-freq(1) on FreeBSD prior to 9.1
    
    FreeBSD prior to 9.1 does not have a kqueue-pollable /dev/klog, so
    syslog-ng would fall back to using timers, except that follow-freq()
    is explicitly set to zero, also diabling timer-based polling. This has
    the effect of making syslog-ng not read from /dev/klog at all.
    
    To work around the issue, on FreeBSD prior to 9.1, use follow-freq(1)
    for /dev/klog when using the system() source.
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit 4bfa03bc222408e2456dadcc9e6a7791f667b609
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Thu Nov 1 09:44:17 2012 +0100

    afprog: introduce afprogram_sd_kill_child for symmetry with the destination driver
    
    This patch factors out the code to kill the child process into a separate
    method so it becomes more in-line with the destination side.
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 659609955cf7a28c48e9c484fb43dcda901954e4
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Thu Nov 1 09:43:17 2012 +0100

    afprog: eliminate code duplication by introducing afprogram_dd_kill_child() function
    
    This patch moves the code to kill the child process into a separate method.
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 2fa9cd47bed0e7f72fa061c30f4d59bfb13437c3
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Tue Oct 30 17:45:15 2012 +0100

    Preparations for 3.3.7
    
    VERSION updated to 3.3.7.
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit 5d35f1d13afa46c75ce9f1f9c366a9afee812564
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Sun Oct 28 16:32:25 2012 +0100

    NEWS: Merge the 3.3.7 RCs, and start finalising the release.
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit 6a3c11c15fcddc49cd35c88e003d6fc40cc8c2bb
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sun Oct 28 10:25:16 2012 +0100

    messages.h: check positive feedback loop for debug/trace messages too
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 045f3d5328601979f4a1f61aed0fb74fd786634f
Merge: f261966 7ba4564
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sun Oct 28 13:46:51 2012 +0100

    Merge remote-tracking branch 'algernon/merge-queue/3.4'

commit f26196618d4407f3bb574ea991b36c920fb09c19
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sun Oct 28 13:04:41 2012 +0100

    messages: only allow a single level of recursions
    
    The code as originally written has permitted a configurable number
    of recursions to detect the positive feedback loop of internal messages.
    This feedback loop may happen when an internal() message triggers
    another internal() which in turn again and so on, effectively eating
    all the available system memory.
    
    Since we've used a single level of recursions anyway, this patch simplifies
    the related code and frees up 6 bits in the LogMessage structure.
    
    It also adds some more information into the suppression message, so it can
    be easier to understand.
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit d7fd9a401da09ab7d638257293c6fee0f9b8b35d
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sun Oct 28 13:04:35 2012 +0100

    messages: remove redirect_to_syslog functionality
    
    it was completely unused.

commit e756e45f9d51c7f301ba411fc76d25d532865a7a
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sun Oct 28 10:25:16 2012 +0100

    messages.h: check positive feedback loop for debug/trace messages too
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 7ba456433f379974554292d9f7587a37ba70df60
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Sat Oct 27 16:43:01 2012 +0200

    [dbparser] Implemented LLADDR parser
    
    The LLADDR parser will match Link Layer ADDResses of the form
    xx:xx:xx:...  where each xx is a 2 digit HEX number.  The parameter
    specifies the maximum number of octets to match and defaults to 20.
    
    The former MACADDR parser was changed to use LLADDR under the hood.
    
    Reported-by: Evan Rempel <erempel@uvic.ca>
    Signed-off-by: Evan Rempel <erempel@uvic.ca>
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit a91eb2c18168a4d956c24be964eddaff11a29c21
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Thu Oct 18 16:07:14 2012 +0200

    [dbparser] Implemented HOSTNAME parser
    
    The HOSTNAME parser will match compliant hostnames including trailing
    period.  This parser does not take any parameter.
    
    Reported-by: Evan Rempel <erempel@uvic.ca>
    Signed-off-by: Evan Rempel <erempel@uvic.ca>
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit 39a276dabc5ac8ea93af292e37c107b6b4085898
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Thu Oct 18 15:54:28 2012 +0200

    [dbparser] Implemented EMAIL parser
    
    The EMAIL parser will match address. The parameter is a set of
    characters to strip from the front and the end of the e-mail address
    which allows for easy matching of <email@some.host> enclosed
    addresses. Characters that a valid for a hostname can not be stripped
    from the end of the hostname. This includes a trailing period if
    present.
    
    Reported-by: Evan Rempel <erempel@uvic.ca>
    Signed-off-by: Evan Rempel <erempel@uvic.ca>
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit 1cc959bfddbea0d1813d16bc2b35a7bc45c9dfa5
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Thu Oct 18 10:48:50 2012 +0200

    travis: Significant Travis CI control file updates
    
    To fix issues with uninstallable packages, and to follow the official
    recommendation, run apt-get update as part of the testing
    process. Also, to make testing more reliable, install into $HOME, so
    that we do not need sudo for running the tests.
    
    Furthermore, restrict the tested branches to a subset: master,
    upstream mirrors, the sandbox and merge-queue branches. While there,
    also enable IRC notifications.
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit b84f14c13263f34d0197930e3418f3cb5bf7d873
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Sat Oct 27 14:38:04 2012 +0200

    cfg-lexer: During glob-based inclusion, only treat ENOENT specially
    
    When including files with glob-magic, treat all errors but ENOENT as
    fatal.
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit cb6ad63ac72b02402ad33d0db7137d8e991a7a1d
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Sat Oct 27 14:19:23 2012 +0200

    cfg-lexer: Handle no-magic includes better, without hiding errors
    
    When the @include pragma was converted to use glob(3), a couple of
    problematic cases stopped producing errors: if we had an @include
    without any magic, it still went through glob(3), which was set up to
    ignore errors (so that @include "/etc/syslog-ng/conf.d/" would work,
    even when the directory didn't exist).
    
    This hid errors, and made it possible even for explicit, glob-less
    @includes to fail silently, making debugging next to impossible.
    
    To fix this, glob() is now called with GLOB_NOMAGIC, so if the pattern
    does not contain any magic, it is returned anyway, whether it exists
    or not: and then, it will eventually be tried by the ordinary include
    mechanism, and produce a failure there, as it is appropriate.
    
    This way, @include "/foo/*" continues to work, and @include
    "/nothing.conf" will fail, as it should: errors are only ignored for
    inclusions that contain magic characters.
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit 103759b70e5a4d1dda30f900ffb0872704cdd080
Merge: 2419380 f7359d2
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sat Oct 27 14:15:00 2012 +0200

    Merge remote-tracking branch '3.3/master'
    
    Conflicts:
    	.travis.yml
    	NEWS
    	VERSION
    	lib/parser-expr-parser.c
    	lib/rewrite-expr-parser.c
    	modules/afsocket/afinet-source.h

commit 2419380ed39919eb2225771117d04a8280e427bb
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sat Oct 27 07:15:13 2012 +0200

    syslog-parser: introduce the new syslog-parser() parser
    
    This patch creates a new parser, to explicitly parse messages as syslog
    messages. This can be used to selectively parse these messages based on
    some filters.
    
    Imagine this use-case:
    
    log {
            source {
                    udp(port(2000) flags(no-parse));
            };
            parser {
                    log {
                            junction {
                                    log {
                                            filter { netmask("127.0.0.1/32"); };
                                            parser { syslog-parser(); };
                                            flags(final);
                                    };
                                    log {
                                            filter { netmask("127.0.0.2/32"); };
                                            parser { csv-parser(columns("C1", "C2", "C3")); };
                                            flags(final);
                                    };
                            };
                    };
    
            };
            destination {
                    file("/home/bazsi/logs/qqq" template("$(format-json --key *)\n"));
            };
    };
    
    Messages from 127.0.0.1 will get parsed as syslog messages, while 127.0.0.2
    as a csv-parser() style messages.
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 001c11fb88bd4ce68c668112678259fdc37e0f93
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Fri Oct 26 19:57:28 2012 +0200

    LogReader: separate msg-format related flags to a separate function
    
    Earlier msg_format related flags were parsed by log_reader_options_process_flag().
    Separate that to another function, so that it can be used independently
    from LogReader.
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 15dd732d4f11b17620388eedf00a6608195e108e
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Wed Oct 24 20:31:20 2012 +0200

    cfg-grammar: move common parser rules from csvparser plugin
    
    Earlier the only plugin that used these were the csvparser plugin, but
    now they make sense for syslog-parser() too
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit bb27a31a5d66b0c754b7632053a2147b59e8ac96
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Wed Oct 24 20:29:23 2012 +0200

    cfg-grammar: reorganize rules so that msg_format related rules can be reused from plugins
    
    This patch introduces msg_format_option rule that can be referenced from
    plugin grammars to parse format specific options. This is going
    to be needed by the syslog-parser() plugin.
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 5f9cce2ccc57a976c71153c3e555fc6bacdd8913
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Wed Oct 24 20:27:58 2012 +0200

    LogParser: pass length argument to log_parser_process()
    
    Since a number of parsers require an explicit length (json-parser,
    and the future syslog-parser), it's useful to pass this information along,
    especially as we have it in log_parser_queue(). This can potentially
    save an strlen() on a potentially large chunk of data in the fastpath.
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit cc80b5fa7ab8af2e436891052821b344e6970fe4
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Fri Oct 26 19:30:21 2012 +0200

    autogen.sh: trigger git submodule init even if only one of the submodules  wasn't yet initialized
    
    The recent introduction of the AMQP destination caused a bootstrap problem,
    as ivykis and libmongo-client was already bootstrapped in my tree, thus
    rabbitmq-c wasn't cloned properly.
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit f7f63aea04ce8a7556e40df4759c887996f3e0ad
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Thu Oct 18 18:15:07 2012 +0200

    affile: Split into source and dest parts
    
    Similar to the afsocket splits, split affile into source and
    destination too, on the file level. We do keep affile-common, for
    affile_open_file() and a couple of constants.
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit cf544b1fe5ff95846a33095ff052cf0a14ede2a9
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Thu Oct 18 15:06:46 2012 +0200

    afamqp: Make the exchange declaration optional
    
    Do not declare the exchange by default, but allow turning this feature
    on via the exchange_declare(yes) configuration option.
    
    Signed-off-by: Attila Nagy <bra@fsn.hu>
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit 1c1009931a161084e9a8469fe6daee89dfd56490
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Mon Oct 8 22:56:00 2012 +0200

    afamqp: Disable building with system librabbitmq for now
    
    There is no rabbitmq-c release yet that we can support yet, so for
    now, error out if the system version was requested.
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit efdee1072316674459b354f58b7621d9d97be4da
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Mon Oct 8 22:46:56 2012 +0200

    afamqp: New AMQP destination driver
    
    This driver implements an AMQP destination (based on the rabbitmq-c
    library), supporting persistence, all the exchange types, and uses a
    creative way to get messages accross: all the name-value pairs
    selected with the value-pairs() syntax will be sent as headers, while
    the message payload can be set with the body() option (empty by
    default).
    
    Most settings have sensible defaults, except for a few, noted below:
    
    @module afamqp
    destination d_amqp {
        amqp(
            vhost("/")
            host("127.0.0.1")
            port(5672)
            username("guest") # mandatory, no default
            password("guest") # mandatory, no default
            exchange("syslog")
            exchange_type("fanout")
            #routing_key("")
            #body("")
            persistent(yes)
            value-pairs(
                scope("selected-macros" "nv-pairs" "sdata")
            )
        );
    };
    
    Publishing the name-value pairs as headers makes it possible to use a
    headers exchange type and subscribe only to interesting log streams,
    in a much more flexible way than using the routing_key() option.
    
    The routing_key() and body() options can contain any template, they
    will be expanded before publication.
    
    Signed-off-by: Attila Nagy <bra@fsn.hu>
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit f870f6c326cd5ea2b58e60edb1cdce5173e73ddf
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Thu Oct 18 10:48:50 2012 +0200

    travis: Significant Travis CI control file updates
    
    To fix issues with uninstallable packages, and to follow the official
    recommendation, run apt-get update as part of the testing process (and
    also install libesmtp-dev). Also, to make testing more reliable,
    install into $HOME, so that we do not need sudo for running the tests.
    
    Furthermore, restrict the tested branches to a subset: master,
    upstream mirrors, the sandbox and merge-queue branches. While there,
    also enable IRC notifications.
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit b0c42b51c27f576a5a3ca9cec4ce27262a890f44
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Sat Oct 13 19:26:52 2012 +0200

    json: The test should not depend on the environment's timezone
    
    The $(format-json) test was failing when a timezone was set in the
    environment that did not match the tests expectations.
    
    To fix this, explicitly set the timezone to UTC.
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit db111f905718c9fb48db0f4a958805bcd0d9238c
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Sat Oct 13 19:02:14 2012 +0200

    json-format: Unbreak $(format-json)
    
    The $(format-json) template function was misbehaving under certain
    conditions, namely where we had a sub-object, a simple value, and
    another object starting right after: in this case, no comma was placed
    between the simple value and the name of the new sub-object.
    
    The fix changes how comma placement is done completely: it is no
    longer a mix of prefix_data & user_data magic, but all state is kept
    in the user data, with the _obj_start(), _obj_end() and _value()
    functions setting it as appropriate:
    
    - When starting a new object, if we need a comma, we'll put one, and
      turn the comma flag off (the first item within an object won't need
      a comma).
    - When ending an object, we never add a comma, but the next item will
      need the comma flag set.
    - When adding a value, if the comma flag is set, we add one, and in
      the end, set the flag ourselves, as the next one will need a comma
      too.
    
    This is much simpler than the previous hackery, and also results in
    correct JSON in every situation.
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit 561de064e94ea34053eb8c8f4f9baf884c580050
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Sat Oct 13 17:59:22 2012 +0200

    logsource: Fix host_override() and program_override()
    
    LogSourceOptions->program_override_len and ->host_override_len must be
    initialised to -1, otherwise host and program overrides will treat the
    value as a 0-length string, as automatic length calculation is only
    performed when these values are -1.
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit f93f83cc2a386c6a961606629c560f435cdeb609
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Sun Oct 14 16:32:54 2012 +0200

    travis: Control file updates
    
    Restrict branch building to a subset of branches that matter (master,
    upstream mirrors and the sandbox), so that packaging branches and
    similar don't end up using resources and failed builds all over the
    place.
    
    While there, also request IRC notifications.
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit f7359d2702f83179283141b83bd7eb79504bf3f3
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Tue Aug 14 12:30:24 2012 +0200

    fixed invalid declarations for bison generated yyparse() functions
    
    The new bison finally declares the yyparse() function in its header, which
    revealed a couple of invalid declarations in a couple of parsers.
    
    This patch fixes that.
    
    Reported-By: Conrad Hoffmann <ch@bitfehler.net>
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>
    Signed-off-by: Gergely Nagy <algernon@madhouse-project.org>

commit 9f0d46794e5412ec34c9b5eb252c31c11096097a
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sun Oct 14 09:57:33 2012 +0200

    afunix: split into source/dest files
    
    To make the source code more navigable, separate the source/destination
    drivers into separate files.
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit bb099a7e41b0126cce172e52510287e019f06711
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sun Oct 14 09:51:37 2012 +0200

    afinet: split into source/dest files
    
    To make the source code more navigable, separate the source/destination
    drivers into separate files.
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 768073c667a04f64fdc75ec17aed62f60c12da75
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Sat Oct 13 19:49:29 2012 +0200

    travis: Install under $HOME, to avoid permission issues
    
    Instead of using sudo to install, install to a directory under $HOME,
    so we don't run into permission problems when running the test suite.
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit e90f374cdade1bd89c47094d3ee1c66d98c88c25
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sat Oct 13 17:40:40 2012 +0200

    afsocket: split afsocket into afsocket-source and afsocket-dest
    
    These files grew too big, split them on source/dest boundary. afinet/afunix
    is split in a followup patch.
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 2d4ee3de14bfcc7ec01218ed790325126eec8aa4
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sat Oct 13 17:34:18 2012 +0200

    cfg-grammar.y: fixed type mismatch warning in source_reader_option
    
    This occurred when compiling plugin grammars as this rule is only used
    there.
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 4900a9cc84b7e8395c00ae2210fdff721dab89ea
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sat Oct 13 13:29:50 2012 +0200

    db-parser: added @PCRE@ parser
    
    This patch implements the @PCRE@ parser in db-parser() patterns. With
    this you can use the power of regexps once the heavylifting of identifying
    the potential patterns happened by the radix implementation.
    
    Syntax:
      @PCRE:name:regexp@
    
    As the name suggests regexp is a Perl-Compatible Regular Expression as
    implemented by the PCRE library.
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit f542bc429d0de1f75274d6c67f95cb077bba36c3
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sat Oct 13 10:46:07 2012 +0200

    dbparser: create a separate directory for pdbtool
    
    As I'd like to split the pdbtool source code to several files, which
    would clutter the db-parser directory.
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 6dcb116996310400ac94e6cd3a7c321a3c595e49
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sat Oct 13 10:30:09 2012 +0200

    db-parser: allow dash in class names
    
    Reported-By: Evan Rempel <erempel@uvic.ca>
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit ee310a5284790f491ea2cf070c0bb1cd59684345
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sat Oct 13 10:23:32 2012 +0200

    pdbtool dump: fixed -p option parsing
    
    And also added a warning if neither -T or -P was specified.
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 3ff27ba89ddccb87a852aa3591af4d12587a5e50
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sat Oct 13 10:23:32 2012 +0200

    pdbtool dump: fixed -p option parsing
    
    And also added a warning if neither -T or -P was specified.
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 3972f9a172feb25504960d6e5db0f2854ee04a99
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sat Oct 13 10:23:04 2012 +0200

    plugin: don't emit module loaded successfully unless verbose mode is enabled
    
    Interactive tools load plugins, but the information about this being
    successful is not very important. Make this a 'verbose' message.
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 6022d4e1ad7f9c46c0b152f47c3f2d0383b7c27d
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sat Oct 13 10:07:43 2012 +0200

    unix-dgram: fixed message processing w/o terminating newlines
    
    In the last refactor, unix-dgram was switched to use the "text" LogProto
    
    Since unix-dgram clients don't always supply an NL character
    (such as on FreeBSD), this caused issues.
    
    This patch fixes the issue and also extends the testcases to cover this.
    
    Reported-by: Peter Czanik <czanik@balabit.hu>
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 7967daaa2e6c7ab9fc5e47dc52843297cd50b38f
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Tue Oct 9 15:02:50 2012 +0200

    Update the travis control file to apt-get update too
    
    To fix issues with uninstallable packages, update the travis-ci
    control file so that it calls apt-get update too.
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit 10bc1bca86d24fbdde75de229a05aac967bcdf32
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Tue Oct 2 12:56:53 2012 +0200

    afmongodb: Include libmongo-client/configure.gnu in the tarball
    
    In order to install cleanly with an internal libmongo-client, we need
    that library to be compiled in statically, which is what the
    configure.gnu script (installed via autogen.sh from git) enforces.
    
    However, since configure.gnu is not part of libmongo-client, its make
    dist will not include it, so its parent must do that. For this reason,
    and similarly to how the same file in lib/ivykis is handled, include
    libmongo-client/configure.gnu in the EXTRA_DIST of
    afmongodb/Makefile.am.
    
    Reported-by: Peter Czanik <czanik@balabit.hu>
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit 054138dcdea09e97ae5995d5716b4837288c32a0
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Tue Oct 2 10:58:36 2012 +0200

    lib/: Include logproto.h in pkginclude_HEADERS
    
    Since we need logproto.h to build, include it in pkginclude_HEADERS.
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit f997b39d1376f39a03691a097d0ff59c89c04dba
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Tue Oct 2 10:22:57 2012 +0200

    json: Include all sources in _SOURCES
    
    With the renaming and such the list of sources required to build the
    plugin got out of sync with reality. This patch corrects that, by
    adding the two new headers, and removing an old, unused one.
    
    Reported-by: Peter Czanik <czanik@balabit.hu>
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit da8ab6ce9eab8baddb801804bf0dc8dafad3d18f
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Tue Oct 2 13:06:25 2012 +0200

    Makefile.am: Recurse into lib first, then libtest
    
    libtest needs a few things in lib built, so build lib first, and
    libtest after.
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit 0e669df018028b11cc122dfae513ca4adb9ed73f
Author: Gergely Nagy <algernon@madhouse-project.org>
Date:   Tue Sep 25 18:15:40 2012 +0200

    lib/: Make libsyslog-ng-crypto.la depend on libsyslog-ng.la
    
    Without the explicit dependency, make will not recognise that we need
    libsyslog-ng.la for libsyslog-ng-crypto.la, and thus fail when we're
    using either parallel make, or make libsyslog-ng-crypto.la explicitly.
    
    Reported-by: Peter Czanik <czanik@balabit.hu>
    Signed-off-by: Gergely Nagy <algernon@madhouse-project.org>

commit 867b491f062b1123c4d3cb3756081e22cffb0012
Author: Gergely Nagy <algernon@madhouse-project.org>
Date:   Tue Sep 25 16:06:49 2012 +0200

    system-source: Correct a typo in the unix-dgram() part
    
    The option is called perm(), not perms().
    
    Reported-by: Peter Czanik <czanik@balabit.hu>
    Signed-off-by: Gergely Nagy <algernon@madhouse-project.org>

commit 0152990e721258f7e0d0bd030ea190826813d416
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Mon Oct 8 11:17:07 2012 +0200

    Preparations for 3.3.6.91
    
    NEWS & VERSION updated for 3.3.6.91 (aka 3.3.7 RC2)
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit ccd5f1b652c358afdf5d9cda597b6206616819b4
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Sun Oct 7 21:01:29 2012 +0200

    afstreams: unref the reader at deinit time
    
    In order to make sure we don't leak the /dev/log fd, unref the reader
    at deinit time, and set it to NULL. This way, it will be reopened
    shortly after in the reload cycle, and we won't leak the fd.
    
    Reported-by: Michael Hocke <michael.hocke@nyu.edu>
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit 128f9a10a52431ba6ae902804313434d8d82db02
Author: Gergely Nagy <algernon@madhouse-project.org>
Date:   Fri Oct 5 20:58:31 2012 +0200

    ivykis: Update to 0.30.4.
    
    Update the bundled ivykis to 0.30.4, which contains an important
    workaround that affects syslog-ng users on FreeBSD.
    
    Along with the previous commit, these two appear to fix all problems
    related to /dev/klog on FreeBSD.
    
    Signed-off-by: Gergely Nagy <algernon@madhouse-project.org>

commit 169bc655620bf641eb0429258533037ff9ae52bd
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Fri Oct 5 12:16:57 2012 +0200

    logreader: When following a file, treat non-regular files specially
    
    When following a file with follow-freq(), and it is not a regular
    file, but something for which stat(2) always returns 0 size (such as
    the /dev/klog character device on FreeBSD),
    log_reader_io_follow_file() never went into the process input branch,
    because the current position (0) was always at EOF (also 0).
    
    To break out of this unfortunate situation, if the file to read from
    is not a regular file, go into the process input loop anyway: at
    worst, it will do an expensive noop.
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit 8d793a92640f492b98693b233ad6b77f0ae1ea9a
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Tue Oct 2 12:56:53 2012 +0200

    afmongodb: Include libmongo-client/configure.gnu in the tarball
    
    In order to install cleanly with an internal libmongo-client, we need
    that library to be compiled in statically, which is what the
    configure.gnu script (installed via autogen.sh from git) enforces.
    
    However, since configure.gnu is not part of libmongo-client, its make
    dist will not include it, so its parent must do that. For this reason,
    and similarly to how the same file in lib/ivykis is handled, include
    libmongo-client/configure.gnu in the EXTRA_DIST of
    afmongodb/Makefile.am.
    
    Reported-by: Peter Czanik <czanik@balabit.hu>
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit b9125ddb4d52417383a4c2ed510e22f6153341dc
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Mon Oct 1 09:51:18 2012 +0200

    rename json to json-plugin
    
    Since json-c produces libjson.so and linking libjson.so (from json-c)
    against libjson.so (from syslog-ng) wouldn't work, we need to rename our
    plugin.
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 2960f61bbb874e0f8c62d4a89046ae17df6a95b9
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sun Sep 30 20:36:28 2012 +0200

    json: rearrange compilation units, rename the plugin and make the unit tests pass
    
    Use a separate json-plugin.c instead of adding this to tfjson,
    rename tfjson to format-json as it more clearly defines what that
    module implements.
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 7ff4d5bd56f8d7955748cf97493d643e65c4d02a
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sun Sep 30 20:31:40 2012 +0200

    templates.h: added TEMPLATE_FUNCTION_DECLARE macro
    
    This macro forward declares the constructor for a template function, so
    it becomes possible to separate the template-function and its registration
    as a plugin into separate compilation units.
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit e959c9658f1dae3d3eb2b3b71a916ba384dc5cfe
Merge: 5aa4843 31e0843
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sun Sep 30 20:18:54 2012 +0200

    Merge remote-tracking branch '3.3/master'
    
    Conflicts:
    	.gitmodules
    	NEWS
    	VERSION
    	autogen.sh
    	modules/afmongodb/libmongo-client
    	modules/afsocket/afsocket.c
    	syslog-ng/main.c

commit 5aa484350ffc8f2b1262b82810f489cfa9c51c58
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sat Sep 29 07:12:14 2012 +0200

    LogTransportMock: create separate constructors for the various cases
    
    Instead of putting yet-another-boolean-argument to the constructor,
    use separate constructors for the different cases. The implementation
    is still using a single read function with conditionals though.

commit 2d0fb042d747883d71ebff9578ce6d2afc3144b5
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sat Sep 29 05:40:31 2012 +0200

    LogProto reorganization to support plugins
    
    This patch is a large-scale refactoring for the LogProto code, it does
    a number of things and should probably be split to a number of independent
    patches for easier review. For now it is a single patch.
    
      * split the abstract base class LogProto into
        LogProtoClient & LogProtoServer. These are quite independent
        (one doing fetches the other posts), so no explanation why they should
        be the same.
      * LogProtoOptions is introduced to hold options related to LogProto
        classes. The options parsed by the core is provided by a
        cfg-grammar rule too (to be included in plugin specific grammars)
      * added valiate_options method that checks at _init() time whether the
        options parsed from the config make any sense. That's the only
        error-handling possibility as the constructor may not return NULL.
      * LogProto classes got split into a number of files, they are provided
        by the core as classes and the ones used as network transports
        are also published as a plugin. This way extending LogProto with
        a module-specific behaviour can use the base classes, and standard
        protocols can be instantiated using the plugin interface (to be used
        as the transport() option for the network/syslog drivers).

commit 29235dfe0dc85649afdb0224553a87a6e18c18bc
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sun Sep 2 07:08:06 2012 +0200

    libtest: added LogProto testing framework as proto_lib.{c,h}
    
    In a similar vain to template_lib.{c,h} implement a LogProto related
    assertions and helper functions. Centralizing this makes it possible to
    test various LogProto implementations from different unit tests easily
    without having to duplicate code.
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit f07aa84e19c2a024b0dde8e44cff3b1ef0b74b1e
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sun Sep 30 17:02:07 2012 +0200

    LogTransportPlain: use polymorphic classes instead of a large number of branches in code
    
    This patch splits LogTransportPlain to 5 polimorphic classes to make the
    code easier to follow, and possibly split the source code to five files
    in the future.

commit d93d35857e3acac5eb59a9735d8947dedf43a511
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sat Sep 15 12:09:39 2012 +0200

    simplify *Options initialization pattern (LogReaderOptions, LogWriterOptions, etc)
    
    The _init() method for various *Options structures were needlessly
    complicated with an ugly warning on top of each and every such function.
    After giving some thought to why it needs to be so complicated a much
    easier pattern could be created, eliminating most of the complexity.
    
    Earlier *_options_init() methods were prepared to be called several times
    without a pairing _options_destroy(), e.g. if any memory was allocated
    by init, a repeated init should have preserved the allocation (or at least
    free the one the previous invocation allocated). This pattern caused
    these init methods to actually save a number of variables locally
    before commencing on the actual initialization and then restoring
    them afterwards.
    
    After giving some thought, this actually addressed an unused use-case:
    if the init method is called for the same Options structure with
    a changed GlobalConfig instance. In this case init would've inherited
    the changed values from GlobalConfig.
    
    However this never happens in reality, options structures may indeed be
    initialized multiple times, however in this case the GlobalConfig remains
    the same.
    
    Removing this assumption simplifies the code a lot and makes it much more
    readable, and finally stops spreading that terrifying comment on the top
    as the pattern got implemented in a number of places.
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 4157b5495d6a28b62d3c016b5c5966b8ed89261a
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sat Sep 15 12:23:09 2012 +0200

    afsql: fixed the failure handling branch in afsql
    
    An "address-of" operator was missing from log_queue_push_head() call,
    potentially causing crashes when the insertion of a record fails.
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit fb60df757c0fe6bf80c508d1edb27d301c98d6a1
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Tue Sep 25 13:05:43 2012 +0200

    json: don't compile the unit tests if ENABLE_JSON is not enabled

commit 31e0843ce918ac9ead433892e67685dd1ac33151
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Fri Sep 14 15:13:17 2012 +0200

    Use https URLs for the submodules & update libmongo-client
    
    Because https can be cloned easier from behind a proxy than git, use
    https URLs. While there, also update libmongo-client to v0.1.5, the
    latest stable release.
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit 6bdf662a20a31392a79cd6e02ea81882776e7be9
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Fri Sep 14 12:02:04 2012 +0200

    autogen.sh: No need to special-case lib/ivykis anymore
    
    The --disable-kqueue and --disable-dev-poll options were only
    recognised by the BalaBit fork of ivykis. Since we switched to
    upstream, these are both obsolete and unnecessary, so lets remove
    them.
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit 8016818ac2fa2328ccbeab6fa13a7dc876e4220b
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Wed Aug 29 17:02:15 2012 +0200

    jsonparser: Only prepend a prefix if there is one
    
    In log_json_parser_process_single(), when parsing an object element,
    only prepend a prefix if there is one, otherwise g_string_assign()
    will complain on stderr with an assert, which is not something we'd
    like.
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit 5752a72b4415e0bb5fbeae78643f4f6feea6163f
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Fri Sep 14 11:15:44 2012 +0200

    json: Use a hand-coded JSON formatter
    
    Instead of relying on json-c to format our JSON, do it ourselves,
    skipping quite a bit of object allocations that we do not need.
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit 0792112a62efd923f3e1a8d60d8b1cd86a8bb005
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Thu Aug 23 13:07:23 2012 +0200

    afmongodb: Use insert instead of upserts
    
    With the recent changes to value pairs, we can now turn our internal
    dotted notation into structures, so do that, and use inserts instead
    of upserts!
    
    This - at the moment - comes with a noticable performance cost, as
    we'll do extra work on the syslog-ng side (which was previously done
    on the server side). However, this paves the way for bulk inserts,
    which will improve performance a lot. (And making the value pairs
    walker more performant will also help, but that's independent of
    mongodb.)
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit 3a1edf9de4fbd49171f441b10464418195b8350c
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Fri Aug 17 16:23:28 2012 +0200

    tfjson: Convert to value_pairs_walk()
    
    Now that we can process dotted-notation properly, make use of that!
    
    With this change, $(format-json) becomes smart enough to turn
    dotted-notation back into proper structures. It does not support
    arrays yet, however.
    
    Also added a test case that uses dotted-notation, and tests that it
    gets correctly formatted.
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit e0e94a991e11e9e37f4cf26c6e3bbe433fb73538
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Fri Aug 17 15:27:47 2012 +0200

    value-pairs: Introduce value_pairs_walk()
    
    This new function is meant to be used when one wants to process the
    result of value-pairs() in a structured manner. It will treat the keys
    as if they were in dotted-notation, and whenever a new object starts,
    it will call obj_start_func, whenever an object ends (a new one
    starts, or we're winding down in the end), it calls obj_end_func. When
    processing a single key, process_value_func will be called.
    
    The obj_start_func and obj_end_func callbacks take six arguments: the
    current key name, the prefix so far, a pointer to an area where
    prefix-specific data can be stored, the previous element's name and
    data on the stack, and the user_data passed to value_pairs_walk(). The
    process_value_func receives the value too, see the VPWalk* typedefs in
    value-pairs.h.
    
    The prefix-specific data can be NULL, so care must be taken not to
    dereference it in that case.
    
    With this functionality, we will be able to construct structured data
    out of the flat representation of value-pairs.
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit ad6679c3918d20c5058bb905dd7cd66916830d65
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Fri Aug 17 18:16:00 2012 +0200

    Merge tfjson & jsonparser
    
    The reason tfjson and jsonparser were separate is because the former
    supported two json libs, and they could be compiled separately.
    
    Now that tfjson dropped json-glib support, the separation became
    pointless, so this patch merges the two together.
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit f5b72a946af99adf841ddcb8a45d2a153ab0c35f
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Fri Aug 17 16:33:10 2012 +0200

    tfjson: remove json-glib support
    
    There is no point in supporting two json formatters anymore, so drop
    support for json-glib.
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit 13849b3220bc30d4c5c2eb670d377d4db9aaed91
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Wed Sep 12 11:08:01 2012 +0200

    Add a Travis-CI control file
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit 4d9f9e2ea563b6b451a780da513861fc9b7cba05
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Fri Sep 7 13:32:39 2012 +0200

    afsocket: In case of unix-dgram sources, include the filename in stats
    
    The file source includes the filename of the source in the stats, but
    the unix-dgram source does not do the same, which makes it harder to
    identify which unix-dgram stat belongs to which source.
    
    With a little change to afsocket_sc_stats_instance(), we can fix that,
    by teaching this function to use self->owner->bind_addr if
    self->peer_addr is unset.
    
    Reported-by: Evan Rempel <erempel@uvic.ca>
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit 6afd5f3231625651a3b81c8a8dce0d8d16c6026a
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Thu Sep 6 13:23:17 2012 +0200

    Preparations for 3.3.6.90
    
    NEWS & VERSION updated for 3.3.6.90 (aka 3.3.7 RC1)
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit c8449114ac77000bb4fbe8c11cfe0e3bdc469857
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Thu Sep 6 12:59:25 2012 +0200

    doc: Move old ChangeLogs to doc/
    
    The old ChangeLogs (especially ChangeLog) were looking stale in the
    root directory, and ChangeLog was overwritten at make dist
    anyway. Since they're historic, move them to doc/: they'll still be
    available in the git repo, but they will not be included in the
    tarball.
    
    The top-level makefile will continue to re-generate ChangeLog
    appropriately, so that the built tarballs will continue to have an
    up-to-date changelog.
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit 149dd05521abd4e1736a7c3ef97e52a13a1bc82d
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Tue Sep 4 19:59:52 2012 +0200

    lib/ivykis: Update to latest stable-v0.30
    
    Update the bundled ivykis submodule to a commit that fixes the spinning
    on FreeBSD.
    
    Reported-by: Cy Schubert <cy@FreeBSD.org>
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit 21a9ac3a7e2554f94b8ff8788bc4e82ec3fb58d3
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Mon Sep 3 11:41:36 2012 +0200

    afsocket: Fix compilation without spoof-source
    
    AFInetDestDriver->spoof_source is only available when compiling with
    spoof-source enabled, so guard it with an #if.
    
    Reported and patched by Dave Reisner <dreisner@archlinux.org>.
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit 9ba1d1b3e1bd8fedd59660654b75b5642b89c0f5
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Thu Feb 2 14:21:01 2012 +0100

    afsocket: fixed building the notls version
    
    There was a collision in the macro used to enable SSL support in the
    configure script and the macro defined by the Makefile in case the SSL
    version is being built. The latter is now renamed to "BUILD_WITH_SSL".
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 8d997973d7134876725035113ccbc3df07f53777
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Sat Sep 1 13:03:49 2012 +0200

    Fix the module registry display in debug mode
    
    In debug mode, msg_init(TRUE) must be called, but we were calling
    msg_init(FALSE) unconditionally, which led to segmentation faults when
    trying to load the modules and log messages.
    
    To fix this, do not call msg_init(FALSE) at startup, leave that to
    app_start() later, but do call msg_init(TRUE) when necessary.
    
    Patch from Tamas Pal <folti@balabit.hu>.
    
    Reported-by: Jose Oliveira <jpo@di.uminho.pt>
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit 79b5be710e0eb01d74cf87783c6d9022ab1e2617
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Sat Sep 1 12:46:05 2012 +0200

    cfg-lexer: Fix glob-based include order
    
    When using glob-based includes, matching files were immediately
    included, which resulted in the include stack going bonkers. The
    proper way to do glob-based includes is to do the same as in the
    directory-based case: add the files to the current include stack
    level's file list.
    
    This patch does just that, thereby making glob-based includes work as
    one would expect them to work.
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit d8d87c0b8845f11c0382efad5fe8d5430dfa7612
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Wed Aug 29 10:38:59 2012 +0200

    system-source: Introduce a new system() generator.
    
    This patch replaces the old confgen-based system() generator, that
    relied on a script (generate-system-source.sh) to generate the block
    system() expands into. While that was flexible and easy to modify, it
    has had the disadvantage of running an external script at startup,
    which is undesirable in many situations, including when using a strict
    AppArmor profile.
    
    However, a generated system() is useful in a lot of situations,
    ranging from creating portable, system-agnostic configuration files to
    supporting sysvinit and systemd with the same config.
    
    For these reasons, this patch implements a built-in system()
    generator, that does not rely on the generate-system-source.sh script
    at all, but does everything itself, from C.
    
    It is loaded by the default scl.conf, but can be loaded separately
    with:
    
     @module system-source
    
    It does not support auto-loading yet, because all the module does, is
    register a block.
    
    The system() generator this patch implements results in the exact same
    expansion the old script generated. The old script-based solution is
    also deprecated (and thus, removed), in order to not duplicate code:
    we only wish to maintain one implementation.
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit b719492d195dd93b102fccc2f3ab5f0344938ca7
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Tue Aug 28 20:59:53 2012 +0200

    ivykis: Update to the latest head of the stable-0.30 branch
    
    The stable-0.30 branch has a few fixes that affect us, for example on
    Solaris, update the submodule to pull those patches in.
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit d5f78c833a20d3eb5da7372dd70bc79f2f971814
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Fri May 18 14:58:56 2012 +0200

    afmongodb: Fix a queue notify<->wakeup deadlock
    
    As it turns out, there's a race condition between
    afmongodb_dd_queue_notify() and the worker thread: one is trying to
    lock queue_mutex to send a wakeup signal and clear the notification
    callback, and the other is using g_cond_wait() with the same
    queue_mutex locked around it.
    
    There appears to be a race between the two threads, and it can happen
    that both are trying to g_mutex_lock() the same mutex at the same
    time.
    
    To work around this problem, the patch below removes the queue_mutex
    locking from dd_queue_notify(): it's not required anyway. But it also
    moves the log_queue_reset_parallel_push() from the queue notify
    function to the other thread, where we're already holding the mutex
    after the g_cond_wait() anyway. (And do something similar in the
    suspend wakeup case too, where locking queue_mutex is also safe).
    
    This gets rid of the deadlock, and the code becomes easier to follow
    aswell.
    
    Reported-by: Eun Kyung <ekyung01@googlemail.com>
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit 77ba8563ab6acb10b374edac5ae562157abe0b16
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Fri Aug 17 10:21:18 2012 +0200

    afmongodb: Support connecting to unix sockets
    
    The next version of libmongo-client (0.1.6) will support connecting
    via unix sockets, and the mongodb destination driver should follow. To
    achieve this, the internal copy was updated to a version that already
    supports this, and the minimum required version was also bumped to
    0.1.6.
    
    With that in place, the path() option is introduced, which, when set,
    will tell the driver to connect via the specified path to a unix
    socket. It does this by setting port to MONGO_CONN_LOCAL, that's how a
    path is recognised by libmongo-client.
    
    However, setting path() conflicts with host(), port() and servers():
    the first cannot be used when any of the other three was previously
    set, nor the other way around. The configuration grammar was updated
    to notice this case, and bail out with an error if such a scenario is
    detected.
    
    Based on the work of Conrad Hoffmann <ch@bitfehler.net>.
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit 691a86a4a61999cf9ade2c8a76d7fec7ebb767ba
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sat Aug 18 14:06:50 2012 +0200

    .gitmodules: change repository PATH to algernon's repo
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 9b318c5778d4d9916cb1e0fbae80b66be6359430
Author: Balint Kovacs <blint@blint.hu>
Date:   Wed Aug 15 19:28:03 2012 +0200

    db-parser(): implement a MAC address parser
    
    The MACADDR parser matches the standard format for printing MAC-48
    addresses in human-friendly form, whis consists of is six groups of
    two hexadecimal digits, separated colons (:)
    
    Signed-off-by: Balint Kovacs <blint@balabit.hu>

commit 9adf4759f87740536be1744f43fc292b2600adf2
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Fri May 18 15:37:17 2012 +0200

    jsonparser: Handle every kind of invalid input gracefully
    
    Previously, we used json_tokener_parse_ex(), which always returned
    NULL in case of an error. A while ago, we switched to
    json_tokener_parse() instead, which never returns NULL, and instead,
    modifies the returned object to be an integer casted to pointer in
    case of an error.
    
    This resulted in the json-parser segfaulting whenever it encountered
    invalid input.
    
    The best course of action is to switch back to
    json_tokener_parse_ex(), because that way we can easily see when an
    error happened, and we even have easy access to the error message.
    
    In the long run, we should probably move back the tokener to the
    LogJSONParser object, and protect it with a mutex, for a bit better
    performance.
    
    Reported-by: Eun Kyung <ekyung01@googlemail.com>
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit 083782be3add61721bcdc6327ff68af2ea2f7113
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Fri Aug 17 10:32:43 2012 +0200

    afsmtp: Fix the module linkage
    
    Use $(MODULE_DEPS_LIBS) and $(MODULE_LDFLAGS) instead of trying to
    grab all the libs.
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit 7d00a9d448d76975e6cbdd1a4cfa076a307ef585
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Fri Jul 6 11:56:47 2012 +0200

    jsonparser: Clone the marker() setting when cloning the parser
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit 31763e12651761290a85efece0d2279a28fbfe17
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sat Aug 18 13:18:25 2012 +0200

    tcp(): enable TCP keepalive by default
    
    This patch enables SO_KEEPALIVE by default and changes the various
    keepalive timers so that broken connections would be detected within
    2minutes, 60 seconds idle time, 10 seconds between keepalive probes and
    6 failed probe means that the connection got broken.
    
    The keepalive parameter setup only works on Linux.
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 2c99ebe31ff0f14b27dbf3b1262052534a2509f3
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sat Aug 18 13:19:51 2012 +0200

    afsocket: Implement tcp_keepalive_time(), intvl() and probes()
    
    Three new options are introduced this patch to control various TCP
    keepalive related parameters
    
      tcp-keepalive-time()   - equivalent to /proc/sys/net/ipv4/tcp_keepalive_time
      tcp-keepalive-probes() - equivalent to /proc/sys/net/ipv4/tcp_keepalive_probes
      tcp-keepalive-intvl()  - equivalent to /proc/sys/net/ipv4/tcp_keepalive_intvl
      tcp-keepalive()        - an alias to the earlier so-keepalive() option to match the keepalive related params
    
    With these new options one can control on a per-source basis the parameters
    governing TCP keepalives.
    
    While these options can be specified for all socket related sources,
    it only makes sense for TCP-based transports.
    
    By default, it's value is 0, which means using the kernel default (2
    hours).
    
    These options only work on platforms which provide TCP_KEEPCNT,
    TCP_KEEPIDLE and TCP_KEEPINTVL setsockopts, which is only Linux as
    far as I know.
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 93af35d412a7d9f96a03029249fde373fe49bab0
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sat Aug 18 13:15:07 2012 +0200

    afsocket: added error warning messages on so-rcvbuf/so-sndbuf failures
    
    This patch checks if the setsockopt to change the socket buffer sizes
    actually succeeds, and emits a warning if it doesn't. Otherwise it can be
    difficult to detect udp drops due to receive buffer sizing issues, when
    the kernel limits syslog-ng's attempt to increase the buffer.
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit cb62deb8fc7587bd44a68b8039dc6b2e47d00bc3
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Tue Aug 14 12:30:24 2012 +0200

    fixed invalid declarations for bison generated yyparse() functions
    
    The new bison finally declares the yyparse() function in its header, which
    revealed a couple of invalid declarations in a couple of parsers.
    
    This patch fixes that.
    
    Reported-By: Conrad Hoffmann <ch@bitfehler.net>
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit ba8a1bc9ab6e0d3e582f507c82db5d946e2b32ea
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Mon Aug 13 11:02:09 2012 +0200

    test_template: refactor to use testutils
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 8644c767635841436f5e7adc121a0ec6cbc1a906
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Mon Aug 13 11:01:01 2012 +0200

    test_template_speed: indent output so that unit test runs are more readable
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 77458876d0806dd0b7722e457d4a2b5a637437be
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Mon Aug 13 07:41:00 2012 +0200

    basicfuncs: unit tests moved to a separate program
    
    Continuing the refactor to independent unit tests, this patch moves stuff
    from test_template to modules/basicfuncs/tests using the new
    template_lib.c in libtest.
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 36c00a985cd710db3377f40fef307ffdd89ea343
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Mon Aug 13 07:30:15 2012 +0200

    test_template: remove cryptofuncs unit tests
    
    As they were moved to a separate test program in an earlier commit.
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 30ef046850f10aaf1aecea7e422a3fc930c4d53b
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Mon Aug 13 07:29:48 2012 +0200

    tfjson: added skeleton unit tests

commit 0f3c04fa3283753149779ad2f9589026f809f2da
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Mon Aug 13 07:29:24 2012 +0200

    libtest: added assert_template_format_with_context() function
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit cc866a899a743031c405ac2b223c8c6ebff428c1
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Mon Aug 13 07:28:18 2012 +0200

    value-pairs: clarified some error messages
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 3df8c3c8dd01bea1422351dd20cdc1786be8f5f5
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sun Aug 12 16:51:51 2012 +0200

    msg_parse_lib: rearranged includes
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 89fab67fd68bad13c5b6f03eb5d17716923019a0
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sun Aug 12 16:50:45 2012 +0200

    cryptofuncs: refactor hash related tests to a separate unit test program
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit e7538a5e474ba99cdd0e101ace7f177432d54efb
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sun Aug 12 16:17:43 2012 +0200

    $(hash): New template function to calculate the hash of its inputs
    
    This patch adds a family of new template functions called
    $(hash), $(md5), $(md4), $(sha1), $(sha256), $(sha512)
    
    These can be used to calculate the cryptographic hash of its arguments.
    
    As it uses the SHA1() function from OpenSSL, it is only available if syslog-ng
    is compiled using --enable-ssl.
    
    One use case for it can be when you'd like to anonymize sensitive parts of the
    log message (eg. the user name) you parsed out using patterndb before storing
    or forwarding it for further analysis but would like to retain the ability to
    correlate messages along this value. Beware though that such simple anonymization
    can be broken if there's enough data available, see
    
        http://arxiv.org/pdf/cs/0610105v2.pdf for references and examples.
    
    Another use-case is to generate quasi-unique-ids for data, using the
    --length option that truncates the length of the hash to a shorter form.
    In real life the chances of the collision is slim, but still makes it
    possible to use a shorter id, than in most cases is unique, especially
    when constrained to a time period, which is often the case for logs.
    
    Syntax:
      $(<method> [opts] $arg1 $arg2 $arg3...)
    
    Options:
      --length N, -l N    Truncate the hash to the first N characters
    
    The generic name "hash" refers to md5. Arguments are concatenated w/o the
    use of additional characters.
    
    Thanks for the original idea to Martin Grauel.
    
    Signed-off-by: Peter Gyongyosi <gyp@balabit.hu>
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 58e9f31a6b6b5d1473b77e71f67a5b587a83149b
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sun Aug 12 16:10:36 2012 +0200

    tfuuid: rename to cryptofuncs
    
    Some further crypto related functions are to be added to syslog-ng, I'd
    like to avoid the profileration of modules just for single functions.
    
    Thus "cryptofuncs" is born, a place for stuff that depeeds on OpenSSL.
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 1850cd996a1faf066d0e508a5f9f56dbaa1db4de
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sun Aug 12 15:21:56 2012 +0200

    ivykis: updated to latest commit in ivykis-0.30 branch
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit d32b5c63e09a4c3897cbc2239c07967cea393de9
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Fri Aug 10 10:44:51 2012 +0200

    Preparations for 3.3.6.
    
    NEWS & VERSION updated to 3.3.6.
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit 19f6cac7cd8fb8e3cffbcc47e6ef241fcdc66759
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Mon Jul 23 11:46:04 2012 +0200

    afsocket: handle max_connections validation properly on SIGHUP
    
    In case a SIGHUP was processed, the num_connections variable got reset to
    zero, which made it possible to accept connections excess the
    max-connections() option. This patch fixes that by properly setting
    the number of connections after reload.
    
    Reported-By: Sandor Geller <wildy@muhelybt.hu>
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 1dfc28c85c6c7058578fd512ea98fb21ab2b6e03
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Mon Aug 6 15:58:51 2012 +0200

    afinet: Disable KEEP_ALIVE when using spoof source
    
    Disabling KEEP_ALIVE when using spoof source will result in rebuilding
    the writer at reload, thus, also resolving the destination. This fixes
    the issue of never resolving the destination after a reload, and
    ending up sending packets to 0.0.0.0.
    
    Patch from Balazs Scheidler <bazsi@balabit.hu>, after debugging the
    problem in person, and going through all the different options.
    
    Reported-by: Marvin Nipper <marvin.nipper@stream.com>
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit bf69c41f696e7d94e424a40f5979bd5efcb33179
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Fri Jul 27 07:42:18 2012 +0200

    msg-format: make sd_param_value maximum length adjustable via API
    
    Although this option is not (yet) introduced in the configuration file,
    the unit tests also try to cover the 'too-long-sdata' case, which is
    inpractical in case the new 64k default is to be overflown.
    
    It might make sense to make this value actually controllable by
    the configuration file, but for now I think it is enough to simply bump
    the default limit to 64k.
    
    This patch also fixes the test_msgparse unit test so it passes again.
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit ab9c013f7f06cbb024cae52905659450ddbdfaf1
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Wed Jul 25 18:39:45 2012 +0200

    syslog-format: increase the limit for SDATA value length to 64k
    
    Reported-By: Sergey <cloun-rulez@yandex.ru>
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit c4ab6f23b573cf286564a2f5a0d2bbbcbf692a94
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Mon Jul 23 11:46:04 2012 +0200

    afsocket: handle max_connections validation properly on SIGHUP
    
    In case a SIGHUP was processed, the num_connections variable got reset to
    zero, which made it possible to accept connections excess the
    max-connections() option. This patch fixes that by properly setting
    the number of connections after reload.
    
    Reported-By: Sandor Geller <wildy@muhelybt.hu>
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit fa922c18667ee09e84d2f13812bc08c021278b6e
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sun Jul 22 08:28:46 2012 +0200

    syslog-ng/main: refactor interactive command line setup into a separate function
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 7b0e44636ff5d4b3810496b3346a6b26408ac25d
Merge: 0129388 cea9aa7
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sun Jul 22 08:25:13 2012 +0200

    Merge remote-tracking branch '3.3/master'
    
    Conflicts:
    	.gitmodules
    	NEWS
    	VERSION
    	configure.in
    	lib/Makefile.am
    	lib/ivykis

commit 0129388dcf30c5e4a27f4a4456da5f1eae0fefa7
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sun Jul 22 07:29:00 2012 +0200

    afsql: use the push_head method of LogQueue instead of using pending_msg
    
    Instead of using a special pending_msg variable to store the last
    unsuccessfully-flushed element, push it back to the queue backlog.
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 02b672e17241fcd1eadc26aa24d760e29ed59cc6
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sun Jul 22 07:43:18 2012 +0200

    test_logqueue: added coverage for log_queue_push_head()
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 9e26eb7a9e3fd58e9a4c4ac5e930e06bb82434f0
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sun Jul 22 07:42:51 2012 +0200

    test_logqueue: fixed memory leaks so this becomes valgrind clean
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit bbb60db83c3db7bf2b560c126151832b078a4234
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sun Jul 22 07:41:41 2012 +0200

    LogQueue: fixed a memory leak in log_queue_fifo_push_head()
    
    log_queue_fifo_push_head() is used by various drivers to push one item in
    the front of the queue, but unlike log_queue_fifo_push_tail(), this one
    didn't consume the passed reference.
    
    This patch fixes this API breakage to behave the same as push_tail(),
    and I also reviewed all the call-sites. Except for LogWriter that
    was fixed just recently all others misused this part of the API. This
    by itself would explain the change.
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 8ebee82ed5ca882847a10e2f35d5aaab5e09cf1c
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sun Jul 22 07:42:08 2012 +0200

    test_logproto: fixed include to reflect the latest rename
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit cea9aa75bf434dbc430d8aae028063ecb0f60392
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sat Jul 14 11:27:32 2012 +0200

    LogProtoDGramServer: encoding is to be applied to individual frames
    
    Instead of trying to make up missing characters in one frame from the next,
    treat them individually, especially as they might come from a different
    source.
    
    The same change is applied to LogProtoRecordServer used to read binary
    files.
    
    Cc: <syslog-ng-stable@balabit.hu>
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit b70b16aebbcefdcf009c3f436a287bd06f67838d
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sat Jul 14 11:02:50 2012 +0200

    LogProtoFramedServer: fixed an incorrect error message
    
    This patch changes the generic I/O error message to reflect that it
    actually can apply to the framed data as well as the header.
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit ed11453d731739afaa61bf439566cde7a265898d
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sat Jul 14 10:51:41 2012 +0200

    LogProtoTextServer: fixed a possible memory leak in case encoding() was used
    
    In case encoding was used on a source, its related data structures were
    not properly freed as the destructor function wasn't properly registered.
    
    Cc: <syslog-ng-stable@balabit.hu>
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit bc72d5997f3e1125466960b972e4965b74d183df
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sat Jul 14 10:50:03 2012 +0200

    LogProto: fixed a bug in fixed-size-encoding detection
    
    Due to a typo, fixed-size encodings were not properly recognized, causing
    syslog-ng to use the slow-path in case encoding() was used on a source.
    
    This change fixes that issue, and at the same time publishes the function
    log_proto_get_char_size_for_fixed_encoding() so that its unit test can call
    it directly.
    
    Cc: <syslog-ng-stable@balabit.hu>
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit adf59394d87aabe00a4424ea4eb88235be723e75
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Wed Jul 4 15:03:22 2012 +0200

    logproto: refactor fixed encoding lookup into a separate function
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 4f9692533b02e6aa4da591c14b5ed617723693c1
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Wed Jul 4 15:02:14 2012 +0200

    log_proto_buffered_server_apply_state: fixed a complete source-file-resend in case encoding is used
    
    The size of the raw data can grow up to max_buffer_size and at reload time
    raw_buffer_size was validated against init_buffer_size, which is clearly
    wrong as the buffer can grow at runtime.
    
    Signed-off-by: Juhasz Viktor <jviktor@balabit.hu>
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 857a8e15bf480de636525a1acabebb46fd9d072a
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Mon Jul 2 21:15:27 2012 +0200

    afsql: Create proper indexes for Oracle DBs.
    
    When creating an index for an Oracle DB, the field name was enclosed
    in apostrophes, which made Oracle very unhappy: it did not associate
    the index with the intended field.
    
    With other databases, the field name is not quoted in the CREATE INDEX
    statement, and for Oracle, it shouldn't be, either.
    
    This patch corrects the mistake, and removes the apostrophes in the
    Oracle case too.
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 9af8e7c01236a06148f7ea7bbff459356dcd874c
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sat Jul 14 14:14:36 2012 +0200

    reorganize unit tests
    
    This patch reorganizes unit tests a bit:
      - a separate libtest is created to hold unit test specific helper code
      - the unit test for csvparser is moved to its module directory
      - configure.in & Makefile.am files updated to work
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 81e2c83ee22a3c4f0ddb735cdd6de98da63431ad
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sat Jul 14 13:38:23 2012 +0200

    test_logproto: add new unit test to cover LogProto server implementations
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 2d1896644e4af30d4477f38d8969ea1eb671b660
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sat Jul 14 13:34:10 2012 +0200

    tests: added support for assertions on internal messages
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 7e7211c8a63d0d29292a440ba80bb95ba016db8a
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sat Jul 14 13:33:32 2012 +0200

    tests: cleaned up includes in testutils
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 113646125dc7f8446e0714a0f455f66ec9de418f
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sat Jul 14 13:31:48 2012 +0200

    tests: added support for comparing fixed length strings to testutils
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit e75459e8000b916184692754eb350c147a6a5d4b
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sat Jul 14 13:29:25 2012 +0200

    tests: use proper version for configuration in msg_parse_lib
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 8e9c0c364a69063554cbad52aa6779627619aad1
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sat Jul 14 11:28:26 2012 +0200

    apphook: explicitly deinit a number of subsystems at shutdown
    
    To get away with a number of leaks in unit tests.
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 5b172e2ef36817d6f93be381e048767669b6d503
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sat Jul 14 11:27:32 2012 +0200

    LogProtoDGramServer: encoding is to be applied to individual frames
    
    Instead of trying to make up missing characters in one frame from the next,
    treat them individually, especially as they might come from a different
    source.
    
    The same change is applied to LogProtoRecordServer used to read binary
    files.
    
    Cc: <syslog-ng-stable@balabit.hu>
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 11e88f8eaa96693f899251bf886e67e3531f3025
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sat Jul 14 11:02:50 2012 +0200

    LogProtoFramedServer: fixed an incorrect error message
    
    This patch changes the generic I/O error message to reflect that it
    actually can apply to the framed data as well as the header.
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 16dee0bb7e386ada59373941be94f75404e8cfcc
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sat Jul 14 11:02:04 2012 +0200

    LogProtoFramedServer: change dynamic buffer allocation
    
    Until now the buffer of LogProtoFramedServer class implementing
    RFC5424 style framing was sized in accordance to the maximum frame length
    processed by the class. More exactly it was sized as "max_frame_len + 10".
    
    This could mean that if most of the messages are about the same size, that
    the buffer is limited to hold one single message. This is certainly not
    the best for performance, so be a bit more liberal when allocating this
    buffer size, it is scaled to hold 16 messages, but at the same time limited
    to 6*log_msg_size().
    
    This is 48k buffer space for the default log_msg_size() value of 8k and
    matches exactly with the buffer size used by LogProtoTextServer.
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 9d905c5e7ccb37f7efed2e7fca3b4b6dd8f500b1
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sat Jul 14 10:56:21 2012 +0200

    LogProtoBufferedServer: fixed a SockAddr caching problem that shouldn't be user-visible
    
    The log_proto_buffered_server_fetch() function improperly NULLed the
    cached GSockAddr instance every time it attempted to read. However that
    forthcoming read may return EAGAIN, which causes the sockaddr to remain
    NULL.
    
    In case an EOF is read the next time, log_proto_fetch() will return NULL as
    the originating sockaddr for the partial message still in the buffer.
    
    This bug shouldn't bite anyone as the cached sockaddr is only used for
    udp() sources, but which in turn don't have partial messages nor EOFs.
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 2f3dfdc1f29b1beee2ced1c4b03d7b54a213cbb3
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sat Jul 14 10:51:41 2012 +0200

    LogProtoTextServer: fixed a possible memory leak in case encoding() was used
    
    In case encoding was used on a source, its related data structures were
    not properly freed as the destructor function wasn't properly registered.
    
    Cc: <syslog-ng-stable@balabit.hu>
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 72dd3bf95e635a26728d8155691dce3eae44b4fc
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sat Jul 14 10:50:03 2012 +0200

    LogProto: fixed a bug in fixed-size-encoding detection
    
    Due to a typo, fixed-size encodings were not properly recognized, causing
    syslog-ng to use the slow-path in case encoding() was used on a source.
    
    This change fixes that issue, and at the same time publishes the function
    log_proto_get_char_size_for_fixed_encoding() so that its unit test can call
    it directly.
    
    Cc: <syslog-ng-stable@balabit.hu>
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 84e4ac3e8037440d7cd2b4f2fd8d7cf13fd90e58
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Wed Jul 4 15:03:22 2012 +0200

    logproto: refactor fixed encoding lookup into a separate function
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 06b6f302bf111458dd7e626a53fe793343c0a2e5
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Wed Jul 4 15:02:14 2012 +0200

    log_proto_buffered_server_apply_state: fixed a complete source-file-resend in case encoding is used
    
    The size of the raw data can grow up to max_buffer_size and at reload time
    raw_buffer_size was validated against init_buffer_size, which is clearly
    wrong as the buffer can grow at runtime.
    
    Signed-off-by: Juhasz Viktor <jviktor@balabit.hu>
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 44587f8dddbee4881bd3655b9c96e2a0b568537a
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Tue Jul 3 17:52:39 2012 +0200

    Preparations for 3.3.5.90
    
    NEWS & Version updated for the 3.3.5.90 (3.3.6 Release Candidate)
    release.

commit 28a669492084416edca09096535870ab9cfcd3b3
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Tue Jul 3 17:29:44 2012 +0200

    Update to, and require ivykis 0.30.1
    
    Now that ivykis 0.30.1 is out, update configure.in to require that
    version, and the git submodule to include it.
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit b9d144bb5e89d271152ac116dd3188b69366cc9c
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Mon Jul 2 21:15:27 2012 +0200

    afsql: Create proper indexes for Oracle DBs.
    
    When creating an index for an Oracle DB, the field name was enclosed
    in apostrophes, which made Oracle very unhappy: it did not associate
    the index with the intended field.
    
    With other databases, the field name is not quoted in the CREATE INDEX
    statement, and for Oracle, it shouldn't be, either.
    
    This patch corrects the mistake, and removes the apostrophes in the
    Oracle case too.
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 718249b6da576418ed876d7fb915be671fc6e180
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Mon Jul 2 21:14:01 2012 +0200

    configure: fixed bashism in systemdsystemunitdir support
    
    Signed-off-by: Tamas Pal <folti@balabit.hu>
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 77df2c184124d5b7bc9139d60a550fbb11638713
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Sun Jul 1 17:50:54 2012 +0200

    Fix the eventlog context initialisation
    
    A regression introduced a few patches earlier, that meant to bring
    eventlog context initialisation earlier broke the test suite.
    
    To fix both problems, app_startup() will call msg_init() once again,
    and msg_init() was made idempotent: once called, it will be a no-op if
    called another time. This allows us to initialize the context early so
    syslog-ng --version will continue working in debug mode, yet, still
    allow tests to call app_startup() only, without another explicit call
    to msg_init().
    
    Reported-by: Jose Oliveira <jpo@di.uminho.pt>
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit ee6a3fac72ef72efe0656ef6ed65921720ae3866
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Sun Jul 1 17:07:07 2012 +0200

    configure.in: Check for utmp.h too
    
    Check the existence of utmp.h too at configure time, because code
    relies on this check already. This makes it so that the getutent()
    compatibility function gets used on FreeBSD 8, and makes afuser
    loadable again.
    
    Reported-by: Peter Czanik <czanik@balabit.hu>
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit 902071881197383731cf428194ef2de9551b79ac
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Sat Jun 30 15:22:10 2012 +0200

    lib/ivykis: Update to a new upstream commit
    
    Updated the lib/ivykis submodule to point to an upstream commit that
    has a deadlock triggered by syslog-ng fixed.
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit 426632a3bdb309260540af8508ad268cff6dc036
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Fri Jun 29 13:00:37 2012 +0200

    lib/: Use upstream ivykis
    
    This patch converts syslog-ng to use upstream ivykis,
    unmodified. Apart from the boring struct and type renaming stuff,
    there is one major change: iv_fd_pollable() is gone, we have
    iv_fd_register_try().
    
    As such, the logic in log_reader_start_watches() and
    log_writer_start_watches() was updated to use the upstream API
    instead.
    
    The control socket code was also updated to use iv_fd_register_try(),
    because we want synchronous registration in that case, and
    iv_fd_register_try() provides that for us.
    
    Furthermore, we now use iv_set_fatal_msg_handler() to print ivykis
    errors to stderr, instead of syslog (this is functionally equivalent
    to what the balabit-patched ivykis did).
    
    The included ivykis is also updated to 0.30 (+ two small patches), and
    the minimum ivykis requirement when compiling with a system ivykis has
    been increased to 0.30 aswell, and the linking magic updated to use
    the combined libivykis, and not search for ivykis-modules anymore.
    
    And since the git submodule now points to upstream, and the
    configure.gnu for ivykis is generated by our own autogen.sh, we need
    to get that into the dist tarball. This is accomplished by including
    it in lib/Makefile.am's EXTRA_DIST.
    
    Many thanks to Lennert Buytenhek <buytenh@wantstofly.org> and Balazs
    Scheidler <bazsi@balabit.hu> for their invaluable help.
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit 2c25c62dffae70b6da4224ea7bfa19ce00d83964
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Tue May 8 12:02:08 2012 +0200

    autogen.sh: Create configure.gnu ourselves in submodules
    
    To make it easier to use upstream git repos as submodules, which do
    not have configure.gnu, create those from within autogen.sh.
    
    This way, it becomes much easier to switch to an upstream repo, and
    still continue reaping the benefits the configure.gnu brings us (such
    as forcing a static linkage).
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit b20845045802507385d22b271ddf2b8dfd3e886f
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Mon May 7 22:57:25 2012 +0200

    Do not link anything but libsyslog-ng against ivykis
    
    There is no need to link anything but libsyslog-ng against ivykis: the
    rest will have the symbols available via libsyslog-ng, and linking
    again can trigger constructors, which is not something we want.
    
    For this reason, this patch stops libsyslog-ng-crypto from being
    linked to ivykis directly.
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit d10412a607e163abdd0fe3ad916ffff4574075cf
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Sun Jul 1 01:07:06 2012 +0200

    Allow --version to work in debug mode
    
    In debug mode, we use msg_debug(), but the eventlog context does not
    get initialized at the time --version is handled. Thus, syslog-ng -d
    -V will segfault, which isn't exactly useful.
    
    This patch moves the eventlog context initialization earlier, and
    thereby fixes the issue.
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit 709ab1252920063e6d4d0d610ad5c1ee5ebdfb75
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sat Jun 30 06:22:13 2012 +0200

    Revert "lib/ivykis: Point the submodule to github"
    
    This reverts commit 5a0f89cc47e890e7975b3d1dfb35a4d02b668486.

commit d916b56844976431124ff708e45742aa8a05a9af
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sat Jun 30 06:18:49 2012 +0200

    further preparations for 3.4.0alpha3

commit c5074e30980c40bc004ed7f6cd55afbf71925f83
Merge: ec788b6 b67ee8a
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Fri Jun 29 19:55:07 2012 +0200

    Merge remote-tracking branch '3.3/master'
    
    In addition to the merge:
      * updated the version check in afunix.c to use the new
        version related functions
    
    Conflicts:
    	lib/Makefile.am
    	lib/logreader.c
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit ec788b6016f1f4045583935ad77da2e485137849
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Fri Jun 29 16:10:05 2012 +0200

    fixed unit test compilation without json-c

commit b15f5f26f2c69f7d590214728a06c85b598efbe5
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Fri Jun 29 15:43:42 2012 +0200

    preparations for 3.4.0alpha3

commit c38d7ad9a2d40650e243ec29c6b3ee07233d31a8
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Fri Jun 29 15:23:58 2012 +0200

    implement mark-mode() globally and on a per-destination basis
    
    the new mark-mode() option can be used to change how MARK messages are
    generated. The following mar-modes are available:
    
     * mark-mode("internal"): old style, MARK messages are generated in the internal() source
     * mark-mode("periodical"): regardless of other messages, MARKs are generated periodically
     * mark-mode("dst-idle"): generate a MARK if a destination was idle
     * mark-mode("host-idle"): generate a MARK if the host running syslog-ng had no local messages
     * mark-mode("none"): no MARK messages at all
     * mark-mode("global"): use the global mark-mode setting
    
    The default for global mark-mode is "host-idle", network destinations
    inherit this by using "global", file destinations don't store MARKs by
    using "none".
    
    Signed-off-by: Attila Nagy <naat@balabit.hu>
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 69c9aa32e463c80d82dde9bc3cdc2e297216192b
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Wed Jun 27 17:27:00 2012 +0200

    MlBatchedTimer: refactor batched timer updates to a separate class
    
    MlBatchedTimer is a MainLoop dependendent class that batches the updates
    to be applied to a timer. Since timer-updates must make a round-trip to
    the main thread, performing it is quite expensive, especially latency wise.
    
    This class skips most of the updates, so that timer-updates can be performed
    in worker threads, a skipped update is a lockless operation (at the cost
    of some inaccuracy).
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit b67ee8aa6335318146b79acdef45c90f6aecbc04
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Fri Jun 29 11:42:30 2012 +0200

    patterndb: Fix a NULL dereference in certain cases
    
    In patterndb, all of the context-* properties are optional, yet, in
    certain cases where they were only partially set (eg, context-id and
    context-time set, but context-scope not), running an action ended up
    with syslog-ng trying to dereference a NULL pointer.
    
    This patch corrects that mistake, by teaching pdb_rule_run_actions()
    to only dereference the context if it is non-NULL. The bulk of the
    function handled the case well, just not the initial condition that
    governs the core of the function.
    
    Reported-by: Imre Lazar <imre@balabit.hu>
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit 96001b34b015e04b76e52fd7c7989a2eb529a887
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Fri Jun 29 08:33:36 2012 +0200

    logproto: Move LogProtoStatus into LogProto itself
    
    Move the LogProtoStatus from LogProtoBufferedServer into LogProto
    itself, so it can be reset or acted upon on a higher level. This
    allows us to move the error state handling to logo_proto_fetch, and it
    also allows us to clear any error state on a higher level.
    
    With these changes, syslog-ng will correctly handle character encoding
    issues on dgram sources: drop and the line with error, but clear the
    error state and continue afterwards.
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit f7606b94d1479cd32cadbbe6f83492a5639cb305
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Thu Jun 28 23:14:19 2012 +0200

    configure.in: Fix two typos in various help messages
    
    There was a typo in the help message of --with-ivykis and
    --with-libmongo-client, but no more.
    
    Reported-by: Jose Pedro Oliveira <jpo@di.uminho.pt>
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit c4037219d3cbffab62a8bbe17fbf96e336f40f2e
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Fri Jun 22 12:12:12 2012 +0200

    afprog: Completely rebuild the writer on SIGHUP
    
    When syslog-ng receives a SIGHUP, it restarts the program()
    destinations, by sending them a SIGTERM, and starting a new
    one. However, programs that ignore signals, and watch only their
    stdin, remain running in this case, which is unfortunate.
    
    To remedy the situation, and because we're already restarting the
    program destinations, unref the writer, thus triggering the closing of
    the file descriptor too. This way, we'll rebuild self->writer from
    scratch on each HUP, but due to restarting the program anyway, this is
    no big deal.
    
    Reported-by: Evan Rempel <erempel@uvic.ca>
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit cf837d4502dbdab935ee1cf7551c2aa2e5b2f56f
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Fri Jun 22 13:48:37 2012 +0200

    doc/man: Properly escape hyphens in the manual pages
    
    When overwriting the installation paths in the manual pages, make sure
    any possible hyphens are correctly escaped.
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit 66f4bdc692721849a4730e463250d02f6184a3da
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Fri Jun 22 13:36:14 2012 +0200

    doc: Make the man page building more robust
    
    Instead of hardcoding the full xsltproc commandline and repeating the
    same thing eight times with very little change, only store the
    stylesheet in a variable (XSL_STYLESHEET), and call xsltproc ourselves.
    
    Furthermore, since xsltproc refuses to output to stdout, put the sed
    magic into a separate transformation step, which will also mean that
    our man pages will have correct paths. Also adjusted the regexp
    slightly, so it catches escaped hyphens in the manpage too.
    
    Doing things this way also has the advantage of failing properly if
    the manual page generation fails for one reason or the other, instead
    of only at install/dist time.
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit 8252e6dbf2ed881813fec2bb7ee2ee418ff63f2e
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Fri Jun 22 10:16:34 2012 +0200

    systemd: Add a Documentation= field to the unit file
    
    This will allow systemctl help syslog-ng.service to bring up the
    manual page.
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit d2369ec9f7662ad002155aecdde8d0e31fd21106
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Fri Jun 22 10:03:29 2012 +0200

    systemd: No need to stop systemd-kmsg-syslogd anymore
    
    When the Journal was introduced, systemd-kmsg-syslogd.service was
    discontinued, so there is no reason to try and stop it anymore.
    
    Reported-by: Jose Oliveira <jpo@di.uminho.pt>
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit a1567ce7c320c42d65456b6b9123bdcfdecbde00
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Fri Mar 30 11:42:07 2012 +0200

    cfg-lexer: Implement glob-based @include.
    
    Both for distributions and otherwise, the ability to limit what kind
    of files are included, especially when doing a directory include is
    very important.
    
    This patch implements just that, by extending cfg_lexer_include_file()
    to try and resolve globs, if it can't find a file otherwise. Files
    included this way still respect the global include-path setting, so
    @include "foo.d/*.conf" will still work.
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit ce15af467f89e1a5dc52605a117f5ab275bdc6a3
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sat Mar 31 21:59:39 2012 +0200

    cfg-lexer: Split cfg_lexer_include_file() into two functions
    
    To be able to keep the code simple in the future, split
    cfg_lexer_include_file() into two: the intent is that we'll check if
    the file exists, and if not, try the same thing as a glob, otherwise
    continue as we did before.
    
    This would nest too deep, so split out the current bulk into a
    separate function.
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 5a0f89cc47e890e7975b3d1dfb35a4d02b668486
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Fri Jun 15 14:51:53 2012 +0200

    lib/ivykis: Point the submodule to github
    
    Point the lib/ivykis submodule to github.com/balabit/ivykis instead,
    and update it to the most recent commit.
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit c70cb00af3ccc5bab6e3f8a556f4b5db8fae628e
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Fri Jun 15 14:48:56 2012 +0200

    lib/eventlog: Remove the lib/eventlog submodule
    
    It accidentally went in with an unrelated change, and was never really
    hooked in.
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit fab6e5cafff3f15c1d0e41c7c4bc4d7a46d1517c
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Fri Jun 15 08:06:48 2012 +0200

    [doc/Makefile.am] Add the xsd/patterndb-4.xsd to the install definition
    
    The definition for the xsds overlooked the new version 4. Added the
    xsd/patterndb-4.xsd to the xsd_DATA definition so that make install
    will install all 4 xsd definitions.
    
    Reported-By: Evan Rempel <erempel@uvic.ca>
    Signed-Off-By: Evan Rempel <erempel@uvic.ca>
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit c0afec5b46eb3508fd3b1449e37b7e550f7d35e2
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Fri Jun 8 15:28:33 2012 +0200

    dnscache: Fix a memory corruption when destroying the DNS cache
    
    The DNS cache gets destroyed every time a worker thread quits, which
    is fine, as most of the dns cache variables are thread local.
    
    However, dns_cache_hosts is not, it's a global static, and
    dns_cache_destroy() was freeing that aswell.
    
    The solution is to not free dns_cache_hosts when a worker stops, but
    do so when syslog-ng stops. This patch introduces dns_cache_deinit()
    which does just that, and removes the same thing from
    dns_cache_destroy(), which now only touches thread-local variables.
    
    Reported-by: EgonB <egon@local.ee>
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit 3f2829349d0983ff3ac7cbd7a50ac4c31d277c00
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Fri Jun 8 13:06:05 2012 +0200

    afuser: Use utmpx when available, instead of utmp
    
    FreeBSD 9 removed support for utmp, and one must use the
    POSIX-specified utmpx instead. The same utmpx is available on Linux
    too (and it is the same as utmp there).
    
    The patch below converts afuser to use utmpx when available, utmp
    otherwise. It is based on the post-build sed magic applied to
    syslog-ng within the FreeBSD ports collection, with other bits based
    on a patch from Alex Zimnitsky.
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit cef41df424cacbee8e2b1df3627fec869a6633b7
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Fri Jun 8 09:56:47 2012 +0200

    LogWriter: rename message duplication related functions
    
    This makes their goal easier to understand.
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 8c36bfb99a7bdbf69216ca6637b51b8276fdd626
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Fri Jun 1 10:02:31 2012 +0200

    tests: Include /usr/lib64 in the dbd search path
    
    Certain systems put 64-bit libraries into /usr/lib64, so include that
    directory in the dbd search path for the tests. Thanks to Jose
    Oliveira <jpo@di.uminho.pt> for the patch!
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit 046f90e76137f31e61412d24b9920914ad75edc5
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sun May 27 14:24:52 2012 +0200

    syslog-format: added support for Cisco style sequence numbering
    
    Cisco routers can specify some additional information in their timestamp:
      - a sequence number (to be parsed into $SEQNUM)
      - whether the timestamp is accurate
      - whether the sender has TZ information
    
    The parser code adds this information in standard RFC5424 name-value pairs,
    .SDATA.timeQuality.isSynced and tzKnown
    
    Signed-off-by: Viktor Juhasz <jviktor@balabit.hu>
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit b9b10efbc67497d040cddbf0261ecbefbb861cfe
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Thu May 17 13:06:30 2012 +0200

    cfg_is_config_version_older(): introduce functions for easier to read config version checks
    
    This patch implements a couple of functions to validate that the user is
    running a given configuration version. It also adds macros to name syslog-ng
    version in log messages for easier sync between syslog-ng and its forks.
    
    Signed-off-by: Viktor Juhasz <jviktor@balabit.hu>
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit f5753612abadf929c900786aaabaffbe8a470455
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Thu May 17 09:58:19 2012 +0200

    rpm: Do not try to install the removed README
    
    Reported-by: Mark Ulmer <mark.ulmer@apollogrp.edu>
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit cdf8bba6fcdc0aa73e284b9fe29d99391030fcfe
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Fri May 4 10:59:56 2012 +0200

    afsmtp: Fix afsmtp linking when configured with --with-libesmtp
    
    In case configure received a --with-libesmtp=/path option, we forgot
    to add -lesmtp to LIBESMTP_LIBS, which resulted in afsmtp getting
    compiled, but not linked to libesmtp, which is obviously not
    desirable.
    
    This patch fixes that, and adds the -lesmtp.
    
    Reported-by: Peter Czanik <czanik@balabit.hu>
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit 11a09867a7e228881200cdec485319c3a9a820b6
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Sun May 13 22:00:15 2012 +0200

    scratch-buffers: Fix a compiler warning
    
    Include misc.h for g_string_steal(), so that the compiler stops
    complaining about an implicit declaration.
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit 11f4ed960dcf7bc8ac053378fd1527870eaf7983
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Fri Sep 16 12:00:58 2011 +0200

    db-parser(): add support for storing values extracted from the program name portion
    
    Previously, only the values extracted from the $MSG portion was used
    to populate the message. This patch makes it possible to use parsers
    in the program name field and name-value pairs extracted from $PROGRAM
    will be also set in the message if a match occurs.

commit 9546e07bd8f2f3c7f4ed52968797d1d85d46c926
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sun May 13 17:03:59 2012 +0200

    templates: introduce SYSUPTIME macro
    
    It expands to the number of 1/100th of a second since syslog-ng startup,
    should be compatible with SNMP sysUptime values.
    
    Signed-off-by: Viktor Juhasz <jviktor@balabit.hu>
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit fce73521639e1e54bd81bd8286d13e2e30ed6824
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Thu Sep 15 13:54:15 2011 +0200

    templates: introduce USEC/MSEC time macros

commit 7cfde7e2060f00df51fcb01276a7ade3c1957641
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Thu Sep 15 13:53:14 2011 +0200

    templates: introduce AM/PM related time macros

commit 24c7478f031b503134056e372040d4c8cffa7aa4
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Thu Sep 15 13:33:47 2011 +0200

    tls_x509_format_dn(): declare in the header
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 720a5675dd5e632803ef8c5b5ed8464b57645a96
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Wed Sep 14 16:23:05 2011 +0200

    log_msg_nv_table_foreach: new function

commit 2180256f8603a302f98684318d3067e6a42fd46e
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Wed Sep 14 16:22:30 2011 +0200

    log_msg_get_handle_name: new function

commit 9e959b15a5f9b0630c98ede7e48a909fa31db178
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Wed Sep 14 15:45:06 2011 +0200

    log_reader_reopen(): make it possible to create a LogReader object without "proto"

commit 1581de3a349c7cd08caeed56e637aa501b38f5d9
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sun May 13 16:34:32 2012 +0200

    persist-state: add persist_state_rename_entry()
    
    This patch adds a new function to rename an existing persist-state key.
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 2eef3f5f3d969db5bf44c50b78a8f9d4b0fdcf1f
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sun May 13 16:33:02 2012 +0200

    LogReader/Writer: don't perform work in non-threaded during reload
    
    When a reload request is already initiated, don't start a new "work"
    in LogReader/LogWriter. This makes reload/exit operations somewhat faster.
    
    Signed-off-by: Viktor Juhasz <jviktor@balabit.hu>
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit dbfc845ac5af27c281ef3e717a67d17efba87e70
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sat May 12 20:18:05 2012 +0200

    test_msgparse: fixed possible null deref
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 346166ce5f5a26bbfff4a1db63f5e363552b197b
Author: Attila Magyar <athos@balabit.hu>
Date:   Mon May 7 17:14:12 2012 +0200

    [testutils]: testcase details can be shown when an assertion fails (fixes: #B-06841)
    
        The new macro testcase_begin() accepts a printf()-style description
        template and an arbitrary number of arguments detailing the currently
        running testcase. The information gets stored in memory so it can be
        displayed on screen automatically when an assertion fails. Testcases marked
        by testcase_begin() must be closed with testcase_end()
    
    Signed-off-by: Attila Magyar <athos@balabit.hu>
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 4896732b4cb3990de3cebc761f1fbc389b7e66d0
Author: Attila Magyar <athos@balabit.hu>
Date:   Fri May 4 19:39:50 2012 +0200

    [test_msgparse]: took the first steps of understanding and refactoring this monster (fixes: #B-06841)
    
        * Simplified testcase() by extracting assertions and small ugly-detail
          functions from it, which also resulted in lower redundancy around
          message serialization checks.
        * Merged many of the extracted functions with assertions refactored in
          test_clone_logmsg.
    
      Possible steps to continue:
    
        * By replacing TEST_ASSERT with more accurate assertion functions from
          testutils, we lost the capability of printing the actual testcase in
          case of failure. This could be solved for example by introducing a new
          functionality in testutils: to mark the beginning and the end of a
          testcase.
        * Many of the calls of testcase() are very similar, which may enable
          changing testcase() to accept a raw msg string, some parsing related
          options and an expected LogMessage object. Then
          test_log_messages_can_be_parsed() could be refactored to initialize an
          expected_log_message object once, then change separate fields on an
          incremental basis for each new test log message.
        * Introducing that expected_message object mentioned above would be even
          more useful since with slight changes in msg_parse_lib (e.g. extracting
          a function named assert_log_messages_equal_except_timestamps() from
          assert_log_messages_equal()) the assertions in the beginning of
          testcase() could be replaced by a simple assert_log_messages_equal()
          call.
    
    Signed-off-by: Attila Magyar <athos@balabit.hu>
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 5b7221f6654530e070646d6324102eb8a35948ab
Author: Attila Magyar <athos@balabit.hu>
Date:   Fri May 4 18:23:06 2012 +0200

    [testutils]: assertion error messages made optional (fixes: #B-06841)
    
    Signed-off-by: Attila Magyar <athos@balabit.hu>
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 35a9060dd76e2394fbcfc5c23f05d6430a917002
Author: Attila Magyar <athos@balabit.hu>
Date:   Fri May 4 18:08:48 2012 +0200

    [test_clone_logmsg]: extracting reusable functions to a separate library (fixes: #B-06841)
    
    Signed-off-by: Attila Magyar <athos@balabit.hu>
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 47c9c7cf17cf6c38d92209b64cdff3e465a8dbc6
Author: Peter Gyorko <gyorkop@balabit.hu>
Date:   Fri May 4 15:42:39 2012 +0200

    test_clone_logmsg: fixed minor things based on the review notes (fixes: #B-06841)
    
    Signed-off-by: Peter Gyorko <gyorkop@balabit.hu>
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit d6ae411defa2d3ee038153e43beb779ffdf0c502
Author: Peter Gyorko <gyorkop@balabit.hu>
Date:   Fri May 4 14:43:48 2012 +0200

    unit: reimplemented test_clone_logmsg unit test (fixes: #B-06841)
    
     * Added assert_guint16() to testutils.c.
    
    Signed-off-by: Peter Gyorko <gyorkop@balabit.hu>
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 475b3fb69af999ffd7bcddeb8e1ccf8c1aaaf9aa
Author: Peter Gyorko <gyorkop@balabit.hu>
Date:   Fri May 4 14:42:33 2012 +0200

    unit: extracted init_and_load_syslogformat/deinit() to msg_parse_lib.h (fixes: #B-06841)
    
    Signed-off-by: Peter Gyorko <gyorkop@balabit.hu>
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit f283beaf59925b66bf5ca30d84772441ded7a974
Author: Juhasz Viktor <jviktor@balabit.hu>
Date:   Fri May 4 10:57:36 2012 +0200

    [test_msgsdata] testcase refactoring to use testutils
    
    Signed-off-by: Juhasz Viktor <jviktor@balabit.hu>
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 91637459eede261d723ffd58faadecd0f16f1e6f
Author: Peter Gyorko <gyorkop@balabit.hu>
Date:   Thu May 3 17:12:15 2012 +0200

    unit: added test_skeleton.c (fixes: #B-06841)
    
    Signed-off-by: Peter Gyorko <gyorkop@balabit.hu>
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 6e00543b363b8bfd30710036f468358cd6c2782a
Author: Peter Gyorko <gyorkop@balabit.hu>
Date:   Thu May 3 16:34:11 2012 +0200

    unit: added testutils.{h,c} to make the test cases short and understandable (fixes: #B-06841)
    
    Signed-off-by: Peter Gyorko <gyorkop@balabit.hu>
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 101cb379b2f433662feefb29013451406e8f3108
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Sat May 12 14:31:54 2012 +0200

    logproto: Move fsync() from logtransport to logproto
    
    To restore the fsync(yes) functionality, move the fsync() from
    LogTransport to LogProto instead, so that we can fsync() right after a
    write() or writev() call.
    
    Turning on fsync(yes) will now result in log_proto_file_writer_new()
    setting self->fsync to a non-zero value, which in turn will cause both
    functions that call write() to fsync() right afterwards too.
    
    Reported-by: Patrick Hemmer
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit 0d9ef25b64ddf3b06a3fe30ef6e44ad4bc73d679
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Mon May 7 21:16:05 2012 +0200

    Don't use deprecated glib symbols on newer glibs
    
    A couple of symbols have been deprecated by glib in versions newer
    than the minimum version syslog-ng supports, and with 2.30 which
    deprecated g_atomic_int_exchange_and_add(), these warnings are way
    over the normal threshold, and turn build logs into not much more than
    noise.
    
    The three deprecated functions and their fixes are as follows:
    
     + g_atomic_int_exchange_and_add(): Which is replaced by
       g_atomic_int_add() if the glib version is found high enough at run
       time.
    
       This is a single place to add an ifdef to, and doing it any other
       way would be far messier.
    
     + g_mapped_file_free(): This is replaced by g_mapped_file_unref(),
       and a configure check was added to see if _unref() is available. If
       it is, we use that. If not, we alias _unref() to _free() in
       compat.h. This way, the call sites can always use
       g_mapped_file_unref().
    
     + g_strup(): This has been deprecated so long ago, that no check is
       done, the code was rewritten to use g_ascii_strup() instead.
    
    No functionality is lost or changed, just different interfaces used to
    accomplish the same thing.
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit aebc8171b57619cc39304e17ef7f874e48329579
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Fri May 4 13:50:52 2012 +0200

    afsocket: Support a smooth upgrade path to recent systemd
    
    When the journal was introduced in systemd, it started to pass
    /run/systemd/journal/syslog to syslogds (it was passing down /dev/log
    before). Since we verify that the FD to open matches the expected
    filename, we didn't pick up the fd due to the filename mismatch.
    
    This can be fixed on the system() source level, where it can decide
    which to generate into the config. However, for setups that do not use
    system() for one reason or the other, this does not work.
    
    For these systems that do not use the system() source, the best
    solution is to try and replace /dev/log with
    /run/systemd/journal/syslog at run-time. This patch does just that,
    and ties it to config versions 3.4 or earlier.
    
    This means that post-3.4, the automatic replacement will stop working,
    and users will get the generic failed to acquire socket error message
    instead.
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit 6e62f50c3e7b9cbd45fae041703a4b4691561234
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Fri May 4 10:40:33 2012 +0200

    lib/gprocess.c: Ignore SIGHUP inside the supervisor.
    
    Reloading syslog-ng's config is often done via a killall -HUP
    syslog-ng command, which also sends a signal to the
    supervisor. However, the supervisor did not handle said signal, thus
    it exited as is the default for it.
    
    To work around this issue, lets ignore SIGHUP inside the supervisor.
    
    Reported-by: Patrick Hemmer
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit 845b5913393658784194e8db57ede9753e801997
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sun May 6 14:33:29 2012 +0200

    json-parser(): added marker() option
    
    This patch implements a marker() option for json-parser(). Marker is
    a string prefix that can be used to identify a message to be parsed. If
    the marker is set and the incoming message doesn't start with it,
    parsing is not performed and the message is dropped.
    
    If the input indeed matches the marker, json parsing commences with the
    string _after_ marker. White space between the marker and the json
    payload is ignored.
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 1f73246138be6142a3fbcec9f2ced8d85b18b0b1
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sun May 6 14:28:25 2012 +0200

    rewrite: added set-tag() and clear-tag() ops
    
    This patch implements two rewrite primitives, set-tag() takes a tag
    and associates it with the log message. clear-tag() does the reverse thing.
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 5e3c14109feb1d707c8c132415593b838725761d
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sun May 6 14:27:25 2012 +0200

    logmsg: publish log_msg_set_tag_by_id_onoff()
    
    This function used to be private, now it is published as it is needed by
    set-tag() and clear-tag().
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 364c030c8ad25ce199fd0a09b27ba84ae9a1cfa5
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sun May 6 14:26:49 2012 +0200

    cfg-tree: handle empty channel {} blocks
    
    Earlier an empty channel {} was considered a compilation error, these
    are now handled as a do-nothing pipe.
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 7f01d5cb8d6de90d98798a78263684430791ab08
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Fri Apr 27 16:30:05 2012 +0200

    afsmtp: Add SCS_SMTP to lib/stats.h
    
    Add SCS_SMTP to lib/stats.h, so we get proper smtp stats too.
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit 9b6768a0dcdbd942f3f92f08a4fff050c70741df
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Fri Apr 27 13:53:16 2012 +0200

    afsql: Move the INSERT construction out of insert_db()
    
    To improve the flow of the afsql_dd_insert_db() function, moved the
    code to construct the insert statement out into a new function:
    afsql_dd_construct_query().
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit 53b541588646371345a8365f8a835f42a0d67eb3
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Fri Apr 27 13:53:15 2012 +0200

    [PATCH (3.4) 2/3] afsql: Simplify insert_db()'s table validation
    
    To make things a tiny bit easier, move the final error handling out of
    _insert_db() into a separate function: afsql_dd_insert_fail_handler().
    
    Furthermore, change afsql_dd_validate_table() to allocate the GString
    for the table name itself, and resolve the template too, if so need
    be.
    
    The above two allows us to simplify afsql_dd_insert_db() a little:
    when validating the table, we can immediately bail out, without a
    goto, since we only need to free up the bare minimum.
    
    And in the end, a monstrous if (success) {} else {} branch is replaced
    by something a lot shorter, and clearer.
    
    All of these together make the flow of afsql_dd_insert_db() easier to
    understand and follow.
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit 05b4701474e4f8d36dba7a083f8cc7d9821402ba
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Fri Apr 27 13:53:14 2012 +0200

    afsql: Move the database connection to a separate function
    
    To make the code clearer, move the code to connect to a database out
    of afsql_dd_insert_db() into afsql_dd_connect().
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit 198e350545c718cb3afd9321a033216a67d1d34b
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Tue May 1 14:09:33 2012 +0200

    libsyslog-ng-crypto.so: link against libcrypto explicitly
    
    This patch adds OPENSSL_LIBS to LIBADD so that libsyslog-ng-crypto.so is
    always linked against libcrypto.so
    
    Reported-By: Alexander Komyagin <komyagin@altell.ru>
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 143aa435f133a9075a01530eeae0d8f40fdb47e1
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Fri Apr 20 20:00:45 2012 +0200

    scl: Teach the system() source about systemd
    
    On Linux, when LISTEN_FDS is non-empty, and
    /run/systemd/journal/syslog is a socket, assume we are running under
    systemd, in which case our source shall be the journal's syslog
    output, instead of the default /dev/log.
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit 61942d74ab95599df357bc00ce4b7d543b51e832
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Fri Apr 20 10:07:26 2012 +0200

    contrib/systemd: Alias the service to syslog.service
    
    In order to be considered a syslog service, we need to Alias ourselves
    to syslog.service. Doing this will make systemd consider syslog-ng a
    valid syslogd service, without the alias, one has to do something
    similar manually.
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit 4b702746ed5cb8e19426c91e862a9b22689ae347
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Fri Apr 6 12:09:48 2012 +0200

    configure.in: Add --disable-smtp support.
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit ab25c4c2a32988d86a5e024d784db7ad48f17cd2
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Tue May 1 09:03:29 2012 +0200

    preparations for 3.4.0alpha2

commit 9b63c47680c47d884e7985b1bda844d5c9a248db
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Mon Apr 30 13:56:51 2012 +0200

    use on-demand LogMessage cloning to implement inmutable messages on parallel log paths
    
    When processing a message, syslog-ng tries hard to avoid copying messages
    along the line. The semantics provided by the syslog-ng configuration
    is that parallel branches of the log processing pipeline are independent,
    e.g. change on one of the branches may not affect the other one.
    
    Earlier, this was implemented by the LogMultiplexer object, before
    posting a message to a branch it checked if the branch may change
    the message by inspecting the PIF_CLONE flag of the head element. This
    didn't handle all cases (e.g. when a rewrite was applied between two
    destinations).
    
    This patch delegates this clone-when-needed operation right before the
    actual change happens, this also allows some performance improvements
    (since the clone may not always be needed).
    
    I introduced the notion of "write-protection" to LogMessage instances,
    when an msg is write-protected no changes can be applied. If a LogPipe
    needs write access, it needs to acquire that by calling
    log_msg_make_writable().
    
    Write-protection is enabled on a LogMessage when it is assumed not to
    change. Such an occassion is when it is put on a LogQueue of a destination
    which processes messages asynchronously. A similar case is when the
    db-parser() puts the message in its correllation state.
    
    Before any writes can be applied, a call to log_msg_make_writable()
    needs to be made, which creates a clone if the current LogMessage
    is write-protected, or leaves the message be if it isn't.
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 9bd9f5b61e0908911085563675e6f53a270c3f47
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Mon Apr 30 13:27:55 2012 +0200

    cfg-grammar: fixed memory leak when parsing "block" definitions
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 49f7359f888615b222b4693faf674bc8d25efbf9
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Mon Apr 30 13:27:38 2012 +0200

    cfg-lexer: fixed a memory leak that caused the linked list that holds generator plugins to be leaked
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 0c930b442e040bc52d7af4ae6793c50dc1158168
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Mon Apr 30 13:34:45 2012 +0200

    cfg-tree: fixed memory leaks in config compilation routines
    
    The objects hash and the name for rules were leaked when processing
    the configuration. This patch fixes those.
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 1839055f750bf7520917c2a986cea4cf21671271
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Mon Apr 30 13:34:12 2012 +0200

    afinter: fixed a compilation warning
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit a6ef12d180acddacf973b1d816a0a540355e821e
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Tue Apr 17 16:42:43 2012 +0200

    test_value_pairs: fixed heap corruption & memory leak
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit d71c87a2998896b39b83bff05864c5d23c375c20
Merge: 5e6df27 d5d607c
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Tue Apr 17 16:32:57 2012 +0200

    Merge remote-tracking branch '3.3/master'

commit 5e6df270bfbfadaf67e716869399c68219212f8c
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sat Apr 7 18:09:26 2012 +0200

    cfg-tree: refactor flow-control calculation
    
    Instead of trying to figure out where to put the PIF_HARD_FLOW_CONTROL
    bit, defer this to log_pipe_queue(). This makes the compilation code
    much easier to understand.
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit a9990f226f95977410647ff5ac206d5f8985b7e2
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sat Apr 7 18:06:57 2012 +0200

    log_expr_node_format_location: fixed a non-zero terminated output string
    
    Instead of sizeof(buf) we should've used the passed buf_len argument. Causes
    string not to be properly NUL terminated, or perhaps a buffer overrun in
    case the passed buffer is smaller than the size of a pointer.
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 1c3a37764d98d5a37f2cd3c79f7f40978edb4383
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sat Mar 31 22:50:20 2012 +0200

    NVTable: allow huge LogMessage data
    
    This patch converts NVTable to use 32 bit offsets/sizes in order to allow
    maximum 4GB log records, each value holding maximum 4GB data. The NVTable
    structure is still artificially limited to 256MB in size.
    
    Signed-off-by: Peter Eisenlohr <peter.eisenlohr@inform-software.com>
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 61a47f7b54d93baf388560d2db25d6c9e4bfde69
Merge: 1ac9c8c 7e6f44c
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sat Apr 7 15:47:25 2012 +0200

    Merge remote-tracking branch 'algernon/algernon/3.4/merge-3.3.5'

commit 7e6f44cc8e4f52a389cee6b4d68aacbdb7ec9c3a
Merge: 4a7fb52 884c078
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Sat Apr 7 14:35:16 2012 +0200

    Merge branch 'upstream/mirror/3.3' into algernon/3.3-merge
    
    Conflicts:
    	NEWS
    	VERSION
    	modules/afmongodb/afmongodb.c

commit d5d607c05251b38e821efe27bc46ac8db78dd722
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Fri Apr 6 11:35:42 2012 +0200

    afinter: Make the parent class LogSrcDriver, instead of LogDriver.
    
    The parent of AFInterSourceDriver should be LogSrcDriver, because
    that's the struct we pass down to it anyway, and other parts of the
    code will cast it back to LogSrcDriver, too.
    
    But if its parent is LogDriver, as it was, we were corrupting the
    later parts of the original LogSrcDriver, with values from
    AFInterSourceDriver.
    
    Many thanks to Peter Eisenlohr <peter.eisenlohr@inform-software.com>
    for initial debugging, and for pinpointing mark messages as the
    triggers.
    
    Reported-by: Peter Czanik <czanik@balabit.hu>
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit a898014482f733e9ccac00b7965e92db00d7589b
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sat Oct 29 20:15:35 2011 +0200

    afsocket: handle DNS failures as if it was a connection failure
    
    Instead of preventing the startup completely.
    
    Reported-By: Heiko Gerstung <heiko@am-anger-1.de>
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit a4acf40959a72adb20ce84f4a94002f8d2542565
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Fri Feb 3 10:52:57 2012 +0100

    afmongodb: Fix a deadlock at deinit time.
    
    There is a race condition between the writer thread and stop_threads
    (via deinit): if deinit sends the signal just at the wrong time, then
    the worker thread willl never wake up, as the main thread is already
    waiting for a join to finish.
    
    The fix is to lock the queue_mutex before signalling, that eliminates
    the race. This patch does just that.
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit 884c078b5212418499a53ffa7618ac7fe3e2df78
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sat Apr 7 13:51:42 2012 +0200

    preparations for 3.3.5

commit 424ff99218f8414ae012f1f66292cbdf0ff6e169
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sat Apr 7 13:45:40 2012 +0200

    throttle: don't let the bucket counter go less than zero
    
    When the LogWriter ignores the throttle setting (for instance when flushing
    the destination at reload/exit time), the throttle_buckets can go
    below zero, which is unexpected. Don't let that happen.
    
    Signed-off-by: Juhasz Viktor <jviktor@balabit.hu>
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit f4fcca3950f60bd71060db19b79aa5b7f6f23678
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sat Apr 7 13:17:03 2012 +0200

    rewrite-expr-grammar: improve error handling for invalid name-value pair names
    
    This change improves the error handling to better pinpoint the issue
    we have with the value() parameter of a given rewrite expression.
    
    Both the invalid .SDATA name and trying to change a read-only macro are
    handled the same, with a nice error message.
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 64978af37a63c05d1ae34a27fe1c9545ccb99b6b
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sat Apr 7 13:15:48 2012 +0200

    log_msg_is_value_name_valid(): new function to check if the passed name is useable as a value name
    
    This function used to live in the rewrite-expr-grammar.ym file, copied here
    and a generalized a bit. The other function will go away with the next
    commit.
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 9827d0135af4c81f0137fe0c89fe8e8b0a1c9e7a
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sat Apr 7 10:20:12 2012 +0200

    mainloop: fixed a minor per-thread leak that occurs when a worker thread exits
    
    This patch frees a per-thread condition variable upon exiting from
    worker threads. Worker threads are automatically terminated after 10
    seconds of idleness, so this might add up if syslog-ng regularly processes
    a message every 10 seconds.
    
    Reported-By: Marvin Nipper <Marvin.Nipper@stream.com>
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 0883e07ca99a7f8a1a227822ab25d4b3afca7a26
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sat Apr 7 10:18:13 2012 +0200

    mainloop: destroying dns-cache and scratch buffers per-thread state doesn't need locking
    
    This patch moves the dns_cache_destroy() and scratch_buffers_free() calls
    outside of the protection of main_loop_io_workers_idmap_lock. They
    accidentaly got there. Shouldn't be a big performance issue, but
    can be a bad example for code added later on.
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 1ac9c8c35aa4370152e2e30b4585d0d6081bbfee
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Wed Apr 4 17:10:07 2012 +0200

    Revert "NVTable: allow huge LogMessage data"
    
    This reverts commit bb667115b80b24055dd1245084c7d2e26d01d184.

commit 9064e909e8aef518ec3c073bccc1bf09da9a2c06
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sun Apr 1 09:42:58 2012 +0200

    driver: fixed possible leak and use-after-free
    
    log_dest_driver_release_queue() was possibly leaking the LogQueue
    instances for file destinations when they got reaped. This was
    caused by an earlier patch that fixed a crash in reloads,
    more specifically this one: c7070e2a6f1c3a312260bcecf49d62028fef27ce
    
    This patch should fix both cases properly, the leak in the file destination
    driver and the original crash in the afsocket destination.
    
    Also, this patch fixes a use-after-free condition, the next member of
    a GList structure was referenced after it was removed from the list.
    
    Kudos to Jakub for the detailed bug report and Algernon for the origianl
    fix.
    
    Reported-By: Jakub Jankowski <shasta@toxcorp.com>
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 4a7fb52a628db2e494d9596b5e949b8ce7f9e321
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sat Mar 31 22:50:34 2012 +0200

    syslog() source: make buffer dynamically allocated
    
    This patch changes self->buffer to be dynamically allocated.
    
    Signed-off-by: Peter Eisenlohr <peter.eisenlohr@inform-software.com>
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit bb667115b80b24055dd1245084c7d2e26d01d184
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sat Mar 31 22:50:20 2012 +0200

    NVTable: allow huge LogMessage data
    
    This patch converts NVTable to use 32 bit offsets/sizes in order to allow
    maximum 4GB log records, each value holding maximum 4GB data. The NVTable
    structure is still artificially limited to 256MB in size.
    
    Signed-off-by: Peter Eisenlohr <peter.eisenlohr@inform-software.com>
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 443bc4546af4ec57280038835e1b1119fd826dff
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Fri Mar 30 10:54:28 2012 +0200

    afmongodb: Restore compatibility with syslog-ng 3.3
    
    In syslog-ng 3.3, we had the host() and port() options for the mongodb
    driver, these were removed in 3.4 in favour of servers(). This patch
    re-adds this two.
    
    Using host() and port() will now prepend the specified combination to
    the server list.
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit 2a601898893cce78f197317fb531e8c7eb661dbe
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Fri Mar 30 09:18:11 2012 +0200

    json-parser: Change the way arrays are formatted
    
    Instead of parsing an array into key-value pairs where the key has a
    suffix of a dot, followed by the array index, make the key resemble
    the javascript array syntax: array[index].
    
    This makes it more intuitive to reach into arrays, and also makes it
    easier to discover arrays when formatting back to JSON.
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit aa56452cbd42470c7f986b667f7c06848c0b5cc7
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Mon Mar 26 14:47:35 2012 +0200

    dummy: Remove this module.
    
    The dummy module does nothing, yet, is installed by default. It's not
    a terribly great example of a simple module, either. For these reasons
    and more, lets bid it a tearful farewell.
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit 7fdca91fd9c1aae5c9d0aa97a732cef32970aa15
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Fri Mar 30 11:42:07 2012 +0200

    cfg-lexer: Implement glob-based @include.
    
    Both for distributions and otherwise, the ability to limit what kind
    of files are included, especially when doing a directory include is
    very important.
    
    This patch implements just that, by extending cfg_lexer_include_file()
    to try and resolve globs, if it can't find a file otherwise. Files
    included this way still respect the global include-path setting, so
    @include "foo.d/*.conf" will still work.
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit fe5f2b89e0c49dfd7d9a89c55304cb205da253ea
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sat Mar 31 21:59:39 2012 +0200

    cfg-lexer: Split cfg_lexer_include_file() into two functions
    
    To be able to keep the code simple in the future, split
    cfg_lexer_include_file() into two: the intent is that we'll check if
    the file exists, and if not, try the same thing as a glob, otherwise
    continue as we did before.
    
    This would nest too deep, so split out the current bulk into a
    separate function.
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit c08618370fc018629d623148452403fb7d0e6f40
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Fri Mar 23 16:24:01 2012 +0100

    afmongodb: Fix a race condition in the queue & wakeup mechanism
    
    The problem was found and analysed by Whille, the patch is based on
    his observations.
    
    The patch corrects a situation where - due to a race condition - the
    worker thread could end up in a permanent sleeping state.
    
    Reported-by: whille <whille@163.com>
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit 35cd19e84ab2008b0f452142dd2d53030cfbbcfd
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sat Mar 31 21:41:02 2012 +0200

    configure: Fix --with-json=json-c/json-glib handling and add --disable-json.
    
    The tests that decide whether the user wanted to select json-c or
    json-glib were a little bit off, which resulted in anything other than
    --with-json=auto failing. This has now been corrected. This patch also adds
    --disable-json for consistency with other enable/disable options.
    
    Reported-by: Peter Czanik <czanik@balabit.hu>
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 88494e0b7973c00c616206ba6ac81903cca85ccb
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Fri Mar 23 11:48:48 2012 +0100

    modules: Do not build or install disabled modules
    
    The afmongodb and afsmtp modules had a subtle bug in their
    Makefile.ams: even if they were disabled, the Makefile still built and
    installed an empty module.
    
    This patch corrects that, by moving the module_LTLIBRARIES inside the
    if block.
    
    Reported-by: Peter Czanik <czanik@balabit.hu>
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit 4d6656bbbc19877e7dc2175a7fb3b9aeeaced270
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sat Mar 31 21:14:28 2012 +0200

    logtransport: handle ENOBUFS on output
    
    FreeBSD returns ENOBUFS on send() failure instead of indicating
    this conditions via poll().  The return of ENOBUFS actually is a send
    error and is calulated in IP statistics, so the best is to handle it as
    a success.  The only alternative would be to return EAGAIN, which could
    cause syslog-ng to spin as long as buffer space is unavailable.  Since
    I'm not sure how much time that would take and I think spinning the CPU
    is not a good idea in general, I just drop the packet in this case.
    UDP is lossy anyway
    
    Reported-By: Traiano Welcome <Traiano.Welcome@mtnbusiness.co.za>
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 35a092d9f8fc6545bbb72958fa117ffdffc1192a
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sat Mar 31 20:22:30 2012 +0200

    afsql: another reset_parallel_push workaround
    
    Lacking a better alternative right now, this patch works around an abort
    happening in the SQL destination driver when the target is slow. It's
    a single line of code, with 20 lines of comment...
    
    Reported-By: whille <whille@163.com>
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 7c2cc16233a5fc21232ec22f56a9ae9022e240bd
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Wed Mar 14 20:48:09 2012 +0100

    cfg-tree: handle template compilation errors properly
    
    In case a template was specified directly at a destination, its syntax errors
    were not properly reported while the configuration was being parsed. This
    patch fixes that.
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit cf193a52e2177641921e6ff7cda48bc4a37d971b
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Wed Mar 14 20:47:19 2012 +0100

    value-pairs: fixed double free in case of an argument parsing failure
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit daded120cefa7217dac0b1a5d9a870a7fa7fc51d
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Wed Mar 14 09:54:35 2012 +0100

    unix-dgram: fixed crash in file permission parsing code
    
    A line to set last_file_perm_options was missed in the unix-dgram variant
    of afsocket, which caused the last_file_perm_options variable to be
    initialized to NULL, causing a segfault later on.
    
    Reported-By: Peter Czanik <peter.czanik@balabit.hu>
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 2d7339985ad8ce9b8d162ca95b3b59d711c27ad2
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Wed Mar 14 09:36:20 2012 +0100

    cfg-tree: fixed segfault triggered by empty source/destination object
    
    When a source/destination object is empty a segfault happened during
    the compilation of configuration (for sources) or at the first message (for
    destinations). This was fixed by handling such cases.
    
    Reported-By: Peter Czanik <czp@balabit.hu>
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit fd3b3863003da213eb45c4cd744aadb926a2ec98
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Mon Mar 12 20:24:31 2012 +0100

    LogProto: fixed framing error on partial flushes in RFC5424 support
    
    This patch fixes bug that is triggered when syslog-ng receives an EAGAIN
    while payload is written to the destination. A patch fixing the issue
    was submitted by Gergely Nagy, however I didn't like that solution
    refactored the code to something more manageable.
    
    Reported-By: Yuri Arabadji <yuri@fused.com>
    Signed-off-by: Fried Zoltan <deirf@balabit.hu>
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 3c14a264ab4c76b9372b1288d6808d19ec4d0aed
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sun Mar 11 14:53:55 2012 +0100

    logwriter: fixed a memory leak for messages that couldn't be flushed at once
    
    Sometimes a message is dequeued, and then can't be posted to the destination
    (probably because of an EAGAIN or something like that). In this case
    it is readded back to the queue. In this case a reference was lost, causing
    a memory leak, but not for all messages, but only for the affected ones.
    
    Reported-By: Evan Rempel <erempel@uvic.ca>
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 77776419504917f54093b7462bcaa6545413bd5d
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Thu Mar 8 21:11:06 2012 +0100

    preparations for 3.4alpha1

commit 404ceb959efe9715ce7437d7dcdc28ababbac590
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Mon Mar 5 14:47:12 2012 +0100

    afsmtp: New destination driver, to send mails via SMTP
    
    This introduces the afsmtp destination driver, updated to the latest
    3.4 conventions, and with all the threading bugs that were also
    present in afmongodb too, fixed.
    
    The driver itself uses libESMTP to send mail, and has the following
    config syntax:
    
    destination d_smtp {
     smtp(
      host("localhost") port(25)
      subject("ALERT! IMPORTANT EVENT FROM ${HOST}")
      header("X-Severity", "${SEVERITY}")
      from("no-reply@${HOST}.dummy")
      to("syslog-alerts@my.example.domain")
      bcc("big-brother@my.example.domain")
      cc("it@my.example.domain")
      reply-to("admin@my.example.domain")
     );
    };
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 7104231ef1852a7a249060442af19e748ab2aaf7
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Fri Feb 3 11:16:13 2012 +0100

    value-pairs: Do not require --rekey in the command-line parser.
    
    The --rekey in the commandline parser is not needed, the various
    transformation functions can work just fine without it, and do the
    setup themselves, if so need be.
    
    This patch gets rid of --rekey.
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit a16798c653c057239236945034114d8abf320e44
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Fri Feb 3 13:46:02 2012 +0100

    tfuuid: New template function to generate UUIDs.
    
    This patch adds a new template function: $(uuid), which can be used to
    generate Universally Unique IDentifiers.
    
    The use case for this is to add an UUID to each message as soon as
    they're received, so that they can be identified later, accross
    destinations. This allows me to pre-generate an ID for messages going
    into mongodb, and send those messages to a different destination too,
    with the same ID included.
    
    Use it like this:
    
    rewrite r_add_uuid { set("$(uuid)" value("uuid")); };
    log { source(s_network); rewrite(r_add_uuid);
          destination(d_mongo); destination(d_program); };
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit e8afb0c2a7b9163c807b8b3a6623a0260206c1e2
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Fri Feb 3 13:46:01 2012 +0100

    uuid: Introduce a new function to generate uuids.
    
    The new function, available in "uuid.h" and libsyslog-ng-crypto, can
    be used to generate UUID strings. It will either use a custom
    implementation, when OpenSSL is available, or libuuid, if it's present
    but OpenSSL is not.
    
    If neither is present, it falls back to a dumb counter.
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit b74827fff80d09c9bcfc40a7e4164c413b041c75
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Wed Mar 7 13:53:39 2012 +0100

    log_writer_suspend(): fixed a potential abort when the error-suspend timeout expires
    
    It is caused by the fact that the watches are deinitialized at the time
    the timer triggers. Instead of only updating them, restart polling completely
    at timer trigger time.
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit c71b4b560fe89209c00c61b890567a9d346b7acb
Merge: f841136 bf742b0
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sun Mar 4 14:19:55 2012 +0100

    Merge remote-tracking branch '3.3/master'

commit f8411361807d77d2fb0b3092c697ccd1a33d7467
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sun Mar 4 14:09:36 2012 +0100

    afmongodb: hack to link afmongodb properly against OpenSSL
    
    In case the glib version is too old, afmongodb requires linking against
    libcrypto, however even though libmongo-client.la lists it as a dependency
    that is not used when linking modules with libtool.
    
    This patch is a hack, a better solution would be welcome, it unconditionally
    links the afmongodb plugin against libssl and libcrypto in case the internal
    copy is being used.
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit e599f1fe11861258a283add5a6ff6db9bcbda68f
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sun Mar 4 14:08:01 2012 +0100

    func_test: try to load modules from the libtool hidden directory
    
    When running within the source tree, syslog-ng should load .so files
    from within the libtool-created .libs directory, otherwise it'd be using
    stale copies in the "install" dir.
    
    This was discovered as now syslog-ng autoloads modules by default.
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 181edbddc8415c03885d35f9e35b5460613d801c
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sun Mar 4 14:05:48 2012 +0100

    crypto: don't use apphooks to register/unregister crypto stuff
    
    Use constructor/destructur functions instead.
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 1980bde933908ad4666d205e895b66dbc30ee6e3
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sun Mar 4 14:04:39 2012 +0100

    plugins: allow loading plugins regardless their filename
    
    Instead of requiring that the name of the plugin must match the "internal"
    name of the plugin, make it possible to load them regardless if they were
    renamed or are loaded through a symlink.
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit e65e2cb622e378e243515486503d9897d71569ce
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Tue Feb 28 06:33:07 2012 +0100

    test_value_pairs: fixed a memory leak in the test program
    
    so that it becomes valgrind clean.
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 428e21d8f2a6e5cb972f3a9b3660e5f966c55b75
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Tue Feb 28 06:32:39 2012 +0100

    tags: don't allocate tag 0 at init time
    
    Its initialization caused a leak and was overwritten when the first real
    tag was created.
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit bf742b09d611720b7849c5e96e67f1d2dba5b748
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Tue Feb 21 10:42:16 2012 +0100

    doc: Fix EXTRA_DIST
    
    There is a \ missing from the end of the second line of EXTRA_DIST,
    which results in a couple of files being left out of make dist, which
    in turn makes distcheck and building from dist tarballs fail.
    
    This patch adds the missing \.
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit 286fe4fa589e2703b228551e1e3f69595be33513
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sun Feb 26 09:42:42 2012 +0100

    value-pairs: compile with earlier glib releases
    
    There were two glib features that prevented syslog-ng to compile
    with earlier versions:
      - g_strcmp0 is only available starting with glib 2.22, use strcmp instead.
      - g_ptr_array_set_free_func() is substituted with our own free code
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 44a7f4334ea3c91eb36e3f799cbe2cba054ec4c2
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sun Feb 26 09:39:50 2012 +0100

    vptransform: publish value_pairs_transform_free
    
    This patch publishes value_pairs_transform_free() function so that code that
    allocates transform objects can free them outside of a ValuePairsTransformSet.
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit ae5d156b01edf14a136513c84980ddb4ef196446
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Mon Feb 13 16:25:16 2012 +0100

    value-pairs: Use a GPtrArray for explicit name=value pairs
    
    Instead of storing the name-value pairs explicitly set by the user in
    a GHashTable, store them in a GPtrArray. This has the advantage of
    being both lighter and faster to both insert and traverse, at the cost
    of making collissions more costy.
    
    If there are two entries with the same key, the templates of both will
    be evaluated, but only the latter will be used, which is a minor
    performance hit. But not using GHashTable outweights that.
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit fa72bc271342dc6a36a9648f0c4731d1f1f329bf
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Fri Feb 10 17:35:22 2012 +0100

    value-pairs: Export value_pairs_foreach_sorted()
    
    Export value_pairs_foreach_sorted(), so that if any module wants to
    use a custom sort function, they can do that.
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit 2e0b7c24c592600d7ae687bce2e85271a8721a7d
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Fri Feb 10 17:35:21 2012 +0100

    value-pairs: Use a GTree for our internal scope.
    
    Using a GTree instead of a GHashTable has the advantage of providing
    faster access and a sorted key list, both of which are desired
    features.
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit 0bd147b943f6d05f4c7f01ca8b9271e9b167c8de
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Fri Feb 10 12:59:44 2012 +0100

    afsql: Fix a deadlock when using explicit commits.
    
    When using explicit commits, in case the COMMIT results in an error,
    syslog-ng forgot to release a mutex, resulting in a deadlock the next
    time the same error happened.
    
    The fix is to do release the mutex in this error path, too.
    
    Signed-off-by: Fried Zoltan <deirf@balabit.hu>
    Signed-off-by: Patrick Hemmer <syslogng@stormcloud9.net>
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit e30b24f7e517fe668f9bcbbd45ee4b8c77806877
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Fri Feb 24 20:07:39 2012 +0100

    cfg-lexer: ignore pragma/include directives when parsing a buffer
    
    Buffer parsing is only used to parse filter expressions, which shouldn't
    need the include/pragma machinery, nor the need to trigger the automatic
    loading of plugins when a buffer is parsed.
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 773116c6eeda97e8d9fb1afdcc82f99ed219eff4
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Fri Feb 24 20:06:10 2012 +0100

    crypto: automatically unregister the crypto hook when libsyslog-ng-crypto.so is unloaded
    
    It might happen that a plugin triggers the load of libsyslog-ng-crypto.so,
    which then gets unloaded (for instance when loading the list of candidate
    plugins). This patch unregisters the apphook automatically in this case.
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit bf657797af5826f416a87201902e431e932a1442
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Thu Feb 16 16:17:00 2012 +0100

    $(grep): added -m option to limit the number of matches
    
    This patch adds the -m option to $(grep), which can specify the maximum
    number of matches (akin GNU grep).
    
    Reported-By: Martin Grauel <martin.grauel@balabit.hu>
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit b16ca8a1e583fb132dd4212d6205da8f614983ba
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Fri Feb 3 10:52:57 2012 +0100

    afmongodb: Fix a deadlock at deinit time.
    
    There is a race condition between the writer thread and stop_threads
    (via deinit): if deinit sends the signal just at the wrong time, then
    the worker thread willl never wake up, as the main thread is already
    waiting for a join to finish.
    
    The fix is to lock the queue_mutex before signalling, that eliminates
    the race. This patch does just that.
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit 921fe160bd454c9c59ab027f78ef3319cad2338d
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Fri Feb 3 09:12:18 2012 +0100

    loggen: handle ENOBUFS gracefully
    
    This patch adds handling of ENOBUFS by sleeping for 1msec one it occurs.
    This fixes ENOBUFS handling on BSDs, which actually return this error
    code even in blocking mode, thus causing loggen to exit with an error
    when UDP is used and the network stack/interface is slower than
    loggen.
    
    Signed-off-by: Russ Milne <rtaitmilne@seccuris.com>
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit cf555f6c251151c3ac74d345ead3231c0a28eeb3
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Thu Feb 2 14:33:06 2012 +0100

    implement automatic loading of modules
    
    Instead of having to rely on @module statements and --default-modules
    parameters, this patch implements automatic loading of modules whenever
    they are referenced from the configuration file.
    
    It first enumerates all available modules, extracts the list of plugins
    they offer and autoloads modules based on this information. This
    means that it doesn't matter what the module name is, syslog-ng
    will perfectly be aware which plugin is in which module.
    
    Whenever multiple modules offer the same plugin (think about the
    afsocket case) a "preference" value will determine which one is used.
    
    The autoloading can be disabled by setting 'autoload-compiled-modules'
    global variable set in the configuration file, which is now set to 1.
    
    The SCL modules.conf file got removed too, instead of having to track
    which modules need loading, the automatic means makes that unnecessary.
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 386b778c577fb1fb55b2e98e975bfdf724b4249f
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Thu Feb 2 14:21:01 2012 +0100

    afsocket: fixed building the notls version
    
    There was a collision in the macro used to enable SSL support in the
    configure script and the macro defined by the Makefile in case the SSL
    version is being built. The latter is now renamed to "BUILD_WITH_SSL".
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit bf5d7aed345d9d4274ee8eb5ee6afc0886420192
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Thu Feb 2 14:18:49 2012 +0100

    main: --module-registry should initialize the logging subsystem
    
    As the plugin loading functions use it, so in case a debug message
    was printed, syslog-ng crashed. This patch explcitly disables
    --debug/--verbose and initializes the logging subsystem.
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 6ea0dcb748779208875a895cb770c2263b548f4e
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Thu Feb 2 14:17:41 2012 +0100

    libsyslog-ng-crypto.so: link against OPENSSL_LIBS explicitly
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit a299854e07b26ddf2e67eb3959b14638c7814691
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Wed Feb 1 11:45:55 2012 +0100

    manual pages: replace generated manual pages with the XML source
    
    This patch changes the included manual pages to be covered under the
    GPL and also a means to regenerate them from their source format (XML).
    
    Signed-off-by: Robert Fekete <frobert@balabit.hu>
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 017e73227752fc0867946ceb84cbfdd074740d78
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Tue Jan 31 15:44:21 2012 +0100

    configuration: make the "channel" keyword equivalent to "log" in log expressions
    
    Following a discussion on the syslog-ng mailing list, the "log" keyword
    can be odd when being used as a part of a source/destination/rewrite/parser
    rule. After a lot of debate, the "channel" keyword was chosen.
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit d58bf8188861e917151a71c1fd33c92b0811d595
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Tue Jan 31 15:43:12 2012 +0100

    cfg: change the current config version to 3.4
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit dea802da96c9bcc4cc8d9e09d293212958e0330e
Merge: 2761c99 e5978b3
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Tue Jan 31 15:09:41 2012 +0100

    Merge branch 'pipe-owner-group'
    
    Conflicts:
    	lib/cfg-grammar.y

commit 2761c99606aa25e8066e3f39f74428875af12a26
Merge: 247d677 e594c61
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Tue Jan 31 15:07:08 2012 +0100

    Merge remote-tracking branch '3.3/master'
    
    Conflicts:
    	NEWS
    	VERSION
    	modules/afmongodb/afmongodb.c

commit e5978b3af3f0f7fbe0959f38a273d8594d8d383f
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Mon Jan 30 20:00:34 2012 +0100

    pipe(): added permission setup code to pipe() sources
    
    This makes it possible to use owner/group/perm options for pipe sources.
    
    Reported-By: Patrick Hemmer <syslogng@stormcloud9.net>
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit f3200e79246e9f04697e8a9e792099d79999ff55
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Mon Jan 30 19:58:04 2012 +0100

    file-perms: refactor file permission manipulation code
    
    This patch introduces file-perms, grammar rules and a object that would
    apply user-specified permission settings to files created by syslog-ng.
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit e594c61daca70d922a0d7553afd5acdb1f9e3da6
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Wed Jan 18 18:00:43 2012 +0100

    afsocket: Free tls_context if it has been allocated
    
    Signed-off-by: Eric Lindvall <eric@sevenscale.com>
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 247d677d376299092e739fffbfcaee0d44de5a5a
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Wed Jan 18 17:04:27 2012 +0100

    afprog: send signals to the whole process group instead of just the child process
    
    Some shells do not propagate signals to its children, effectively
    causing them to be left alone at syslog-ng reloads. This is less than
    ideal in case the process doesn't exit if its stdin is closed.
    
    This patch changes the kill() calls to send signals to all children,
    which in turn should properly terminate everything spawned by the shell.
    
    Reported-By: Hendrik Völker <hendrik.volker@de.verizonbusiness.com>
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 5e44eb46b0d7b86b62f17698e2b6de875ac8d7c6
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Tue Jan 17 20:44:11 2012 +0100

    preparations for 3.3.4

commit a25edf6a46c0eb740f0069ca5ada953148ae5cc2
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Mon Jan 16 23:06:06 2012 +0100

    csv-parser: fixed the use of the template() function in case of multiple invocations
    
    When csv-parser() is used in multiple log paths, it is cloned. The clone operation
    didn't properly clone the value of the template() parameter, effectively causing the
    clone to operate on $MESSAGE.
    
    Reported-By: John Morrissey <jwm@horde.net>
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 3dc36259904aa1b206ee52e6ac2cd1266957cef0
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Mon Jan 16 22:49:01 2012 +0100

    control socket: close connection fd to avoid leak
    
    This patch fixes an fd leak associated with control connections, that
    are used by syslog-ng-ctl.
    
    Reported-By: Jakub Jankowski <shasta@toxcorp.com>
    Fixed-By: Peter Eisenlohr <peter.eisenlohr@inform-software.com>
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit ece855da52124744fb14858c54906b6e901f58b2
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Tue Jan 10 13:11:09 2012 +0100

    json-parser: Implement array parsing.
    
    Arrays are parsed into a $fieldname.$index structure for now.
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit b4244d20bb40fff2c94fd15c8aa20990b89917af
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Tue Jan 10 13:11:08 2012 +0100

    json-parser: Implement boolean parsing.
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit 2c4f6554ce56df640673c77e98aa4722bc2b98e6
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Tue Jan 10 13:11:07 2012 +0100

    json-parser: Support netsted objects.
    
    Moved the json_object iteration into its own function, so that it can
    be called recursively. This made us able to do just that, and easily
    handle nested objects.
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit 7b5773b7f1367e64d06c0a88ed8258a3ecc8c478
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Tue Jan 10 13:11:06 2012 +0100

    jsonparser: Handle invalid JSON input properly.
    
    When JSON parsing fails, handle it gracefully, by printing an error
    message and returning immediately, instead of ending up segfaulting.
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit 888ee834deb5a6013b0120c2f00450d139056296
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Tue Jan 3 01:55:33 2012 +0100

    afmongodb: Remove the TODO file.
    
    The TODO file was old and stale, remove it.
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit 768f0c6ec8eba2ad51531f2331fb5635fe12c063
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Tue Jan 3 01:55:32 2012 +0100

    afmongodb: Add support for safe-mode.
    
    This adds a new option to the mongodb destination driver:
    safe-mode(yes|no), which, as the name implies, can be used to turn
    safe-mode on and off. For performance reasons, it is off by default.
    
    Safe mode basically involves an extra check after each insert, that
    checks whether the last insert succeeded, and only treating the insert
    a complete success when the double check succeeds too.
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit a980b9d268efa54879d3deeb4a53fa5a281629ba
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Tue Jan 3 01:55:31 2012 +0100

    afmongodb: Added replicaset support.
    
    The servers can now be specified with a server() parameter, where the
    first will be the primary (used in the stats for example), the rest
    will be the seeds.
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit ae8ae9aa17c7ac5544d5c779b55e9d5b0ecb9f33
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Tue Jan 3 01:55:30 2012 +0100

    afmongodb: Convert to mongo_sync_*
    
    In preparation to support other things, and to slightly reduce code
    complexity, convert the MongoDB destination driver to use the mongo_sync
    family of functions.
    
    Signed-Off-By: Gergely Nagy <algernon@balabit.hu>

commit 3e7eec7466eeab4295d579d35003dfd6358e2338
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Tue Jan 3 01:55:29 2012 +0100

    afmongodb: Clean up the default value-pairs() set.
    
    Cleaned up the default value-pairs() set, so no needless excludes are
    present by default.
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit bf22a896ad524caac3880c298c4cf58dfce62257
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Thu Dec 29 15:01:27 2011 +0100

    afmongodb: Only free the value pairs if there's any.
    
    In afmongodb_dd_free() only free self->vp, if it is non-NULL. In case
    of a syntax error in the configuration file, it may very well be NULL
    still, and that would lead to us segfaulting shortly after printing
    the error message.
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit f284d852e744503cffac50100cd6a87b9a97944f
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Thu Dec 29 14:41:21 2011 +0100

    afmongodb: Fix a race condition in the queue handling.
    
    There is a race condition between afmongodb_dd_queue() and
    afmongodb_worker_insert(), that can trigger an assertion when the rate
    of incoming messages is very high.
    
    The scenario that triggers this is like this:
    
    * We receive a message, put it in our internal queue, and notify the
      worker thread.
    * The worker thread resets the queue's parallel_push.
    * We receive another message, notice that the queue is empty, so we
      insert it, and set parallel_push at the same time.
    * The worker thread tries to pop the queue's head, but that triggers
      an assert, because parallel_push is set.
    
    The root cause of the problem is that afmongodb_dd_queue() modifies
    the queue without locking the queue_mutex. This patch corrects that
    problem.
    
    Reported-By: Costa Farber <costaf@wix.com>
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit 0e858cbc7eccffffff12cfcccf7399b43333d9f1
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sun Jan 15 13:44:14 2012 +0100

    configuration: implement Log Expressions support
    
    This patch is a huge one that completely changes the data structure behind
    the configuration parser and refactors all log processing statements
    in the configuration in a notion called 'log expressions'.
    
    All major statements in the configuration: source, destination,
    filter, parser, rewrite have become log expressions. Log expressions can
    be nested recursively and this makes the syslog-ng configuration language
    much more flexible and makes it easier to extend in the future.
    
    The change is upward compatible with the old language, so users should
    not notice anything.
    
    Here are the features that this patch implements.
    
    Junctions
    
        Before junctions, log statements could contain embedded log statements
        like this:
    
        log {
        	source(s_all);
        	filter(f1);
        	log { filter(f11); destination(d11); };
        	log { filter(f12); destination(d12); };
        };
    
        Only messages that match "f1" will be dispatched to the two embedded log
        statements, which in turn will send the message to d11 and d12 if their
        corresponding filter matches.
    
        Embedded log statements were limited in a number of ways:
          - it can only be used at the end of a log statement,
          - it is not possible to add further processing _after_ all log statements were
            finished
          - it is not possible to process the "output" of embedded log statements,
            message processing finishes on each branch separately.
    
        There comes the "junction", which is an enclosing block for embedded log
        statements so their "end" becomes available.
    
        For instance it becomes possible to do things like this:
    
        log {
        	source(s_all);
        	filter(f1);
        	junction {
        		log { filter(f11); rewrite(d11); };
        		log { filter(f12); rewrite(d12); };
        	};
        	destination(d11);
        };
    
        The destination "d11" will get the "output" of the embedded log statements
        in the junction right before the destination. This can be used
        for a number of things:
    
          - in a number of cases, filtering & rewrite would depend on the
            context (like which source a message was read from)
          - however once that processing is finished, the further processing of the
            message becomes the same.
    
        For instance: Apache log files contain a header which is omitted when Apache
        logs to syslog instead. By using junctions, one branch can remove the
        extra header from files while doing nothing in the other. For example:
    
        log {
          source(apache_files);
          source(syslog);
          junction {
            log { filter(f_apache_files); rewrite(r_apache_remove_file_header); };
            log { filter(f_apache_syslog); };
          };
          destination(d_files);
        }
    
        Also, junctions are a preparatory work for combining sources/destinations
        and processing elements.
    
    Inline definition of log processing elements
    
        Instead of having to define all objects (source, destination,
        filter, parser, rewrite) externally, make it possible to include their
        definition in the log statement itself.
    
        Here's a sample config that demonstrates its use:
    
        @version: 3.4
    
        log {
        	source {
        		unix-stream("log");
        	};
    
        	filter {
        		message("foo");
        	};
    
        	destination {
        		file("/home/bazsi/logs/d4.log");
        	};
        };
    
        Please note that the usual duplication problems apply, e.g. you can't
        define the same file destination twice in two different log statements,
        otherwise stats & queues will be duplicated and syslog-ng will issue
        an internal error on each reload. Checking for duplications with proper
        error logging is to be done in the future.
    
    Everything is a log expression
    ==============================
    
        This feature is the combination of all written above, which essentially
        makes the syslog-ng configuration language much more powerful.
    
        All log expressions can recursively involve other log expressions.
        Some practical examples:
    
        It becomes possible to attach parser/rewrite expressions to sources,
        and reuse the combination of the source and the assorted parser/rewrite
        expression as a source:
    
            source s_apache {
                log {
    		source { file("/var/log/apache/error.log"); };
    	        parser(p_apache_error_parser);
    	    };
            };
    
        Anything that is read from Apache's error log file, will be processed
        by p_apache_error_parser prior to hitting the normal log paths,
        defined further down in the configuration.
    
        It becomes possible to use junctions within parsers: sometimes it is not
        trivial how to process a given stream of log messages. Some of them
        is best processed by db-parser(), others with csv-parser(). It is
        usually quite trivialy to decide which one to use (tags, $PROGRAM
        or other log message property), but currently syslog-ng only allows
        this to be implemented using separate log paths. This complication is
        now removed with a parser like this:
    
            parser p_parse_all {
    	    log {
                     filter(f_csvparseable); parser { csv-parser(); }; flags(final);
                };
                log {
    	         parser { db-parser(); };
                };
            };
    
          Basically this parser would try to process messages with csv-parser()
          if the filter "f_csvparseable" matches, otherwise it uses db-parser().
    
          Please note that all the expressions above can use both references
          of other previously defined log expressions or can define them
          in-line, right on the spot.
    
    Error reporting
    ===============
    
          Error reporting was also improved, syslog-ng has now started to print
          the exact location where a given processing element was defined.
    
          This is not complete, but technical possibility exists to add this
          information to all diagnostics messagess.
    
    Implementation notes
    ====================
    
          - LogSourceGroup and LogDestGroup are eliminated, their functionality
            (primarily source specific counters) is moved to
            LogSrcDriver and LogDestDriver respectively
          - LogProcess is eliminated, its functionality is pushed
            into stock LogPipe
          - the global counters "center.received" and "center.queued"
            work again
          -

commit fe588b8afad3788dc3f372cb42aeaf8fee4f7f6b
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sun Jan 15 11:35:33 2012 +0100

    LogDestDriver: introduce log_dest_driver_queue_method()
    
    This patch introduces a new derived queue method that has to be called
    from all LogDestDriver instances. In this patch, the method is created
    and all dest drivers explicitly call that in their _queue() method.
    
    Note that in order to do this, destination drivers should pass a reference
    and ack to this inherited method, which requires changes in all
    destination drivers.
    
    This change allows us to factor in more-and-more destination related
    functionality in LogDestDriver instead of pushing those into
    LogSourceGroup/LogDestGroup, which is going to be removed in a
    follow-up patch. For example, previously group related counters were
    updated in the LogSourceGroup/LogDestGroup objects, this is going to be
    moved back to the driver, sparing us one additional LogPipe during
    processing and making implementation a bit more object-oriented.
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 7200624de8c79551063114613a8b536decee1ca9
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sun Jan 15 11:29:48 2012 +0100

    scratch-buffers: fixed compilation warning by including misc.h
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit a5408f011d54ab550f067e48c6731079cb9fe4a9
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Thu Jan 12 13:43:35 2012 +0100

    LogPipe: added assertion to log_pipe_queue() to check initializedness
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 0af8c877aee98a6bafdf9a5eaa888e9298c308c3
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Thu Jan 12 13:43:14 2012 +0100

    LogPipe: make it possible to clone LogPipe instances
    
    This used to be part of the LogProcess interface which need to be cloned
    whenever the same pipe is connected to the log processing graph in
    multiple places. This patch promotes that interface to the LogPipe
    class.
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 8ab998e9086b21ad4693a2adfa8a7a9a7b002ca5
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Thu Jan 12 13:42:13 2012 +0100

    merge with log_pipe_new

commit 0f67924c20cdc7abc76b9b4192faf32a32152b84
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Thu Jan 12 13:42:06 2012 +0100

    syslog-ng.h: define LogPipe typedef globally
    
    Instead of having to include logpipe.h everywhere.
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 77626db95e67fc6b0eb4853dc1926fdb0130dca7
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Thu Jan 12 13:41:14 2012 +0100

    LogSrcDriver: indicate in flags that we're a source for log messages
    
    A new PIF_SOURCE flag is introduced that indicates that a given LogPipe
    will "generate" messages, not just merely forwarding them.
    
    This is used by the configuration compilation code to change the LogPipe
    structure accordingly.
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit a654af519887fab7ba21feffb43578bb9661d7bc
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Thu Jan 12 13:39:21 2012 +0100

    LogPipe: make it possible to create a simple 'do-nothing' LogPipe
    
    This patch adds a new constructor for LogPipe, that creates a LogPipe
    instance that does nothing.
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit a94f0f159b910575ceda2fe52a9fe9eb96c735d9
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Thu Jan 12 13:31:14 2012 +0100

    rename center.{c,h} to cfg-tree.{c,h} without changing contents
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 1e7f8fe65a1a51f2000ffbaddc280ef443529426
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Fri Jan 6 12:51:02 2012 +0100

    configure.in: removed "environ" variable test in favor of an explicit OS dependency
    
    The test didn't work reliably as "environ" as a variable is available on
    Darwin in executable programs, but not in shared libraries. syslog-ng
    uses that in a shared library, but there's no easy way to test that.
    
    This patch changes the detection from an actual check of the environ
    variable to a check to the underlying OS.
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 7201f9a4c6d1b26206494cd60020a2536a7ffaec
Merge: 4425054 511e939
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Wed Dec 28 14:20:13 2011 +0100

    Merge remote-tracking branch '3.3/master'

commit 4425054b0f74104d2bf47f9f4b630fc09bdd7345
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Tue Dec 27 17:24:06 2011 +0100

    log_center_init_pipe_line(): rescope variables so most declarations are where the given variable is used
    
    This patch is primarily meant to make the code a little bit more readable
    by moving the variable declarations to where they are used instead of
    being defined at the top of the function. junction {} handling will make
    this function even more complex, so making it a bit more readable helps
    a lot.
    
    I also added a comment to describe the function so that it drives the
    reader's eyes a bit for deeper understanding on what's going on.
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 3d05ee23122a707c74bd53f8bc33f535aa34b912
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Thu Dec 22 15:14:49 2011 +0100

    basic-funcs: implement $(length) function
    
    The idea behind the $(length) function is to make it possible to filter
    based on value length, such as:
    
    f_malformed {
     match ('-', value ("$(if ($(length "${MSG}") <= 16) "-" "+")"));
    };
    
    Reported-By: Gergely Nagy <algernon@balabit.hu>
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 511e939f4199af3ae9aaa4a14b77c7f82863c16f
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Thu Dec 22 15:02:16 2011 +0100

    logsource: fixed potential division by zero exception
    
    Reported-By: Dmitry Gilev <dmitry.gilev@me.com>
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 9254fe9e6236746bf1f955f0cac1274634b1beda
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Wed Dec 7 12:11:12 2011 +0100

    afsql: Add support for specifying custom SQL backend options.
    
    When one is using an SQL backend that supports a set of options that
    syslog-ng does not set itself, yet, one does want these options set,
    there was previously no way to accomplish that without changing the
    source.
    
    This patch adds a new option: dbd-option(OPTION_NAME VALUE) (where
    OPTION_NAME is always a string, and value can be either a string, or a
    number). The options specified this way will always be set with libdbi
    whenever we (re)connect to the database.
    
    A simple use-case:
    
    destination d_slow_sql_test {
      sql(type("null")
          dbd-option("null.sleep.connect" 1)
          dbd-option("null.sleep.query" 5)
          columns("dummy")
          values("1")
      );
    };
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit 61aa152834083393fe34dfcafecffaf3a916048e
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Fri Dec 2 15:37:34 2011 +0100

    afprog: Terminate the child process on deinit.
    
    When reloading the configuration, terminate the child process of a
    program destination, for the following reasons: it will be restarted
    anyway by afprog_dd_reopen(), so there's no harm done. But if dash is
    used as /bin/sh, simply closing the stdin of the process will not make
    it stop.
    
    That, in turn, results in us starting the same program over and over
    again on each SIGHUP. So instead of doing this, send a SIGTERM to the
    child on deinit, too.
    
    Reported-by: Thomas Wollner <tw@wollner-net.de>
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit 79fc32703615e045fca4c9aaf85b7ab2915e7ed4
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Wed Dec 21 13:35:28 2011 +0100

    csvparser: fixed csv-parser() when applied to multiple log paths
    
    Reported-by: Michael Hocke <michael.hocke@nyu.edu>
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit c62fcd18a7c945d5185a2e2278ad22d2abc1fb41
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Fri Dec 2 13:29:42 2011 +0100

    logrewrite: Correctly initialize the conditional rules.
    
    In case where the condition of a rewrite used a filter reference
    instead of inlining the filter itself, the filter expression was never
    initialized. This resulted in the condition always evaluating to
    not-match, making the following construct completely useless:
    
     rewrite("new-value", value("MESSAGE"), condition(filter(f_my_filter)))
    
    The fix is to introduce a new function, log_rewrite_init_method(),
    which will initialize the condition filter if it exists, and has an
    init method. Then we bind this method to LogPipe's init callback
    during log_rewrite_init().
    
    This way, when initializing the rewrite pipe, the condition will get
    initialised too.
    
    Reported-by: Thomas Wollner <tw@wollner-net.de>
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit ab08c84abbeda5a200b8150a6af7b02c64d84994
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sun Dec 18 09:53:39 2011 +0100

    [dbparser] Implemented SET parser
    
    The SET parser matches any characters specified in its parameter list
    without further checks. This is a generic solution for the need of
    matching and arbitrary number of whitespaces in messages with padding
    for fields
    
    Reported-By: Evan Rempel <erempel@uvic.ca>
    Signed-Off-By: Balint Kovacs <blint@balabit.hu>

commit 6549f537b518926cd5f505504451fa73a8a8269b
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sun Dec 18 09:24:19 2011 +0100

    $(strip): added new template function to strip off whitespace from both ends of a string
    
    This patch adds the implementation and unit tests for $(strip) that
    can be used to strip off spaces from string.
    
    Usage:
    
      $(strip $arg1 $arg2 $arg3)
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 97353039a7441090a49e6002a6bbe38f5b8a0e52
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sat Dec 17 20:22:07 2011 +0100

    dbparser: fixed message indexing in action rules with no correllation (incompatible)
    
    Actions that are attached to rules having context-id (e.g. correllation),
    use @0 for the message being generated and @1 the last message in
    the context.
    
    This is inconsistent with rules that have no correllation, where @0 was the
    triggering message.
    
    This patch fixes this behaviour, but at the same time it is incompatible
    with previous versions.
    
    Reported-By: Evan Rempel <erempel@uvic.ca>
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit a70984928208599dc46a99ae1d2d11026fdea1ff
Merge: ddc7c25 8d50d24
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Thu Dec 15 21:29:56 2011 +0100

    Merge remote-tracking branch 'github/master'

commit ddc7c2539bd66fa35e8df441e4baf58e87b6708d
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Thu Dec 15 21:27:43 2011 +0100

    value-pairs: key rewriting support
    
    This is the implementation of the key rewriting feature, along with a
    couple of other enhancements that were required for the functionality.
    
    The first change is that the key() statement now works very
    differently: instead of being a wrapper around pair(), it is now a
    glob-accepting include statement instead (with keeping the name).
    
    As such, it no longer guarantees that a given key will appear in the
    final set, as excludes still have a chance to override it.
    
    key() and exclude() patterns are now matched in order, and the last
    one wins. The only way to guarantee a key into a set, in spite of any
    exclude() rules, is via pair(). The key-value pairs specified by
    pair() are still inserted into the set afterwards.
    
    The key rewriting itself is done via the new rekey() statement, to be
    used under the key() statement, along these lines:
    
    value-pairs(
     key(".cee.*"
         rekey(shift(4)
               add-prefix("Events")
               replace("Events.some_field" "a_new_name")
         )
     )
    )
    
    Similarly, the same thing can be done with format-json (without the
    line breaks):
    
    $(format-json --key .cee.* --rekey --shift 4 --add-prefix Events
                  --replace Events.some_field=a_new_name)
    
    The transformations listed under rekey() are applied to each key
    matched by the glob specified for the outer key() statement, and the
    transformations are applied in the order they're listed in the
    configuration.
    
    This patch implements the following translations: shift($AMOUNT),
    which simply shifts the key $AMOUNT characters right;
    add-prefix($PREFIX) which does as the name suggests; and
    replace($PREFIX, $NEW_PREFIX), which replaces a substring at the start
    of the key, with another. The replace() transformation does not
    support replacing anything other than a prefix.
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit 606c8cc0b10aa4e877f70726b707402d100bb0f9
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Wed Dec 14 15:21:05 2011 +0100

    afunix: clarified error messages in case of a failure
    
    On Fedora systems, syslog-ng was configured to use unix-stream() /dev/log
    whereas systemd supplied a unix-dgram() one, which caused difficult to
    diagnose problems.
    
    This patch adds further logging to this case and causes syslog-ng to fail
    with an error message if it finds that /dev/log is using an incorrect
    socket type.
    
    Reported-By: Michal Schmidt <mschmidt@redhat.com>
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 32b7d63aa5074551c84ac62ec023b84c7274ce39
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Fri Dec 9 21:38:17 2011 +0100

    pdbtool match: added the value of the TAGS macro if a message matches
    
    The TAGS values assigned by patterndb is an important output, which
    wasn't displayed so far.
    
    This patch adds
    TAGS=...
    
    line for each matched message.
    
    Reported-By: Evan Rempel <erempel@uvic.ca>
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit cd059eab18b483685fd83675d39fb54bcbedfe8c
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Tue Nov 29 16:13:52 2011 +0100

    db-parser(): set .classifier.unknown tag if a message doesn't match
    
    Whenever a message doesn't match the patterns, automatically set
    the tag '.classifier.unknown'. Likewise if it does, clear this tag.
    
    The rationale is to make it easier to use tags to detect if a message actually
    matched while processing with the last db-parser().
    
    We're clearing the same tag in case of a match so that if there are
    multiple db-parser() instances, the check against .classifier.unknown
    would work, even if the first one matched and the 2nd doesn't.
    
    Reported-By: Evan Rempel <erempel@uvic.ca>
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit a5e11c771787ce1671d95713fa9342a99a1e1289
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Tue Nov 29 16:05:15 2011 +0100

    added patterndb-4.xsd to the tarball
    
    Reported-By: Evan Rempel <erempel@uvic.ca>
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 8d50d247ecb5a14693705a52341222908ca83f7a
Merge: 0ef1b92 1b52fd8
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Fri Nov 25 13:14:22 2011 +0100

    Merge remote branch '3.3/master'
    
    Conflicts:
    	NEWS
    	VERSION
    	lib/mainloop.c
    	lib/value-pairs.c
    	modules/basicfuncs/basic-funcs.c

commit 0ef1b9274ba83a5689a59d66d910ca0513fd9dfd
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Fri Nov 18 17:19:00 2011 +0100

    value-pairs: Fix the error handling in the command-line parser.
    
    When an error occurs during command-line parsing, do not attempt to
    free argv: it's not owned by us anymore.
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit a9eefd946f24ae7630f27fad8f2add4efb751d90
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Fri Nov 18 15:13:03 2011 +0100

    logproto: Fix compilation on systems without IOV_MAX.
    
    Since IOV_MAX is not defined on Hurd its usage is made conditional.
    Errors are handled by g_malloc0() which aborts on failure, so no
    return value has to be checked.
    
    Reported-By: Svante Signell <svante.signell@telia.com>
    Patch-From: Svante Signell <svante.signell@telia.com>
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit 1b52fd8741b33c20e7cdc06b907fb76a981c8874
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Fri Nov 25 12:38:40 2011 +0100

    [logrewrite] Repair logrewrite *_clone and *_subst_clone functions (fixes: #7686)
    
    Repair rewrite clone functions because we did not clone $MACRO id and conditions.
    Before this patch if we used rewrite in config file and use example PIPE source
    we rewrited $MESSAGE macro instead of macro in config file because the $MESSAGE
    macro was the default macro.
    
    Signed-off-by: Fried Zoltan <deirf@balabit.hu>
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit e495996c1e4eef0a79f4cf49b5252098d7a00e10
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Fri Nov 25 12:30:24 2011 +0100

    LogMessage: reorganize nv_table_add_value() call-sites for readability
    
    Reported-By: Attila M. Magyar <athos@balabit.hu>
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 0f96f048abc74aa27f0299f586b7c7b736c71401
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Fri Nov 25 12:18:39 2011 +0100

    NVTable: added comment on NVTable memory management
    
    Reported-By: Attila M. Magyar <athos@balabit.hu>
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit d199a1980be6b23fe24189e86a882812288e292c
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Thu Nov 17 21:28:14 2011 +0100

    preparations for 3.3.3

commit c7070e2a6f1c3a312260bcecf49d62028fef27ce
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Thu Nov 17 21:21:19 2011 +0100

    driver.h: fixed a double-unref scenario causing crashes on reload
    
    This patch fixes a heap-corruption caused by a double-unref in
    log_dest_driver_release_queue(), triggered at reload time.
    
    Reported-By: Patrick H. <syslogng@feystorm.net>
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 555a5cead6723132e6aa89f52365bb40582c8ecc
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sun Nov 13 13:22:18 2011 +0100

    Further preparations for 3.3.2

commit b9b0e5d0207c06b5a7b59aafe7db457c217b070d
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Sat Nov 12 14:27:27 2011 +0100

    gprocess: Fix --no-caps handling when building with hardening options.
    
    When both glib and syslog-ng is built with hardening options enabled,
    overwriting a string pointer with a FALSE boolean does not have the
    expected results: the string will not become NULL.
    
    In this case, --no-caps will end up with a segfault, because
    process_opts.caps is non-NULL, and points to junk.
    
    To fix this, introduce a new function that sets process_opts.caps to
    NULL explicitly, and use this function as a callback, instead of
    assuming that a FALSE boolean will have the expected results.
    
    Reported-By: Peter Czanik <czanik@balabit.hu>
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit 476a1da5ac00dcea58fe3038bc110ec8dec4c0d8
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Sat Nov 12 10:29:24 2011 +0100

    value-pairs: Fix a small memory leak in the commandline parser.
    
    Whenever we parse a command-line, we construct a new argv array, to
    prepend a zeroth element for glibs option parser. We correctly free'd
    it on the error path, but never on the success path.
    
    This lead to a small memory leak every time
    value_pairs_new_from_cmdline() was called (that is, at the moment,
    each $(format-json) template function leaked a little bit).
    
    This patch fixes this issue by modifying the error handling a little:
    instead of freeing everything and returning NULL, we only free the
    value-pairs structure, and set it to NULL. The rest of the freeing is
    left up to the common parts afterwards, which now correctly frees the
    constructed argv array too.
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit 56ac221ddc72498b77d7c30ba89f5d5f9641f6df
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sat Nov 12 20:49:03 2011 +0100

    NEWS: updated for 3.3.2

commit c94867c78a3250795806a4b0eab69ea6be758c21
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sat Nov 12 20:46:22 2011 +0100

    configuration: allow configuration object duplicates
    
    Historically syslog-ng used to allow overriding configuration block simply
    by defining the same object twice. A previous patch has changed this
    to an error, however there seem to be people who rely on the old behaviour.
    
    In order to serve both groups of people (who get it wrong and who really
    wants to use this) a new global variable has been introduced.
    
    This line in the beginning of the config:
    
    @define allow-config-dups 1
    
    will restore the old behaviour, this is also printed to the console
    at startup.
    
    Reported-By: Dave Rawks <dave@pandora.com>
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit d2c4e32e750706953a64b366b3e0d8c61a42d864
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Wed Nov 2 11:58:37 2011 +0100

    resolve_sockaddr: Fix domain stripping on initial lookup.
    
    When looking up a hostname, we were only setting the 'positive' bool
    during lookup, so it was only set when the host already existed in the
    cache. When it didn't, and we just put it there right after the failed
    lookup, the bool remained false.
    
    This resulted in the domain part not being stripped even when
    use_fqdn(no) was set.
    
    The fix implemented in this patch is dead simple: if we managed to
    resolve a host, we set the bool to TRUE.
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit e4ed6c00d7df607a8ef82df0288fd849134b8ed3
Author: Erik Maciejewski <erikm@ymail.com>
Date:   Tue Oct 4 03:17:13 2011 -0400

    afsql: Database connection health check
    
    Implemented a health check for the database connection after a query
    fails in afsql_dd_insert_db() that addresses an issue where, if a
    thread has a valid connection instance but has lost the actual
    connection somehow, log messages can potentially be dropped without
    an attempt to reconnect.
    
    An error message is generated similar to the initial connection
    error message if the connection is found to be down.
    
    The value for a thread's failed_message_counter is not incremented
    if the database connection is found to be down as the connection's
    state is the probable cause of the failed query.
    
    The placement allows any existing or subsequent uses of goto error
    to take advantage of the health check.
    
    Signed-off-by: Erik Maciejewski <erikm@ymail.com>

commit 89195186d7001739d496f6c8756c60933403f9e1
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sat Nov 12 13:45:38 2011 +0100

    filters: add support for evaluation in message contexts
    
    Filters are sometimes used in correllation contexts (for example "$(if)")
    which then may reference templates.
    
    Previously such cases were handled by losing the correllation state
    within the embedded template. This patch changed that and now
    correllation state is propagated into filter expression evaluations.
    
    Reported-By: Daniel Ankers <md1clv@md1clv.com>
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 8239b581b1c81f1ca7c425f2ced5b6869e7e20b2
Merge: fc744aa c97c589
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Wed Nov 9 21:22:29 2011 +0100

    Merge remote branch 'algernon/feature/3.3/scratch-buffers'

commit fc744aae608a9848cb13fe8098b11423e941c41b
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Wed Nov 9 21:17:34 2011 +0100

    logrewrite: fixed conditional rewrite
    
    In case condition() was specified for a rewrite rule and the condition
    didn't match, the log_rewrite_queue() method erroneously returned without
    either dropping the message or sending it on the log message pipeline.
    
    Since rewrite rules may not drop messages, we should
    always call log_pipe_forward_msg().
    
    Reported-By: Martin Holste <mcholste@gmail.com>
    Cc: <syslog-ng-stable@balabit.hu>
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit c97c58954900168d7a7780ef5aa09a14835aeb2c
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Mon Nov 7 22:20:44 2011 +0100

    scratch-buffers: Use an embedded GString.
    
    Instead of using a pointer to a GString, embed the GString, thus not
    only shaving off a few bytes of memory used for scratch buffers, but
    also reducing fragmentation.
    
    Requested-by: Balazs Scheidler <bazsi@balabit.hu>
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit 7dcda390add8408223b9563267be0833f182a9eb
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Tue Nov 1 13:22:49 2011 +0100

    value-pairs: Convert to use scratch buffers.
    
    Instead of using a temporary GString stored in the ValuePairs
    structure (which is NOT thread safe), use scratch buffers instead.
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit ebda1098348c48b4b5c3f9730a9a87ca34bc6861
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Tue Nov 1 13:13:03 2011 +0100

    scratch-buffers: Scratch buffer implementation.
    
    Scratch buffers are thread-local GString buffer stacks. The intended
    usage is that whenever a piece of code needs a scratch buffer for some
    quick task, it can acquire one via scratch_buffer_acquire(), and
    whenever it is not needed anymore, it releases it back to the stack
    with scratch_buffer_release().
    
    Buffers are allocated on-demand, and they're freed up at the end of
    main_loop_io_worker_job_stop().
    
    Code that wishes to use scratch buffers need to acquire and release as
    appropriate. These return a ScratchBuffer object, from which the
    GString part can be extracted with sb_string().
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit 9f626febb2b5a6c3a4530b872470b0330fbee977
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Mon Nov 7 22:20:44 2011 +0100

    scratch-buffers: Use an embedded GString.
    
    Instead of using a pointer to a GString, embed the GString, thus not
    only shaving off a few bytes of memory used for scratch buffers, but
    also reducing fragmentation.
    
    Requested-by: Balazs Scheidler <bazsi@balabit.hu>
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit bed329583e9e4a804100039c637c9d81a887cfc2
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Tue Nov 1 13:22:49 2011 +0100

    value-pairs: Convert to use scratch buffers.
    
    Instead of using a temporary GString stored in the ValuePairs
    structure (which is NOT thread safe), use scratch buffers instead.
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit 093faefb400f58cda0104559a31c57f3dfa0a61d
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Tue Nov 1 13:22:33 2011 +0100

    jsonparser: Convert to use scratch buffers.
    
    Instead of holding on to a pair of GStrings in the LogJSONParser
    structure, and using them in a non-thread safe manner, use the newly
    introduced scratch buffers instead.
    
    Also, we now create a new JSON tokener for each message - it's thread
    safe that way, and it's cheap enough to not need caching.
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit 6ae77b9415bc547e68533861a87796f7ad382a8d
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Tue Nov 1 13:13:03 2011 +0100

    scratch-buffers: Scratch buffer implementation.
    
    Scratch buffers are thread-local GString buffer stacks. The intended
    usage is that whenever a piece of code needs a scratch buffer for some
    quick task, it can acquire one via scratch_buffer_acquire(), and
    whenever it is not needed anymore, it releases it back to the stack
    with scratch_buffer_release().
    
    Buffers are allocated on-demand, and they're freed up at the end of
    main_loop_io_worker_job_stop().
    
    Code that wishes to use scratch buffers need to acquire and release as
    appropriate. These return a ScratchBuffer object, from which the
    GString part can be extracted with sb_string().
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit 9e7f9258b03c58701be40d40f9708bb3a9c56625
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Mon Oct 31 22:14:05 2011 +0100

    log_writer_set_options: fixed a memory leak
    
    log_writer_set_options() will be called possibly multiple times on the same
    instance, but the code didn't check if stats_id or stats_instance were
    already set. If they were, their old value was forgotten, thus leaked.
    
    Reported-By: Jakub Jankowski <shasta@toxcorp.com>
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 571e71aaf42beb3170ed9cec588a918f05afc8bb
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Mon Oct 31 21:54:40 2011 +0100

    pdbtool: fix missing check in pdbtool test ruleid warning
    
    Signed-off-by: Balint Kovacs <blint@balabit.hu>

commit 13b8351e1ba166a57ffcf010f7fd34db39124ca1
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Mon Oct 31 21:51:13 2011 +0100

    pdbtool: Test file accessibility in test mode.
    
    When run in test mode (pdbtool test), check that a file exists, before
    trying to load it, and return a sensible error message in case it does
    not.
    
    Reported-By: Peter Czanik <czanik@balabit.hu>
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit 0df32f3f984efec6ae11c0a19efc1414abb04e64
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Mon Oct 31 18:16:11 2011 +0100

    pdbtool: Bail out on errors even if validating only.
    
    When run with the --validate flag, and an error is detected, short
    circuit to the next file, instead of running the rest of the
    validation with garbled data.
    
    Reported-by: Peter Czanik <czanik@balabit.hu>
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit 13abb05aeeab5e56f73cf83352d0b83df6597faa
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Mon Oct 31 17:06:14 2011 +0100

    detect if "environ" variable is present
    
    MacOSX doesn't have an "environ" global, compile the setproctitle code
    conditionally. We could use _NSGetEnviron(), but the whole point of
    setting the proctitle is not that important, and I'm not completely sure
    that it actually works.
    
    Changing the process title involves a lot of possible unportable magic.
    
    Reported-By: Peter Czanik <czanik@balabit.hu>
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit b061328b3e0d3b466ac29ef4e1b3ee384b7130b0
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Mon Oct 31 16:33:32 2011 +0100

    configuration: report duplicate configuration elements
    
    Previously if a configuration element name was used twice, the 2nd would
    be used and some memory was leaked on every reload.
    
    This patch changes that by reporting duplicate IDs as configuration errors.
    
    A patch was posted by Anthony, but a different implementation
    was used instead.
    
    Reported-By: anthony lineham <anthony.lineham@alliedtelesis.co.nz>
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 60b596791040762fb3302939a58f493b72239847
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Mon Oct 31 10:13:42 2011 +0100

    mainloop: allow the number of worker threads over 64
    
    This patch allows more than 64 worker threads with one limitation: threads
    over 64 will not scale nicely in the LogQueueFifo implementation, as
    they'd contend on the queue wait lock.
    
    Reported-By: Arkadiusz Miśkiewicz <arekm@maven.pl>
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 73a8c48983319942f668080a19ec037d1aab22cf
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Mon Oct 31 10:06:01 2011 +0100

    affile: release per-writer LogQueue instances during runtime
    
    Instead of keeping those queues around if a destination is reaped, allow
    them be freed. Also, make sure that file destinations have their queue
    restored accross SIGHUP in case they contain unflushed items.
    
    Reported-By: Jakub Jankowski <shasta@toxcorp.com>
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 040587ec5ec662756ac18eb7ff998af64359c3ba
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Mon Oct 31 10:03:18 2011 +0100

    LogWriter: introduce log_writer_get_queue() method
    
    The new function returns the current LogQueue instance.
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit df5cbb37116476bb0b03036f9837e345c8fdb151
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Mon Oct 31 10:02:52 2011 +0100

    LogQueue: added keep_on_reload() method
    
    This patch introduces a new member function for LogQueue instances. Its
    role is to indicate whether we prefer keeping that LogQueue instance
    around when reloading syslog-ng. The default FIFO implementation allows
    the core to free the queue if it has zero items.
    
    If the implementation doesn't supply such method, we default to keeping the
    queue around.
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 9d9679e9e13cecdba33b61d2d3da71869bb5490f
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Mon Oct 31 09:58:42 2011 +0100

    LogDestDriver: properly maintain self->queues list in acquire/release
    
    The maintenance of the self->queues list was not complete, although
    new LogQueue instances acquired were added to the queue, their removal only
    worked in the log_dest_driver_deinit() function.
    
    With this change log_dest_driver_release_queue() can also be called
    explicitly by plugins, and the queues list will not become corrupted.
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 779e1e3fb0364b50f2125fd94eb927dda307886a
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Mon Oct 31 09:58:18 2011 +0100

    driver: don't generate persist IDs for drivers that fail to specify one
    
    This seems to have been a bad idea. The only location this was used
    is the file() destination driver, but that has multiple queues, making
    the current default ID generation collide.
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 775af1b8ead493198c1e3cea1edf64909d8a72b2
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sat Oct 29 20:15:35 2011 +0200

    afsocket: handle DNS failures as if it was a connection failure
    
    Instead of preventing the startup completely.
    
    Reported-By: Heiko Gerstung <heiko@am-anger-1.de>
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 3bd4fd7baf0ab087b36dc64172508503268bfb17
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sat Oct 29 17:49:57 2011 +0200

    preparations for 3.3.2

commit c7fb3470c6140786fa97e35f1d488ce6a0b7af4e
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sat Oct 29 16:31:18 2011 +0200

    logproto: Fix log_proto_file_writer_flush()'s partial construction.
    
    If the log messages has different length and only a partial write
    happen the log_proto_file_writer_flush there are a possible buffer
    under/overflow happen.
    
    The problematic part is in the calculation about the last written
    byte of the last written message. The calculation is not just too
    difficult to follow but use the wrong message length in it.
    Because of this ther are buffer under/overflow may happen or
    starting to read the message in wrong position, causing messing the
    log.
    
    Signed-off-by: SZALAY Attila <sasa@balabit.hu>
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit 53650a641751a1f6a260789b9eb2998284fe6a63
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Fri Oct 28 15:39:15 2011 +0200

    tfjson: Make $(format-json) have less unneccessary whitespace.
    
    When compiling with jsonc, use a custom formatter, so that the
    generated JSON does not have superflous whitespace between elements,
    and the only whitespace in the JSON is in the content parts.
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit e5569687bba2551c89a78faee55bcf8b4944066f
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sat Oct 29 13:46:38 2011 +0200

    jsonparser: New parser module for JSON parsing.
    
    The new parser supports json-c only, it does not work with
    json-glib. For this reason, the configure script was modified a
    little, so that it uses --with-json only. When json-c is found or
    selected, then both the parser and the template function will be
    built. If json-glib is found or selected, then only the template
    function will be available.
    
    The summary after configure now lists the determined settings.
    
    The new parser is - so far - fairly simple: it parses a JSON with
    json-c (int, double and string values are supported so far, booleans,
    arrays and sub-objects aren't yet), and sets the appropriate
    name-value pair in the LogMessage.
    
    Users can configure a prefix to prepend before each key.
    
    Usage is as simple as:
    
    source s_json { tcp(port(21514) flags(no-parse)); };
    destination d_json {
      file("/tmp/test.json"
           template("$(format-json --scope dot-nv-pairs)\n"));
    };
    parser p_json { json-parser (prefix(".json.")); };
    log { source(s_json); parser(p_json); destination(d_json); };
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit 4886557ac8a91e810e72b3ee698aff57b7804832
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Tue Oct 25 17:26:37 2011 +0200

    logqueue: Maximized the number of the messages removed from the queue. (fixes: #24383)
    
    Sometimes because of a race condition it is possible that there are more
    messages in the log queue than the configured limit (log_fifo_size()).
    
    In this situation the the log_queue_fifo_move_input_unlocked tries to
    remove more elements from the thread queue than it contains and
    because of this, it produces an invalid linked list, causing heap corruptions
    and other nastiness.
    
    Signed-off-by: Attila Szalay <sasa@balabit.hu>
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 16427b9a419146b316f6e39d6d4ca7495dcf1b8a
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Thu Oct 27 17:33:58 2011 +0200

    afsocket: fixed a NULL deref in case of reload
    
    If syslog-ng is reloaded, and the new config removes a tcp() source, and
    a connection is still alivem, it would segfault.
    
    Reported-By: Eric Lindvall <eric@sevenscale.com>
    Cc: syslog-ng-stable@balabit.hu
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit fec9c35c155a6c22da68c93de7fbee350c0c5d1a
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Wed Oct 26 15:55:38 2011 +0200

    syslog-ng/Makefile.am: create $(localstatedir) automatically at install time
    
    Reported-By: Hery Fanomezantsoa <rhfano@gmail.com>
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 253aa00fa17cab07e59c69cd0cbd7550780f1a7a
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Tue Oct 25 21:54:21 2011 +0200

    afsocket: avoid glib warning at shutdown/reload
    
    Sometimes a NULL GString instance was freed.
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit a2b4febbd1a6147762420a227600afba0eff4778
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Tue Oct 25 21:16:07 2011 +0200

    configure: don't use non-standard arguments for "head"
    
    Reported-By: Michael Sterrett <mr_bones_@gentoo.org>
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 4b438115f6387eb52b6c39c1f751ecf0c4a5ac5f
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sun Oct 23 20:19:58 2011 +0200

    filters: fixed filter() evaluation when embedded as an AND/OR subexpression
    
    When introducing the "init" method for filters one case was omitted: even
    though AND and OR expressions don't want to do anything on init, their
    subexpressions might, so this patch adds an init function to AND and OR
    which does nothing but calls the same for its "left" and "right"
    subexpression.
    
    This patch fixes filter("xxx") expression evaluation when that is
    not a single expression, but rather included in an AND or OR.
    
    Reported-By: Leonid Isaev <lisaev@umail.iu.edu>
    Cc: <syslog-ng-stable@balabit.hu>
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 05065fa7bc903496560ce6ee23dbfa8ac95a9f60
Merge: 1d8ccce 46bbdf9
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sun Oct 23 20:03:38 2011 +0200

    Merge remote branch '3.3/master'
    
    Conflicts:
    	NEWS
    	VERSION
    	lib/misc.c
    	lib/str-format.c
    	modules/basicfuncs/basic-funcs.c

commit 46bbdf9a107409e320450f9c4b6a82c2cf9f36af
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sun Oct 23 09:08:08 2011 +0200

    LogMatcher: fixed reference counting
    
    A reference count was added to LogMatcher instances, but it contained several
    critical issues:
      - the refcount wasn't initialized
      - the instance got freed when the refcount was non-zero
    
    Essentially the only case it worked when a rewrite rule was referenced
    from only _one_ location and in that case it leaked the matcher instance.
    
    Kudos for the great diagnosis in the original report, reported as ticket
    #139 in bugzilla.balabit.com.
    
    Reported-By: Patrick <bugzilla.syslogng@feystorm.net>
    Cc: syslog-ng-stable@balabit.com
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit c2936fb2b7129ffc831372fca85eb6fe9720ca7e
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sun Oct 23 08:54:56 2011 +0200

    systemd: make sure the acquired fd is in non-blocking mode
    
    The fd acquired from systemd is in blocking mode, and syslog-ng
    didn't explicitly set it to non-blocking, causing syslog-ng
    to stall. This patch changes that, explicitly enables
    O_NONBLOCK and O_CLOEXEC on systemd acquired fds.
    
    Reported-By: Enrico Scholz <enrico.scholz@informatik.tu-chemnitz.de>
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit d766735ef8703a3d7e3834c5e3d2ef49b690ff26
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Mon Oct 17 00:07:38 2011 +0200

    afsocket: Fix compilation with libsystemd-daemon
    
    When the libsystemd-daemon library is used, we need to use the header
    provided by the library, otherwise linking will likely fail. To do
    that, configure sets WITH_LIBSYSTEMD as appropriate, and depending on
    that value, we either include <systemd/sd-daemon.h> or "sd-daemon.h".
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit a1f739964ac574b9a3fdb91981b5ab8d76775f35
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sat Oct 15 17:56:06 2011 +0200

    fixed compilation error on platforms without clock_gettime()
    
    MacOSX lacks clock_gettime(), so avoid depending on it if not available.
    
    Reported-By: Jack Nagel <jacknagel@gmail.com>
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 1460b364ff2e97dd2e5b7733ac4a450d53e16a89
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sat Oct 15 17:54:30 2011 +0200

    configure: fixed clock_gettime() detection
    
    It is in -lrt and previously that wasn't added to the test.
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 065d8b971dc8ea3bf314a9263db4c79475c8f2c7
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Thu Oct 6 11:04:01 2011 +0200

    Fix compilation without OpenSSL.
    
    While most places where OpenSSL was used were guarded by ENABLE_SSL
    ifs, some were not. This patch adds those guards to lib/crypto.c,
    modules/afsql/afsql.c and tests/loggen/loggen.c.
    
    It also makes sure that OPENSSL_LIBS gets emptied when enable_ssl is
    set to no.
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit 0bae72c98dfbbaf0ce9fbbafc28f0f7797e7324e
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Thu Oct 13 15:29:22 2011 +0200

    afsql: allow initialization to continue even without indexes
    
    Reported-By: Viktor Juhasz <jviktor@balabit.hu>
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 0136e1b8a0460dd34be74c3fe6e202f971484be4
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Thu Oct 13 15:28:57 2011 +0200

    afsql: fixed a memory leak of the "indexes" array
    
    This bug caused some memory leaked at every SIGHUP.
    
    Reported-By: Jakub Jankowski <shasta@toxcorp.com>
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 5ef8dbba059d4670896e81f0bcf2bf63686f119b
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Thu Oct 13 15:28:17 2011 +0200

    afuser: fixed the leakage of the username
    
    The afuser driver was leaking the name of the user, accumulating leaked
    some memory at every SIGHUP.
    
    Reported-By: Jakub Jankowski <shasta@toxcorp.com>
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 70fa96f33c89ce2bb10d10aaa7ba0492764a441c
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Mon Oct 3 09:40:51 2011 +0200

    updated Jakub's contributor entry
    
    He'd like to attribute his syslog-ng work to SuperHost.pl

commit f6e075c0d47e0d6aaeb85329d752fa3ec9b1e03a
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sun Oct 2 09:50:47 2011 +0200

    updated contributor list for 3.3.1

commit 3a736e62b27f7036ab23b91cf0839a95d0185e18
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sat Oct 1 15:31:03 2011 +0200

    tgz2build/rules: remove README file

commit b5314e1389c17336d582582b2f8c9b0014521486
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sat Oct 1 14:38:20 2011 +0200

    preparations for 3.3.1

commit 803b90423d8582439665249054f9f547582e9959
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sat Oct 1 13:17:07 2011 +0200

    value-pairs: change the default scope to empty for the template-function option parser
    
    When parsing value-pairs with the bison parser (e.g. mongodb destination),
    the default scope is empty. On the other hand when using the value-pairs
    command line parser (e.g. format-json), the default scope was rfc3164.
    
    The latter was changed for consistency and in order to make it really
    simple to use _only_ the specified nv pairs.
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 0b0e35ce9a9c3680c0d651276248b9ffb2db6c35
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Fri Sep 30 20:18:15 2011 +0200

    nvtable: implement proper limitation on NVTable size
    
    NVTable has a maximum size of 65535 * 4, due to limitation of the
    data structure (length is stored in 16 bits shifted by two). However
    this limit was not properly boundary checked and oversize NVTable
    got syslog-ng to abort with an assertion failure.
    
    This patch changes syslog-ng behaviour so that reallocation problems are
    properly reported.
    
    Reported-By: Peter Eisenlohr
    Cc: syslog-ng-stable@balabit.hu
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit e51862b911732eacb20ec4203d9a5708796ec146
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Tue Aug 30 19:52:38 2011 +0200

    configure: Use ustar tar format for the make dist tarball.
    
    In order to avoid the 99 char filename limit, force the ustar format,
    so we extend the limit to 255 bytes instead.
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit c4898a6252cab9b4e621faab7522efb26c44cedb
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Wed Sep 28 09:33:50 2011 +0200

    updated libmongo-client to the latest upstream
    
    It is one-or-two patches ahead of 0.14
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit d438b73a8769ce892228d84cec2323ebc0ed5954
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Sun Sep 11 00:09:23 2011 +0200

    afmongodb: Print the collection name upon init.
    
    When initializing a mongodb destination, include the collection name
    in the logged message too.
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit 8d11b02fc103c6064483f774199f73e0abc75d40
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Sat Sep 10 21:20:13 2011 +0200

    configure.in: Fix --without-compile-date.
    
    The option forgot to properly set the supplied value, and thus, always
    resulted in compile date being enabled. This patch corrects that.
    
    Reported-By: Peter Czanik <czanik@balabit.hu>
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit 5afe42abe1be685a4714c691b277c24617438578
Author: Gergely Nagy <algernon@balabit.hu>
Date:   Sun Sep 25 13:43:33 2011 +0200

    gprocess: Implement stricter CAP_SYSLOG checking.
    
    Some distributions ship libcap with headers generated from the kernel
    sources, instead of the headers of libcap itself, resulting in the
    headers and the library diagreeing about what capabilities are
    supported.
    
    For this reason, before deciding whether CAP_SYSLOG is supported,
    verify that libcap can actually parse it, and fall back to
    CAP_SYS_ADMIN if it can't.
    
    The benefit of this is that even if ran on such a system, syslog-ng
    will still continue to work (albeit triggering a kernel warning)
    instead of terminating.
    
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit bde16fe3cb7d6025ab3bb5463213a5a7f0cba290
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Tue Sep 27 20:44:01 2011 +0200

    syslogformat: handle AIX style message forwards properly
    
    There was a bug in processing AIX style message forwards, the hostname
    wasn't detected properly. This patch fixes that issue and adds a unit test
    to cover this case.
    
    Reported-By: ericduda@yahoo.com
    Cc: syslog-ng-stable@balabit.hu
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 936971db436a30cc29ba7d4c7fa11ce29a9d1bae
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Tue Sep 27 20:33:59 2011 +0200

    afmongodb, afsql: Fix a race condition in the queue handling.
    
    On occassions where we received a message, woke up the worker thread,
    then received two two others before the worker finished, we had a high
    chance of triggering an assertion, because we ended up calling the
    insert before the parallel_push stuff managed to wake up the thread
    and clear the callbacks.
    
    Now we explicitly clear parallel_push before popping the queue head,
    for the simple reason that we do not need it at that point anymore.
    
    Many thanks to Balazs Scheidler <bazsi@balabit.hu> for pointing out
    what happens.
    
    Cc: syslog-ng-stable@balabit.hu
    Signed-off-by: Gergely Nagy <algernon@balabit.hu>

commit e224d45da2ecad68f7f9c44895849a0fc795aae5
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Tue Sep 27 20:14:35 2011 +0200

    log_dest_driver_acquire_queue(): make sure all dest drivers have a name
    
    The persist_name for acquire_queue() identifies the destination driver that
    would like to keep its queue kept accross reloads.
    
    File destinations didn't keep their queue, effectively causing file drivers
    to lose their queue accross reloads. This went unnoticed as LogWriter does
    one last time to flush everything out to the disk when reloading, but
    still it is more important to keep the queue properly.
    
    Cc: syslog-ng-stable@balabit.hu
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 2ed7f92153aec5e4e666ea17dcd8d2232a8e76f9
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Tue Sep 27 20:12:24 2011 +0200

    log_dest_driver_release_queue(): unref the queue even if no name is present
    
    This patch fixes a memory leak for file destinations, in which we leak all
    LogQueue instances, possibly containing data, which can become quite large,
    especially if a lot of log files are opened/closed continously.
    
    Reported-By: Jakub Jankowski <shasta@toxcorp.com>
    Cc: <syslog-ng-stable@balabit.hu>
    Cc: Gergely Nagy <algernon@balabit.hu>
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 4ccdb8c7cbb784aa6231d14cfb006156b00ea77e
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Fri Sep 23 11:34:45 2011 +0200

    unit tests: whitespace changes in Makefile.am

commit 838f2594f0a762da6aaa35182b07c481361c4515
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Wed Sep 21 14:27:05 2011 +0200

    test_persist_state: don't run on HP-UX
    
    Our venerable HP-UX box always returns ENOMEM for this test.
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit ab3d7257bf980261fbee7fbe5349d73889437d75
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Wed Sep 21 14:24:35 2011 +0200

    test_thread_wakeup: fixed compile warning

commit 7ce8139eab2d64d0df38b8f76dcc0261e1cf3bdf
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Wed Sep 21 14:20:09 2011 +0200

    test_logqueue: added some more verbose logging on stderr
    
    Signed-off-by: Viktor Juhasz <jviktor@balabit.hu>
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 616c8065c72625c6bef67828c99ae892870f1e5a
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Wed Sep 21 14:19:28 2011 +0200

    test_logqueue: rename sum_lock
    
    This symbol seems to be defined as a macro on one of our platforms,
    rename to avoid the clash.
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit b41c7127e94a82f353625858f7d60dbcb659320e
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Wed Sep 21 14:18:19 2011 +0200

    test_loqueue: disable on AIX

commit 3193b729423d4c86e2f8e3227bcc3f247c750b56
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Wed Sep 21 14:17:53 2011 +0200

    test_logqueue: work on platforms without __thread

commit 6f89ffb969ec6d95fa812873cb29ca8f0314d0a2
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Wed Sep 21 14:15:21 2011 +0200

    test_filters/test_matcher: ref the payload in order to make sure that the borrowed value pointers remain valid

commit 42aba2f27e9a4126fefae377b37aeaf77c490d38
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Fri Sep 9 11:33:17 2011 +0200

    LogWriter: implement pad_size() for destination drivers

commit 6bb06e868d393d17ec0c5682b229b18d660d8553
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Fri Sep 23 11:35:28 2011 +0200

    LogWriter: initialize the SEQNUM value to 1 in the constructor
    
    This fixes an assumption in the unit tests, which assume that SEQNUM is
    1 initially, rather than 0.

commit c56b98aea98ccc9acd0147bd443a4a61b9abd156
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Wed Sep 21 14:11:33 2011 +0200

    mark locally generated messages as such
    
    The LF_LOCAL in LogMessage->flags indicates that the message was generated
    locally. This flag was not properly set and this patch fixes that
    issue.
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 6b62ae6610d659024787339c61335bcbf192120e
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Thu Sep 15 15:41:14 2011 +0200

    dbparser/test_radix: added negative testcases
    
    Signed-off-by: Marton Illes <marci@balabit.hu>
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 1916391debf28529c8df8e70d24c732166ac3bd0
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Thu Sep 15 15:40:51 2011 +0200

    test_patternize: fixed uninitialized variable
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 9312566a192af81a2ca38fc09e896c24ea6f70cd
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Wed Sep 14 16:14:58 2011 +0200

    stats: implement per-tag counters
    
    This patch adds counters at stats-level(3) that counts the number of
    messages having a specific tag.
    
    Signed-off-by: Viktor Juhasz <jviktor@balabit.hu>
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 55fcc5205f5fd4eff537411fbc6263ad1eb4975d
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Wed Sep 21 12:35:38 2011 +0200

    stats: invoke stats_lock/unlock for unregister operations too
    
    This patch also adds an assertion to all unregister paths.
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 2b38d4ea07f77db3c8a504253c689761c6b8f4c0
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Thu Sep 15 15:30:27 2011 +0200

    dbparser: fixed compilation warnings
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 9b06e4439f7dc670b5622cab9b221b06cf989d97
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sat Sep 17 12:54:57 2011 +0200

    dbparser: add error handling for improperly formatted QSTRING/ESTRING parsers
    
    Signed-off-by: Tamas Pal <folti@balabit.hu>
    Signed-off-by: Marton Illes <marci@balabit.hu>
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 6d078782bccc3220804b5a8e36edd18af6460be6
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sat Sep 17 13:25:16 2011 +0200

    pdbtool: initialize the config with the proper version number
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit c1f09562c67addbb8690e0070ba6dca48a168574
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sat Sep 17 13:24:56 2011 +0200

    pdbtool: added dictionary subcommand to display the dictionary used by a pdb file
    
    Signed-off-by: Peter Gyorko <gyorkop@balabit.hu>
    Signed-off-by: Viktor Juhasz <jviktor@balabit.hu>
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 9144a6d7d6142d091bc3c9190a166a622c509af7
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sat Sep 17 13:23:15 2011 +0200

    pdbtool: added --debug & --verbose switches
    
    Signed-off-by: Viktor Juhasz <jviktor@balabit.hu>
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit a2b7cd65811b1084127cb555c2670f2209c9046d
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sat Sep 17 13:22:54 2011 +0200

    pdbtool: fixed a possible NULL deref in pdbtool dump
    
    Signed-off-by: Tamas Pal <folti@balabit.hu>
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 1620c8d199d9f9877bdf90f53ad7c7cf52dc955d
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sat Sep 17 13:22:39 2011 +0200

    pdbtool: match should return rc == 0 if debugging was requested
    
    Signed-off-by: Tamas Pal <folti@balabit.hu>
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit e39b7e1182f24640a85575cb91592fd13e8b22be
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sat Sep 17 12:48:47 2011 +0200

    afsql: don't release the db_thread_mutex lock in afsql_dd_queue()
    
    Signed-off-by: Viktor Juhasz <jviktor@balabit.hu>
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 48eb1b8b7cd1e4d54b597648059375dcb73586c3
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Wed Sep 21 12:27:26 2011 +0200

    afsql: stat counter and queue identifier should include the table name too
    
    Signed-off-by: Viktor Juhasz <jviktor@balabit.hu>
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit edaeb404bf81af2529fb350292d4ef2ddc668117
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sat Sep 17 12:18:10 2011 +0200

    afsql: add proper synchronization to db_thread_terminate
    
    Signed-off-by: Viktor Juhasz <jviktor@balabit.hu>
    Signed-off-by: Attila Nagy <naat@balabit.hu>
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit e532050aa7c38ec3d9c7901f0368c562bfa69f3d
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Sat Sep 17 11:22:23 2011 +0200

    afsql: clarify g_time_val_add() invocation
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit a42237c6d85403535b42462bc3bcce9d3aacc972
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Fri Sep 16 14:44:51 2011 +0200

    afsocket: fixed uninitialized variable
    
    Signed-off-by: Tamas Pal <folti@balabit.hu>
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 8cbd4456d82c43f106b77fecfdd56c1dafc07590
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Fri Sep 16 14:43:19 2011 +0200

    afsocket: properly deinit/init AFSocketSourceConnection accross reload
    
    In order to have the LogReader/Writer instances deinited during reload
    we need to call deinit/init for AFSocketSourceConnections, which might be
    stored in the persist config structure. Earlier they were not deinitialized
    and that worked because syslog-ng wasn't multithreaded and reload happened
    synchonously.
    
    Signed-off-by: Viktor Juhasz <jviktor@balabit.hu>
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 9395c24eca74d2405d1bb7fe0fcbec65a368987c
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Fri Sep 16 10:15:02 2011 +0200

    configure.in: Glib sanity checks should be performed using the libs in GLIB_LIBS
    
    Signed-off-by: Tamas Pal <folti@balabit.hu>
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit c705c98ff8de36462ea725adb9b3200164418106
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Fri Sep 16 11:40:17 2011 +0200

    afsql: rename ugly retry-sql-inserts() option to retries()
    
    Both forms are accepted for now.
    
    Signed-off-by: Balazs Scheidler <bazsi@balabit.hu>

commit 0555c7c5dd86ca5af6ab9533ff5ba473269da4fa
Author: Balazs Scheidler <bazsi@balabit.hu>
Date:   Fri Sep 16 11:34:31 2011 +0200

    afsql: fixed the handling of the port() parameter
    
